2007-09-18  Daniel Steffen  <das@users.sourceforge.net>

	*** 8.4.16 TAGGED FOR RELEASE ***

	* changes: updates for 8.4.16 release.

2007-09-15  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (SunOS-5.1x): 	replace direct use of '/usr/ccs/bin/ld'
					in SHLIB_LD by 'cc' compiler driver.
	* unix/configure: autoconf-2.13

2007-09-11  Reinhard Max  <max@suse.de>

	* generic/tkImgGIF.c: Fixed a buffer overrun that got triggered by
	multi-frame interlaced GIFs that contain subsequent frames that
	are smaller than the first one.

	* tests/imgPhoto.test: Added a test for the above.

2007-09-11  Daniel Steffen  <das@users.sourceforge.net>

	* unix/configure.in:	backport of TK_INCLUDE_SPEC addition.
	* unix/tkConfig.sh.in:	[Bug 777203]
	* unix/configure: autoconf-2.13

2007-09-11  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/makefile.vc: Fix for AMD64 symbols target builds.
	* win/rules.vc:

2007-09-05  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/rc/tk_base.rc: Backported the BASE_NO_TK_ICON patch to assist in
	creating tclkits and/or basekits with corrent resources.

2007-09-04  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* tests/wm.test: -transparentcolor added to windows wm attributes tests

2007-08-27  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXDialog.c (Tk_ChooseColorObjCmd): correct setting of
	interp result [Bug 1782105]; fix -initialcolor overwriting last color
	selection; style cleanup.

2007-08-07  Daniel Steffen  <das@users.sourceforge.net>

	* unix/Makefile.in:	add support for compile flags specific to
				object files linked directly into executables.

	* unix/configure.in (Darwin): only use -seg1addr flag when prebinding;
	use -mdynamic-no-pic flag for object files linked directly into exes.

	* unix/configure: autoconf-2.13

2007-07-25  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXDialog.c (NavServicesGetFile): reset interp result on
	nav dialog cancel. [Bug 1743786]

2007-07-09  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWindowEvent.c (Tk_MacOSXIsAppInFront):	use process mgr
	* macosx/tkMacOSXMouseEvent.c:				to determine if
	app is in front instead of relying on activate/deactivate events (which
	may arrive after this info is needed, e.g. during window drag/click
	activation); replace other process mgr use to get this info with calls
	to Tk_MacOSXIsAppInFront().

	* macosx/tkMacOSXMouseEvent.c (TkMacOSXProcessMouseEvent): correct
	window click activation, titlebar click handling and background window
	dragging/growing in the presence of grabs or window-/app-modal windows;
	fix window click activation bringing all other app windows to front.

	* macosx/tkMacOSXDraw.c (TkPutImage): handle non-native XImage byte and
	bit orders; reverse bits via xBitReverseTable instead of InvertByte().

2007-07-04  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/tkMacOSXXStubs.c (DestroyImage): Fixed crash in release
	of image data for images coming from XGetImage, introduced
	2007-06-23. (das)

2007-07-02  Daniel Steffen  <das@users.sourceforge.net>

	* xlib/xgc.c (XCreateGC): correct black and white pixel values used to
	initialize GC foregrund and background fields.

	* macosx/tkMacOSXColor.c: add debug messages for unknown pixel values.

	*  macosx/tkMacOSXDraw.c (TkMacOSXRestoreDrawingContext): don't restore
	port state if it wasn't altered by TkMacOSXSetupDrawingContext().

2007-06-29  Daniel Steffen  <das@users.sourceforge.net>

	* xlib/ximage.c:		bitmaps created from the static .bmp
					arrays always have LSBFirst bit order.

	* macosx/tkMacOSXScrlbr.c: correct int <-> dobule conversion issues
	that could lead to Carbon getting confused about scrollbar thumb size.

	* macosx/tkMacOSXDraw.c (XCopyArea, XCopyPlane, TkPutImage) use
	TkMacOSX{Setup,Restore}DrawingContext() to setup/restore clip & colors.
	(TkMacOSXSetupDrawingContext, TkMacOSXRestoreDrawingContext): add save
	and restore of QD port clip region; factor out clip region code common
	to CG and QD branches; check for port and context validity; handle
	tkPictureIsOpen flag during QD port setup.
	(TkScrollWindow): remove unnecessary scroll region manipulation

	* macosx/tkMacOSXDraw.c:	remove second global QD temp region
	* macosx/tkMacOSXInt.h:		(no longer necessary) and rename
	* macosx/tkMacOSXRegion.c:	remaining global QD temp region.
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWindowEvent.c:

	* macosx/tkMacOSXDraw.c: 	make useCGDrawing variable MODULE_SCOPE
	* macosx/tkMacOSXFont.c: 	and sync formatting with HEAD.

	* macosx/tkMacOSXButton.c:	reduce reliance on current QD port
	* macosx/tkMacOSXColor.c:	setting and remove unnecessary
	* macosx/tkMacOSXDebug.c:	references to a drawable's QD port,
	* macosx/tkMacOSXDebug.h:	notably replace GetWindowFromPort(
	* macosx/tkMacOSXDialog.c:	TkMacOSXGetDrawablePort()) idiom by new
	* macosx/tkMacOSXDraw.c:	TkMacOSXDrawableWindow() and change
	* macosx/tkMacOSXKeyEvent.c:	TkMacOSXSetColorInPort() to take a port
	* macosx/tkMacOSXMenu.c:	argument.
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXScale.c:
	* macosx/tkMacOSXScrlbr.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c:

	* macosx/tkMacOSXInt.h:		  	factor out macros, declarations
	* macosx/tkMacOSXPrivate.h (new): 	and prototypes that are purely
	internal and private to the 'macosx' sources into a new internal header
	file that does _not_ get installed into Tk.framework/PrivateHeaders.

	* macosx/tkMacOSXButton.c: 		#include new tkMacOSXPrivate.h
	* macosx/tkMacOSXCarbonEvents.c:	instead of tkMacOSXInt.h.
	* macosx/tkMacOSXClipboard.c:
	* macosx/tkMacOSXColor.c:
	* macosx/tkMacOSXCursor.c:
	* macosx/tkMacOSXDebug.c:
	* macosx/tkMacOSXDialog.c:
	* macosx/tkMacOSXDraw.c:
	* macosx/tkMacOSXEntry.c:
	* macosx/tkMacOSXEvent.c:
	* macosx/tkMacOSXFont.c:
	* macosx/tkMacOSXHLEvents.c:
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXMenus.c:
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXNotify.c:
	* macosx/tkMacOSXRegion.c:
	* macosx/tkMacOSXScale.c:
	* macosx/tkMacOSXScrlbr.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c:
	* macosx/tkMacOSXXStubs.c:

2007-06-23  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkImgPhoto.c (ImgPhotoConfigureInstance, DisposeInstance):
	use XDestroyImage instead of XFree to destroy XImage; replace runtime
	endianness determination by compile-time check for WORDS_BIGENDIAN.

	* xlib/ximage.c (XCreateBitmapFromData): use XCreateImage and
	XDestroyImage instead of creating XImage structure manually.

	* macosx/tkMacOSXXStubs.c (XCreateImage, DestroyImage): correct XImage
	bytes_per_line/bitmap_pad calculations and endianness setting; free
	image data and XImage structure at destruction; formatting cleanup.

	* macosx/tkMacOSXDialog.c (NavServicesGetFile): disable app-modal
	sheet variant of nav dialog on OS versions where it causes problems.

2007-06-09  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinWm.c (WmIconphotoCmd): fix wm iconphoto RGBA issues.
	[Bug 1467997] (janssen)

	* win/tkWinMenu.c (TkWinHandleMenuEvent): improve handling to
	allow for unicode char menu indices and not use CharUpper on Tcl
	utf strings. [Bug 1734223]

2007-06-09  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXColor.c: fix issues with TK_{IF,ELSE,ENDIF} macros;
	* macosx/tkMacOSXDraw.c:  implement Jaguar equivalent of unavailable
	* macosx/tkMacOSXEntry.c: kHIToolboxVersion global; panic at startup
	* macosx/tkMacOSXEvent.c: if MAC_OS_X_VERSION_MIN_REQUIRED constraint
	* macosx/tkMacOSXInit.c:  is not satisfied.
	* macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXWm.c:

	* macosx/tkMacOSXDraw.c (XCopyArea, XCopyPlane, TkPutImage)
	(TkMacOSXSetupDrawingContext): factor out common code and standardize
	setup/restore of port, context and clipping; formatting cleanup.

	* macosx/tkMacOSXWindowEvent.c:	add error checking.
	* macosx/tkMacOSXMenu.c:	fix gcc3 warning.
	* macosx/tkMacOSXScrlbr.c:	fix testsuite crash.
	* macosx/tkMacOSXSubwindows.c:	formatting cleanup.
	* macosx/tkMacOSXRegion.c:	fix typos.
	* macosx/tkMacOSXScale.c:

2007-06-06  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXInt.h: use native debug message API when available.

	* macosx/tkMacOSXMouseEvent.c (GenerateMouseWheelEvent): enable
	processing of mousewheel events in background windows.

	* macosx/tkMacOSXScrlbr.c: modernize checks for active/front window.
	* macosx/tkMacOSXScale.c:
	* macosx/tkMacOSXWm.c:

	* macosx/tkMacOSXColor.c: factor out verbose #ifdef checks of
	* macosx/tkMacOSXDraw.c:  MAC_OS_X_VERSION_{MAX_ALLOWED,MIN_REQUIRED}
	* macosx/tkMacOSXEntry.c: and runtime checks of kHIToolboxVersion into
	* macosx/tkMacOSXEvent.c: new TK_{IF,ELSE,ENDIF}_MAC_OS_X macros.
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXWm.c:

	* macosx/tkMacOSXDraw.c:  factor out clip clearing in QD ports;
	* macosx/tkMacOSXEntry.c: formatting cleanup.

	* unix/configure.in (Darwin): link the Tk and Wish plists into their
	binaries in all cases; fix 64bit arch removal in fat 32&64bit builds. 

	* unix/tcl.m4 (Darwin): fix CF checks in fat 32&64bit builds. 
	* unix/configure: autoconf-2.13

2007-06-05  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/photo.n: Clarified the fact that base64 support for the -data
	option is not universal. [Bug 1731348] (matzek)

2007-06-04  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXMenu.c: add error checking; whitespace cleanup.

	* macosx/tkMacOSXDraw.c:	sync comment formatting with HEAD.
	* macosx/tkMacOSXEmbed.c:
	* macosx/tkMacOSXEntry.c:
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXKeyboard.c:
	* macosx/tkMacOSXMenus.c:
	* macosx/tkMacOSXSend.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c:
	* macosx/tkMacOSXXStubs.c:

2007-06-02  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXMenu.c (TkpPostMenu): ensure cascade menus display in
	posted menus that are not part of the menubar or attached to a
	menubutton (fixes bug reported on tcl-mac by Linus Nyberg).

2007-05-31  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWindowEvent.c (GenerateUpdateEvent): complete all
	pending idle-time redraws before newly posted Expose events are
	processed; add bounds of redrawn windows to update region to ensure all
	child windows overdrawn by parents are redrawn.

	* macosx/tkMacOSXWindowEvent.c:	centralize clip and window invalidation
	* macosx/tkMacOSXSubwindows.c: 	after location/size changes in the
	* macosx/tkMacOSXWm.c:		BoundsChanged carbon event handler;
	correct/add window invalidation after window attribute changes.

	* macosx/tkMacOSXSubwindows.c (XResizeWindow, XMoveResizeWindow,
	XMoveWindow): factor out common code dealing with embedded and
	non-toplevel windows; remove unnecessary clip and window invalidation.

	* macosx/tkMacOSXButton.c (TkpDisplayButton): move clip setup closer to
	native button drawing calls.

	* macosx/tkMacOSXWm.c (TkMacOSXIsWindowZoomed, TkMacOSXZoomToplevel):
	correct handling of gridded windows in max size calculations.

	* macosx/tkMacOSXEvent.c (TkMacOSXFlushWindows): use HIWindowFlush API
	when available.

	* macosx/tkMacOSXColor.c:	cleanup whitespace and formatting.
	* macosx/tkMacOSXDraw.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWm.c:

	* generic/tkFont.c:	#ifdef out debug msg printing to stderr.

2007-05-30  Don Porter  <dgp@users.sourceforge.net>

	* generic/tk.h: Correct placement of #include <tcl.h> [Bug 1723812].

	* README:		Bump version number to 8.4.16
	* generic/tk.h:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf-2.13
	* win/configure:

2007-05-30  Daniel Steffen  <das@users.sourceforge.net>

	* library/bgerror.tcl:	standardize dialog option & button size
	* library/dialog.tcl:	modifications done when running on on Aqua.
	* library/msgbox.tcl:

	* library/demos/button.tcl: set button highlightbackground on Aqua.

	* generic/tkFileFilter.c (AddClause): fix warning.

	* macosx/tkMacOSXMenu.c (DrawMenuSeparator): use DrawingContext API.

	* macosx/tkMacOSXWindowEvent.c (ClearPort): clip to updateRgn.

	* macosx/tkMacOSXDebug.c:	factor out debug region flashing.
	* macosx/tkMacOSXDebug.h:
	* macosx/tkMacOSXDraw.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWindowEvent.c:

	* macosx/tkMacOSXEvent.c:	cleanup whitespace and formatting.
	* macosx/tkMacOSXFont.c:
	* macosx/tkMacOSXRegion.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c:
	* macosx/tkMacOSXXStubs.c:
	* xlib/xgc.c:

2007-05-25  Don Porter  <dgp@users.sourceforge.net>

	*** 8.4.15 TAGGED FOR RELEASE ***

	* unix/README:	Updates and typo corrections.  [Bug 1724841]

2007-05-16  Don Porter  <dgp@users.sourceforge.net>

	* tests/bind.test:	Make test suite more SCIM-tolerant [Bug 1609316]

2007-05-15  Don Porter  <dgp@users.sourceforge.net>

	* changes: updates for 8.4.15 release.

	* generic/tkGrid.c: Stop crash due to list intrep shimmer [Bug 1677608]

2007-05-09  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkFileFilter.c (AddClause): OSType endianness fixes.

	* library/palette.tcl (tk::RecolorTree): handle color options with
	empty value, fixes error due to emtpy -selectforeground (reported on
	tcl-mac by Russel E. Owen).

	* macosx/tkMacOSXWindowEvent.c:	ensure window is brought to the front
	* macosx/tkMacOSXMouseEvent.c:	at the start of a window drag (except
	* macosx/tkMacOSXInt.h:		when cmd key is down); formatting and
					whitespace fixes.

	* macosx/tkMacOSXDialog.c (Tk_GetSaveFileObjCmd): add -filetypes option
	processing.

	* macosx/tkMacOSXEmbed.c (TkpMakeWindow, TkpUseWindow): fix sending of
	Visibility event for embedded windows (fixes frame-3.9 hang).

	* macosx/tkMacOSXScrlbr.c (ScrollbarBindProc):		fix testsuite
	* macosx/tkMacOSXSubwindows.c (TkMacOSXUpdateClipRgn):	crashes by
	adding sanity checks.

	* macosx/tkMacOSXButton.c: fix debug msg typo.

2007-04-29  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkCanvas.c:	allow -selectforeground option to be None; add
	* generic/tkCanvText.c:	fallback to fgColor when selFgColor is None
	* generic/tkEntry.c:	(new default on aqua to match native L&F).
	* generic/tkListbox.c:
	* generic/tkText.c:

	* generic/tkCanvas.c:	   add support for bypassing all of Tk's double
	* generic/tkEntry.c:	   buffered drawing into intermediate pixmaps
	* generic/tkFrame.c:	   (via TK_NO_DOUBLE_BUFFERING #define), it is
	* generic/tkListbox.c:	   unnecessary & wasteful on aqua where all
	* generic/tkPanedWindow.c: drawing is already double-buffered by the
	* generic/tkTextDisp.c:	   window server. (Use of this on other
	* macosx/tkMacOSXPort.h:   platforms would only require implementation
	* unix/tkUnixScale.c:	   of TkpClipDrawableToRect()).

	* library/bgerror.tcl:	on aqua, use moveable alert resp. modal dialog
	* library/dialog.tcl:	window class and corresponding system
				background pattern; fix button padding.

	* library/tearoff.tcl:	correct aqua menu bar height; vertically offset
	* library/tk.tcl:	aqua tearoff floating window to match menu.

	* library/demos/menu.tcl:   on aqua, use custom MDEF and tearoffs;
	* library/demos/menubu.tcl: correct menubutton toplevel name.

	* library/demos/puzzle.tcl: fix button size & padding for aqua.

	* macosx/tkMacOSXCarbonEvents.c: add window event target carbon event
	* macosx/tkMacOSXEvent.c:	 handler for all kEventClassWindow and
	* macosx/tkMacOSXEvent.h:	 kEventClassMouse events; move all
	* macosx/tkMacOSXNotify.c:	 remaining events except for
	* macosx/tkMacOSXWindowEvent.c:	 kEventClassKeyboard from dispatcher to
	application event handler; pass event handler callRef downstream; fix
	debug event tracing; process all tcl event types in carbon event timer;
	delay carbon event timer first fire; add TkMacOSXTrackingLoop() to mark
	enter/exit of event tracking loop during which all tcl events but only
	carbon update events should be processed by the timer (replaces various
	calls to Tcl_SetServiceMode()); rename TkMacOSXReceiveAndProcessEvent()
	to TkMacOSXReceiveAndDispatchEvent(), move it from tkMacOSXEvent.c to
	tkMacOSXCarbonEvents.c and modify it to dequeue only update events
	during a tracking loop; add TkMacOSXRunTclEventLoop() to standardize
	the various ways in use to run the tcl event loop; add handling of
	kEventClassAppearance events (for ScrollBarVariantChanged event).

	* macosx/tkMacOSXDialog.c:	use new TkMacOSXTrackingLoop() around
	* macosx/tkMacOSXEvent.c:	blocking API that puts up modal dialogs
	* macosx/tkMacOSXMenu.c:	or when entering/exiting menu/control
	* macosx/tkMacOSXMouseEvent.c:	tracking, window dragging and other
	* macosx/tkMacOSXScale.c:	mouse tracking loops.
	* macosx/tkMacOSXScrlbr.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c:

	* macosx/tkMacOSXDialog.c:	use new TkMacOSXRunTclEventLoop()
	* macosx/tkMacOSXScale.c:	instead of Tcl_DoOneEvent(),
	* macosx/tkMacOSXScrlbr.c:	Tcl_ServiceAll(), TclServiceIdle()
	* macosx/tkMacOSXWindowEvent.c:	and Tcl_GlobalEval("update idletasks").

	* macosx/tkMacOSXColor.c: make available as Tk system colors all
	* macosx/tkMacOSXPort.h:  appearance manager brushes, text colors and
	backgrounds with new and legacy names, as well as the fully transparent
	color "systemTransparent"; add TkMacOSXSetColorIn{Port,Context}() to
	directly set an X pixel color value in the current QD port resp. the
	given CG context without requiring passage through rgb representation
	(lossy for most system colors); modernize/remove Classic-era code;
	replace crufty strcmp() elseifs by Tcl_GetIndexFromObjStruct().

	* macosx/tkMacOSXButton.c:	use new TkMacOSXSetColorInPort()
	* macosx/tkMacOSXDraw.c:	instead of setting rgb color directly
	* macosx/tkMacOSXMenubutton.c:	to allow for non-rgb system colors.

	* macosx/tkMacOSXCursor.c: implement "none" cursor as on other
	platforms [Patch 1615427]; add all missing appearance manager cursors.

	* macosx/tkMacOSXDefault.h: set SELECT_FG_COLORs to None to match aqua
	L&F; use standard system color names; use new 'menu' system font;
	correct default scrollbar width.

	* macosx/tkMacOSXDraw.c: 	standardize initialization, use and
	* macosx/tkMacOSXInt.h: 	emptying of various static temp rgns
	* macosx/tkMacOSXRegion.c:	onto two global RgnHandles; in debug
	* macosx/tkMacOSXSubwindows.c:	builds, verify emptiness of these temp
	* macosx/tkMacOSXWindowEvent.c:	rgns before use.

	* macosx/tkMacOSXDraw.c: add TkMacOSX{Setup,Restore}DrawingContext() to
	* macosx/tkMacOSXInt.h:  abstract common setup & teardown of drawing
	environment (for both CG and QD); save/restore QD theme drawing state;
	handle GC clip region; add TkpClipDrawableToRect() to allow clipped
	drawing into drawable regardless of GC used; use new system color
	"systemWindowHeaderBackground" to setup background in themed toplevels;
	correct implementation of TkMacOSXMakeStippleMap().

	* macosx/tkMacOSXEntry.c: use new TkMacOSXSetupDrawingContext() and
	* macosx/tkMacOSXFont.c:  TkMacOSXRestoreDrawingContext() instead of
	various setup/teardown procs like TkMacOSX{SetUp,Release}CGContext(),
	TkMacOSXQuarz{Start,End}Draw(), TkMacOSXSetUpGraphicsPort() etc.

	* macosx/tkMacOSXEmbed.c: add CG context and drawable clip rgn fields
	* macosx/tkMacOSXInt.h:   to MacDrawable struct.
	* macosx/tkMacOSXSubwindows.c:

	* macosx/tkMacOSXDialog.c: make -parent option of tk_getOpenFile et al.
	use the sheet version of NavServices dialogs; ensure native parent win
	exists before using StandardSheet API for tk_messageBox [Bug 1677611];
	force sheets to behave like app-modal dialogs via WindowModality() API;
	use more modern ColorPicker API.

	* macosx/tkAboutDlg.r: use themed movable modal dialog, fix (c) year.

	* macosx/tkMacOSXEntry.c:  take xOff/yOff of MacDrawable into account
	when computing locations/bounds to ensure correct posititioning when
	not drawing into intermediate pixmap.

	* macosx/tkMacOSXFont.c: use appearance manager API to map system font
	* macosx/tkMacOSXFont.h: names to TkFonts; add "menu" system font for
	menu item text drawing from MDEF; disable broken QD stippling.

	* macosx/tkMacOSXMenu.c:		large-scale rewrite of custom
	* macosx/tkMacOSXMenu.r (removed):	MDEF and related code that
	* unix/Makefile.in:			restores many longtime-MIA
	features to working order (e.g. images, custom colors & fonts in menus
	etc); implement compound menu items; use Appearance Mgr and ThemeText
	APIs to mimic native MDEF as closely as possible when default "menu"
	system font is used; remove now obsolete SICN drawing code and
	resources.

	* macosx/tkMacOSXCarbonEvents.c: handle additional menu carbon events
	* macosx/tkMacOSXEvent.c:	 in order to support <<MenuSelect>> in
	* macosx/tkMacOSXMenu.c:	 the menubar and in menus that are not
	* macosx/tkMacOSXMenus.c:	 using the custom MDEF [Bug 1620826];
	fix early and missing clearing of current Tk active menu entry; fix
	extraneous sending of <<MenuSelect>> during active menu entry clearing.

	* macosx/tkMacOSXMouseEvent.c: add support for async window dragging by
	the window server; set the corresponding window attribute by default.

	* macosx/tkMacOSXMouseEvent.c: rationalized handling order of
	non-mousedown events; add TkMacOSXModifierState() to retrieve the
	current key modifiers in carbon format.

	* macosx/tkMacOSXScrlbr.c: use appearance manager API to retrieve
	scrollbar component metrics; add awareness of multiple possibilites for
	scrollbar arrow position in aqua and handle user changes to arrow
	position pref; handle difference in metrics of small & large scrollbar
	variants; handle aqua "jump to here" scrollbar behaviour; correct
	computation of scroll view size and position; enforce min scrollbar
	height to avoid scrollbar component overlap; erase scrollbar area
	outside of standard width; remove broken auto-adjust code; account for
	window class when leaving space for grow box; remove code to manually
	draw grow box; use modern API for thumb scroll proc; replace
	HiliteControl() by modern API; replace control mgr constants with
	appearance mgr equivalents.

	* macosx/tkMacOSXSubwindows.c: use SetWindowBounds() API instead of
	SizeWindow(); invalidate clip regions after X{Map,Unmap}Window as fix
	for [Bug 940117] made them dependent on mapping state; remove unneeded
	calls to TkMacOSXInvalClipRgns() and unnecessary setting of QD port;
	use native-endian pixmap on intel; remove obsolete pixmap pix locking.

	* macosx/tkMacOSXWindowEvent.c: handle only the first of a batch of
	kEventAppAvailableWindowBoundsChanged events sent per transaction;
	handle kEventWindowBoundsChanged event to support live window resizing
	and centralized sending of location/size changed ConfigureNotify
	events; ensure HIGrowBox is redrawn after bounds change; constrain
	window after dragging to ensure titlebar is not inacessible
	offscreen or under dock/menubar; handle kEventWindowGetRegion and
	kEventWindowDrawContent for transparent windows to mark resp. paint
	content region as transparent; handle kEventWindowConstrain for
	fullscreen windows to ensure bounds match new screen size; enter/exit
	fullscreen UIMode upon activation/deactivation of fullscreen window.

	* macosx/tkMacOSXWm.c: use live-resize and async-drag carbon window
	* macosx/tkMacOSXWm.h: attributes for toplevels by default; implement
	new [wm attributes] -topmost, -transparent and -fullscreen; refactor
	WmAttributesCmd() parallelling the tkUnixWm.c implementation, use thus
	factored proc to set proxy icon from [wm iconbitmap]; dynamically
	determine default values for toplevel min and max sizes (similar to
	tkWinWm.c impl): min sizes depend on window class & attributes to
	ensure visibility of all titlebar widgets and grow box, max sizes
	depend on maximal window bounds for all active displays; factor out
	code that puts into effect changes to master or override_redirect; use
	RepositionWindow() API to determine staggered initial window bounds;
	correct resize limit calculations, handle gridding and use modern
	resize API in TkMacOSXGrowToplevel(); remove sending of ConfigureNotify
	after resize or zoom (now handled by BoundsChanged handler); correct
	composite carbon window attribute handling, remove currently unusable
	attributes and add new attributes in [tk::unsupported::MacWindowStyle];
	ensure validity of window class and attributes before use; apply
	changes to window class when handling carbon window attribute changes
	(if HIWindowChangeClass() API available); add debug build warning
	message when deprecated window style is used instead of window class;
	use transparent HIGrowBox for resizable windows; avoid unnecessary
	calls to window structure width API; use tcl time API in TkpGetMS();
	add TkMacOSXEnterExitFullscreen() to enter/exit UIMode with dock and
	menubar hidden; restrict wmTracing output to debug builds; remove
	unneeded calls to TkMacOSXInvalClipRgns() and unnecessary setting of QD
	port; workaround GetWindowStructureWidths() Carbon bug (bogus results
	for never-mapped floating windows).

	* macosx/tkMacOSXXStubs.c (TkMacOSXDisplayChanged): add maximal window
	bounds field to Screen record (in ext_data), computed as the union of
	available window positioning bounds of all graphics devices (displays).

	* macosx/tkMacOSXBitmap.c: fix macRoman encoding leak.
	* macosx/tkMacOSXCursor.c:
	
	* macosx/tkMacOSXDebug.c (TkMacOSXCarbonEventToAscii): use static
	* macosx/tkMacOSXDebug.h: buffer to simplify callers; const fixes.

	* macosx/tkMacOSXBitmap.c: use more efficient QDSwapPort() instead of
	* macosx/tkMacOSXButton.c: GetPort()/SetPort()/GetGWorld()/SetGWorld().
	* macosx/tkMacOSXDraw.c:
	* macosx/tkMacOSXFont.c:
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXScale.c:
	* macosx/tkMacOSXScrlbr.c:
	* macosx/tkMacOSXXStubs.c:

	* macosx/tkMacOSXColor.c: use kHIToolboxVersionNumber for runtime OS
	* macosx/tkMacOSXEntry.c: version check rather than Gestalt() etc.
	* macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXWm.c:

	* macosx/tkMacOSXDraw.c: remove obsolete and now incorrect
	* macosx/tkMacOSXInt.h:  tkMenuCascadeRgn clipping code.
	* macosx/tkMacOSXMenu.c:

	* macosx/tkMacOSXHLEvents.c: replace Tcl_GlobalEval() resp. Tcl_Eval()
	* macosx/tkMacOSXScrlbr.c:   by Tcl_EvalEx().
	* macosx/tkMacOSXInit.c:

	* macosx/tkMacOSXInit.c (TkpInit): reorder initialization steps.

	* macosx/tkMacOSXKeyEvent.c: remove pre-10.2 support.

	* macosx/tkMacOSXMenus.c: remove now useless call to
	TkMacOSXHandleTearoffMenu(); use \x.. quoting for non-latin1 macroman
	literar chars to allow file to be edited as utf-8.

	* macosx/tkMacOSXScale.c: replace TrackControl() by modern
	* macosx/tkMacOSXScrlbr.c: HandleControlClick() API (using new
	TkMacOSXModifierState()).
	
	* macosx/tkMacOSXInt.h:		move all constant #defines needed to
	* macosx/tkMacOSXColor.c:	support building on older OS X releases
	* macosx/tkMacOSXEvent.h:	to a central location in tkMacOSXInt.h.
	* macosx/tkMacOSXFont.c:
	* macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXMenus.c:
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXWm.c:

	* macosx/tkMacOSXInt.h:		 add ChkErr() macro to factor out
	* macosx/tkMacOSXButton.c:	 Carbon OSStatus return value checking
	* macosx/tkMacOSXCarbonEvents.c: and TkMacOSXDbgMsg() macro to factour
	* macosx/tkMacOSXClipboard.c:	 out debug message output; use these
	* macosx/tkMacOSXColor.c:	 macros to replace #ifdef TK_MAC_DEBUG
	* macosx/tkMacOSXCursor.c:	 blocks & direct printing to stderr,
	* macosx/tkMacOSXDebug.c:	 and to do additional OSStatus return
	* macosx/tkMacOSXDialog.c:	 checking, and to standardize OSStatus
	* macosx/tkMacOSXDraw.c:	 usage.
	* macosx/tkMacOSXEntry.c:
	* macosx/tkMacOSXEvent.c:
	* macosx/tkMacOSXFont.c:
	* macosx/tkMacOSXHLEvents.c:
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXMenus.c:
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXScrlbr.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c:
	* macosx/tkMacOSXXStubs.c:

	* macosx/tkMacOSXSend.c:	remove duplicate/unused declarations.
	* macosx/tkMacOSXXStubs.c:

	* macosx/tkMacOSXDebug.c:	const fixes.
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXTest.c:
	* macosx/tkMacOSXWm.c:
	* macosx/tkMacOSXXStubs.c:

	* macosx/Wish-Info.plist.in: add tcl document extensions/mime types and
	LSMinimumSystemVersion, LSRequiresCarbon & NSAppleScriptEnabled keys.

	* macosx/tkMacOSXAETE.r:	fix whitespace.
	* macosx/tkMacOSXConfig.c:
	* macosx/tkMacOSXCursors.r:
	* macosx/tkMacOSXKeyboard.c:
	* macosx/tkMacOSXSend.c:
	* macosx/tkMacOSXXCursors.r:
	* macosx/README:

	* macosx/Makefile:		fix/add copyright and license refs.
	* macosx/Tk-Info.plist.in:
	* macosx/Wish-Info.plist.in:
	* macosx/tkMacOSX.h:

	* unix/Makefile.in (dist): copy license.terms to dist macosx dir.
	* unix/configure.in: install license.terms into Tk.framework; fix tk
	debug build detection.
	* unix/configure: autoconf-2.13

	* doc/colors.n:		document new Mac OS X system colors.
	* doc/cursors.n:	document new Mac OS X native cursors.
	* doc/font.n:		document new Mac OS X 'menu' system font.
	* doc/wm.n:		document new Mac OS X [wm attributes].

2007-03-07  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkMain.c (Tk_MainEx): replicate macosx-specific code from
	TkpInit() that ensures the console window appears when wish is started
	from the OS X Finder (i.e. with stdin == /dev/null), jeffh's 2006-11-24
	change rendered the corresponding code in TkpInit() ineffective in wish
	because Tk_MainEx() sets tcl_interactive before calling TkpInit().

	* macosx/tkMacOSXDebug.c (TkMacOSXGetNamedDebugSymbol): add fix for
	libraries loaded with a DYLD_IMAGE_SUFFIX.

	* unix/tcl.m4 (Darwin): s/CFLAGS/CPPFLAGS/ in macosx-version-min check.
	* unix/configure: autoconf-2.13

2007-02-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tcl.m4: use SHLIB_SUFFIX=".so" on HP-UX ia64 arch.
	* unix/configure: autoconf-2.13

	* library/tkfbox.tcl (::tk::IconList_Goto): avoid goto issues in
	empty dirs.  [Bug 1662959]

2007-02-04  Daniel Steffen  <das@users.sourceforge.net>

	* unix/configure.in: add caching to -pipe check.
	* unix/configure: autoconf-2.13

2007-01-30  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/Makefile.in (install-private-headers): added target

2007-01-25  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4:       integrate CPPFLAGS into CFLAGS as late as possible
	* unix/configure.in: and move (rather than duplicate) -isysroot flags
	from CFLAGS to CPPFLAGS to avoid errors about multiple -isysroot flags
	from some older gcc builds.

	* unix/configure: autoconf-2.13

2006-01-19  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4: ensure CPPFLAGS env var is used when set. [Bug 1586861]
	(Darwin): add -isysroot and -mmacosx-version-min flags to CPPFLAGS when
	present in CFLAGS to avoid discrepancies between what headers configure
	sees during preprocessing tests and compiling tests.

	* unix/configure: autoconf-2.13

2006-12-22  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* unix/tkUnixEvent.c (TkUnixDoOneXEvent): Made correct on AMD64 and
	other similar 64-bit systems where fd_mask is not 'unsigned int' in
	effect. [Bug 1522467]

	* library/msgs/es_ES.msg (removed):
	* library/msgs/es.msg: Fixed translation fault that was present in all
	Spanish-speaking locales. [Bug 1111213]

2006-12-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinButton.c (TkpDisplayButton): lint init. [Bug 1618604]

2006-12-19  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (Darwin): --enable-64bit: verify linking with 64bit -arch
	flag succeeds before enabling 64bit build.
	* unix/configure: autoconf-2.13

2006-12-04  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkListbox.c (ConfigureListboxItem): ListboxWorldChanged
	not needed - just call EventuallyRedrawRange. [Bug 1608046] (rezic)

2006-12-01  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/wm.n, tests/winWm.test:
	* win/tkWinWm.c: add -transparentcolor attribute for Windows.

2006-11-30  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXDialog.c (Tk_MessageBoxObjCmd): fix inability to use
	buttons with standard Escape key binding as -default button (reported
	on tcl-mac by Hans-Christoph Steiner).

2006-11-26  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (Linux): --enable-64bit support.	[Patch 1597389]
	* unix/configure: autoconf-2.13			[Bug 1230558]

2006-11-24  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/tkMacOSXInit.c (TkpInit): only set tcl_interactive 1 if
	it isn't already defined.  Allows embedders to set it to 0 to
	prevent the console appearing on OS X. [Bug 1487701]

	* unix/tkUnixMenu.c (DrawMenuUnderline): bound Tcl_UtfAtIndex usage
	* tests/menu.test (menu-36.1): [Bug 1599877]

2006-11-23  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinMenu.c (TkWinHandleMenuEvent, DrawMenuUnderline):
	handle unichar underlining correctly and safely. [Bug 1599877]

2006-11-02  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWindowEvent.c (GenerateUpdateEvent): fix handling of
	Carbon Update events: the QuickDraw window update region was being
	ignored and all child TkWindows were sent an Expose XEvent even when
	they did not need to be redrawn. [Patch 1589226]

2006-11-01  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXDebug.c: add TkMacOSX prefix to leftover macosx-private
	* macosx/tkMacOSXDebug.h: global symbols without Tk prefix; ifdef out
	* macosx/tkMacOSXEmbed.c: currently unused debug procs.
	* macosx/tkMacOSXEvent.c:
	* macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXCarbonEvents.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWm.c:

2006-10-31  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* rules.vc: Fix bug #1582769 build with VC2003 and correct i386 arch.

2006-10-23  Don Porter  <dgp@users.sourceforge.net>

	* README:		Bump version number to 8.4.15
	* generic/tk.h:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf-2.13
	* win/configure:

2006-10-18  Pat Thoyts  <patthoyts@users.sourceforge.net>

	*** 8.4.14 TAGGED FOR RELEASE ***

	* win/nmakehlp.c: Ensure builds with VC6 without Platform SDK.
	* win/rules.vc:   Pickup MACHINE from environment.

2006-10-17  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkPanedWindow.c:	Cleaned up some code flagged by a
	* generic/tkText.c:		`make checkexports` test.
	* generic/tkText.h
	* generic/tkTextTag.c:

2006-10-16  Daniel Steffen  <das@users.sourceforge.net>

	* changes: updates for 8.4.14 release.

	* macosx/tkMacOSXDraw.c: fix numerous issues in CG and QD drawing procs
	so that they now match X11 drawing much more closely [Bug 1558051];
	use Tiger ellipse drawing API when available; fix comments & whitespace.

	* macosx/tkMacOSXInit.c: set default linewidth limit for CG
	antialiasing to 0 as thin horizontal/vertical lines look good now.
	* macosx/README: document CG antialiasing limit changes.

	* generic/tkCanvLine.c (ConfigureLine):     on TkAqua, pass outline
	* generic/tkCanvPoly.c (ConfigurePolygon):  linewidth in gc even for
	* generic/tkRectOval.c (ConfigureRectOval): fills (as it controls AA).

	* macosx/Makefile: don't redo prebinding of non-prebound binaires.

2006-10-10  Don Porter  <dgp@users.sourceforge.net>

	* changes:		changes updated for 8.4.14 release.

2006-10-05  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tkUnixFont.c (Ucs2beToUtfProc, UtfToUcs2beProc):
	(TkpFontPkgInit, encodingAliases): Correct alignment issues in
	encoding conversion.  Call ucs-2be "unicode" on big-endian
	systems. [Bug 1122671]

2006-09-27  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/makefile.vc:  Support MSVC8 and AMD64 target. Also try using
	* win/rules.vc:     sed to generate the manifest (cross-compile cannot
	* win/nmakehlp.c:   execute tclsh). If no sed, use the tclsh exe.

2006-09-25  Andreas Kupries  <andreask@activestate.com>

	* generic/tkConsole.c: Complete reversal of the changes of Sep 22.
	* generic/tkMain.c:    For compat reason the Tcl core will not change
	* generic/tkWindow.c:  the registered version to include the patchlevel,
	* library/tk.tcl:      making the changes to Tk unnecessary.
	* unix/configure:
	* unix/Makefile.in:
	* unix/tcl.m4:
	* win/configure:
	* win/Makefile.in:
	* win/makefile.vc:
	* win/rules.vc:
	* win/tcl.m4:

2006-09-22  Andreas Kupries  <andreask@activestate.com>

	* generic/tkConsole.c: TIP #268 update regarding registered package
	* generic/tkMain.c:    version, now using full patchlevel instead of
	* generic/tkWindow.c:  major.minor
	* library/tk.tcl:
	* unix/configure:
	* unix/Makefile.in:
	* unix/tcl.m4:
	* win/configure:
	* win/Makefile.in:
	* win/makefile.vc:
	* win/rules.vc:
	* win/tcl.m4:

2006-09-22  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkImgBmap.c (ImgBmapPostscript):  Use NULL instead of 0 as
	end-of-strings marker to Tcl_AppendResult; the difference matters on
	64-bit machines. [Bug 1562528]

2006-09-20  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinMenu.c (TkpPostMenu): disable menu animation in menus
	with images to avoid clipping bug.  [Bug 1329198]

2006-09-11  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWm.c (TkMacOSXMakeRealWindowExist): revert part of
	2006-05-16 change that had set overrideredirect windows to not become
	activated by the window manager, as this prevented interaction with
	native widgets in such windows [Bug 1472624]; apply changes to carbon
	window attributes even if native window has already been created.

	* macosx/tkMacOSXKeyEvent.c (TkMacOSXProcessKeyboardEvent): fix app
	* macosx/tkMacOSXMenu.c (DrawMenuBarWhenIdle): menu item key shortcuts
	* macosx/tkMacOSXInt.h: when custom ".apple" menu is installed.

	* library/demos/widget: on TkAqua, don't install file menu with single
	quit menu item, as the application menu already has a quit item.

	* macosx/tkMacOSXColor.c: fix building on Mac OS X 10.2.

2006-09-10  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXColor.c (TkSetMacColor, TkpGetColor): use AppearanceMgr
	* macosx/tkMacOSXDefault.h: to retrieve platform std colors for text
	* macosx/tkMacOSXPort.h:    selections, add "systemHighlightSecondary"
	color name for standard color of inactive selections.

	* library/text.tcl (aqua): change focus bindings to implement platform
	standard look for inactive text selections using this new color.

	* generic/tkTextBTree.c (TkTextIsElided): on TkAqua, don't show text
	* generic/tkTextDisp.c (GetStyle):        selection when text widget
	* generic/tkText.c (TextEventProc):       is in disabled state.

	* generic/tkEntry.c (DisplayEntry): change default TkAqua selection
	* macosx/tkMacOSXDefault.h:         relief to "flat" (platform std).

	* generic/tkText.c (Tk_TextCmd): fix bug leading to default text
	selection relief string DEF_TEXT_SELECT_RELIEF being ignored.

	* macosx/tkMacOSXMouseEvent.c (TkMacOSXProcessMouseEvent): allow mouse
	event delivery to background windows with kWindowNoActivatesAttribute
	(e.g. overrideredirect windows), as these never come to the foreground
	they would never receive any mouse events otherwise. [Bug 1472624]

	* macosx/tkMacOSXWindowEvent.c (TkMacOSXGenerateFocusEvent): do not
	send focus events to any windows with kWindowNoActivatesAttribute.

	* macosx/tkMacOSXXStubs.c (XQueryColor, XQueryColors): implement basic
	XColor computation from pixel values, enough to make tkImg's window.c
	happy, fixes img::window failures reported on tcl-mac.

	* macosx/tkMacOSXMenu.c (DrawMenuEntryLabel): fix leak. [Bug 1554672]

	* macosx/Makefile: workaround bug in 'cp -pRH' on Darwin 6 and earlier,
	fixes 'make embedded' failure reported on tcl-mac; fix error from 'make
	deploy' with same build tree as previous 'make embedded'.

	* macosx/tkMacOSXEntry.c (TkpDrawEntryBorderAndFocus): fix typo.

	* unix/tcl.m4: sync with tcl/unix/tcl.m4.

2006-09-07  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkWindow.c: add #include "tclInt.h" now required due to use
	of tcl internal Tcl_CreateNamespace() in previous commit.

2006-09-06  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkEntry.c:     move hard-coded ALWAYS_SHOW_SELECTION
	* generic/tkInt.h:       control of entry/text selection display
	* generic/tkText.c:      based on focus to the Tcl level,
	* generic/tkTextBTree.c: controlled by ::tk::AlwaysShowSelection
	* generic/tkTextDisp.c:  (boolean, private).  [Bug 1553691]
	* generic/tkWindow.c:
	* library/tk.tcl
	* unix/tkUnixPort.h:

	* generic/tkText.c (DeleteChars): backport of 8.5 text delete
	speedup that removes tags from deleted area first. [Bug 1456342]

2006-08-30  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinKey.c: Add WM_UNICHAR window message support (used by
	* win/tkWinX.c:   virtual keyboard apps). [Bug 1518677] (petasis)

2006-08-24  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXScrlbr.c (UpdateControlValues): set native scrollbar
	control bounds only once all size adjustments have been computed.
	Fixes issue with grow icon obscuring scrollbar reported on tcl-mac.

2006-08-21  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXCarbonEvents.c (CarbonTimerProc): avoid starving main
	event loop: limit the number of tcl events processed per invocation.
	Fixes bug reported on tcl-mac by Kevan Hashemi.

2006-08-18  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (Darwin): add support for --enable-64bit on x86_64, for
	universal builds including x86_64, for 64-bit CoreFoundation on Leopard
	and for use of -mmacosx-version-min instead of MACOSX_DEPLOYMENT_TARGET.
	* unix/configure.in (Darwin): remove 64-bit arch flags from CFLAGS for
	combined 32-bit and 64-bit universal builds, as neither TkAqua nor TkX11
	can be built for 64-bit at present.
	* unix/configure: autoconf-2.13

	* macosx/README: updates for x86_64 support in Tcl.

	* macosx/tkMacOSXInit.c (TkpInit): when available, use public
	TransformProcessType() API instead of CPSEnableForegroundOperation() SPI
	to notify the window server that we are a GUI application.

	* macosx/tkMacOSXWm.c (WmAttrGetTitlePath): use HIWindow API on >=Tiger.

	* macosx/tkMacOSXMouseEvent.c (GenerateToolbarButtonEvent):
	* macosx/tkMacOSXMenus.c (GenerateEditEvent):
	* macosx/tkMacOSXMenu.c (MenuSelectEvent): bzero XVirtualEvent structure
	before use to ensure all fields are initialized. [Bug 1542205]

2006-08-16  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/tkMacOSXWm.c (WmAttributesCmd): correct OS X result for
	[wm attributes $top].

2006-07-25  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXKeyEvent.c (TkMacOSXProcessKeyboardEvent): handle key
	shortcut for kHICommandQuit in the same way as other application menu
	item key shortcuts. [Bug 1516950]

2006-07-24  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWm.c (TkWmMapWindow): fix incorrect values of wmInfo
	parentWidth/Height for toplevels by recalculating them once the window
	is mapped (i.e once the window&structure sizes are known). [Bug 1358663]
	(ParseGeometry): sync with ParseGeometry in tkUnixWm.c/tkWinWm.c.

2006-07-21  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkBind.c (TkBindInit): for REDO_KEYSYM_LOOKUP, change
	keysym-to-string mapping hash to use first name in ks_names.h instead of
	last (if there are multiple possibilities), e.g. "F11" instead of "L1".

	* macosx/tkMacOSXKeyboard.c (TkpGetKeySym): correct keysyms for pure
	modifier key presses [Bugs 700311, 1525905]; correct keysym for Enter
	key; add keysyms for new NumLock and Fn modifiers (added 2005-08-09).

2006-07-20  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWm.c (WmAttributesCmd, WmIconbitmapCmd): add support
	for weakly importing symbols not available on OSX 10.2 or 10.3, enables
	binaires built on later OSX versions to run on earlier ones.
	* macosx/README: document how to enable weak-linking; cleanup.
	* unix/configure.in: enforce requirement of OSX 10.2 for TkAqua; move
	* unix/tcl.m4:       Darwin specific checks & defines that are only
	relevant to the tcl build out of tcl.m4; restrict framework option to
	Darwin; cleanup quoting.
	* unix/configure: autoconf-2.13

	* macosx/tkMacOSXKeyEvent.c: ifdef out diagnostic messages to stderr.

	* macosx/tkMacOSXEvent.h:      standardize MAC_OS_X_VERSION_MAX_ALLOWED
	* macosx/tkMacOSXMenu.c:       checks per QA1316, ensure define can be
	* macosx/tkMacOSXMenubutton.c: overridden on command line (from default
	* macosx/tkMacOSXMenus.c:      of current OS version).
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXWm.c:

	* macosx/tkMacOSXCursor.c (TkMacOSXCursor):
	* macosx/tkMacOSXDebug.c (TkMacOSXGetNamedDebugSymbol):
	* macosx/tkMacOSXInit.c (Map): fix signed-with-unsigned comparison and
	other warnings from gcc4 -Wextra.

2006-07-14  Andreas Kupries  <andreask@activestate.com>

	* generic/tkWindow.c (Initialize): Modify change of 2006-05-25
	  (jeffh). Release mutex a bit earlier, to prevent lock when OS X
	  creates its console windows (recursively enters Tk_Init). Patch
	  by JeffH.

2006-07-06  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/tkfbox.tcl: catch scrollbar use of highlightthickness

2006-06-21  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/bgerror.tcl (::tk::dialog::error::bgerror): remove a
	couple of unnecessary hardcoded options

2006-06-15  Don Porter  <dgp@users.sourceforge.net>

	* changes: changes to start prep for an 8.4.14 release.

2006-06-15  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/makefile.vc:  Sync with tcl to enable building with 
	* win/rules.vc:     VC8 (VS2005 C compiler)
	* win/nmakehlp.c:

2006-06-14  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkScale.c:	Revised variable writing logic to account
	for [scale]'s design that it deals with its value as a formatted
	string, and not as a double.	[Bug 891141].

2006-06-14  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXSubwindows.c (TkMacOSXInvalidateWindow): ensure invalid
	clip regions are recreated via TkMacOSXUpdateClipRgn() before they are
	used; correct call order of TkMacOSXInvalidateWindow() and
	TkMacOSXInvalClipRgns() throughout. [Bug 1501922]

	* macosx/tkMacOSXDraw.c (TkPutImage): implement drawing of very wide
	images in slices of less than 4096 pixels to workaround CopyBits
	limitation. [Bug 950121]

2006-06-09  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkMain.c:     Added Tcl_Preserve() call on the master
	interp as crash protection against any Tcl_DeleteInterp() call
	that might happen.

2006-06-05  Don Porter	<dgp@users.sourceforge.net>

	* generic/tkInt.h:      Thread safety for the data structures of 
	* generic/tkConsole.c:  the wish [console].  [Bug 1188340].

2006-06-01  Don Porter	<dgp@users.sourceforge.net>

	* generic/tkConsole.c:	Added Tcl_RegisterChannel() calls to bump
	the refcount of channels passed to Tcl_SetStdChannel().	 This prevents
	early free-ing of the channels that leads to crashes.  [Bug 912571].

2006-05-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/entry.test (entry-22.1):
	* tests/listbox.test (listbox-6.15):
	* generic/tkListbox.c (ListboxInsertSubCmd, ListboxDeleteSubCmd):
	Ignore Tcl_SetVar2Ex failure of listVarName, similar to entry
	widget handling. [Bug 1424513]

2006-05-26  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/tkMacOSXButton.c (TkMacOSXDrawControl): correct redraw
	for direct transition from disabled to active state. [Bug 706446]

2006-05-25  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkMenu.c (DeleteMenuCloneEntries): Modify entry index
	changes to work around VC6 optimization bug. [Bug 1224330]

	* generic/tkMessage.c (MessageWidgetObjCmd): Correct msgPtr
	preserve/release pairing. [Bug 1485750] (afredd)

	* generic/tkWindow.c (Initialize): Correct mutex (un)lock
	pairing. [Bug 1479587]

2006-05-16  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWindowEvent.c (TkMacOSXGenerateFocusEvent): don't send
	focus events to windows of class help or to overrideredirect windows.
	[Bug 1472624]

	* macosx/tkMacOSXWm.c: set overrideredirect windows to not become
	activated by the window manager and to not receive OS activate events
	(should make them behave more like on other platforms); use modern
	window class API for overrideredirect and transient windows; set the
	default class of overrideredirect windows to 'simple' rather than
	'plain' (i.e. no window frame); add missing Panther and Tiger window
	attributes to [::tk::unsupported::MacWindowStyle].

2006-05-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkImgPhoto.c (Tk_PhotoPutBlock, Tk_PhotoPutZoomedBlock):
	Fix opt added 2006-03 that caused slowdown for some common cases.
	[Bug 1409140]

2006-05-13  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkCanvWind.c (DisplayWinItem, WinItemRequestProc): ensure
	canvas window items are unmapped when canvas is unmapped. [Bug 940117]

	* macosx/tkMacOSXSubwindows.c (TkMacOSXUpdateClipRgn): empty clip region
	of unmapped windows to prevent any drawing into them or into their
	children from becoming visible. [Bug 940117]

	* macosx/tkMacOSXInt.h:         revert Jim's attempt of 2005-03-14 to
	* macosx/tkMacOSXSubwindows.c:  fix Bug 940117 as it disables Map/Unmap
	event propagation to children.  [Bug 1480105]

	* macosx/tkMacOSXDraw.c (TkPutImage): handle tkPictureIsOpen flag, fixes
	incorrect positioning of images with complex alpha on native buttons;
	actual alpha blending is still broken in this situation. [Bug 1155596]

	* macosx/tkMacOSXEvent.c (TkMacOSXProcessCommandEvent):
	* macosx/tkMacOSXMenus.c (TkMacOSXInitMenus): workaround carbon bug with
	key shortcut for 'Preferences' app menu item. [Bug 1481503]

	* macosx/tkMacOSXKeyEvent.c (TkMacOSXProcessKeyboardEvent): only check
	for HICommand menu item shortcuts in the application menu.

	* macosx/tkMacOSXInt.h:       initialize keyboard layout setup in
	* macosx/tkMacOSXInit.c:      TkpInit() rather than during handling of
	* macosx/tkMacOSXKeyEvent.c:  first key down event.

	* macosx/tkMacOSXDraw.c:        add optional debug code to flash clip
	* macosx/tkMacOSXSubwindows.c:  regions during update or draw.

2006-05-04  Don Porter  <dgp@users.sourceforge.net>

	* README:		Bump version number to 8.4.14
	* generic/tk.h:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf-2.13
	* win/configure:

2006-04-28  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWm.c (TkWmMapWindow, InitialWindowBounds): fix use of
	potentially stale window position in initial configure event on first
	map of a window. [Bug 1476443]
	(TkMacOSXWindowOffset): use modern GetWindowStructureWidths API.

	* macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXMouseEvent.c (TkGenerateButtonEventForXPointer): new
	internal function to generate button events for current pointer
	directly, without requiring prior call to XQueryPointer().

	* macosx/tkMacOSXMouseEvent.c (XQueryPointer): implement return of
	window-local pointer position.

	* macosx/tkMacOSXInt.h:      use improvements above to avoid calls to
	* macosx/tkMacOSXKeyEvent.c: GlobalToLocal() when the current port might
	* macosx/tkMacOSXMenu.c:     not be set correctly. May fix [Bug 1243318]
	* macosx/tkMacOSXMenus.c:    
	* macosx/tkMacOSXScale.c:
	* macosx/tkMacOSXScrlbr.c:

	* tkAboutDlg.r: update copyright.

	* macosx/tkMacOSXCarbonEvents.c: sync with HEAD
	* macosx/tkMacOSXDebug.c:
	* macosx/tkMacOSXDebug.h:
	* macosx/tkMacOSXDraw.c:
	* macosx/tkMacOSXEvent.c:
	* macosx/tkMacOSXEvent.h:
	* macosx/tkMacOSXFont.h:
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXSend.c:
	* macosx/tkMacOSXTest.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c:

2006-04-25  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* unix/tkUnixFont.c (TkpGetFontFamilies): Fix crash caused when the
	XServer returns invalid font names. [Bug 1475865]

2006-04-22  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXEmbed.c:
	* macosx/tkMacOSXWm.c:
	* tests/constraints.tcl:
	* tests/wm.test: sync with 2006-04-18 commit to HEAD. (darley)

2006-04-12  Don Porter  <dgp@users.sourceforge.net>

	*** 8.4.13 TAGGED FOR RELEASE ***

	* generic/tkGrid.c: Fixed handling of out of bounds row or column.
	* tests/grid.test:  [Bug 1432666]

	* changes:	Updates for next RC.

2006-04-11  Jeff Hobbs  <jeffh@ActiveState.com>

	* changes: update for bug fix.

	* generic/tkBind.c (Tk_BindEvent, ChangeScreen): replace
	Tcl_GlobalEval with more efficient Tcl_EvalEx.

	* win/tkWinEmbed.c (TkpGetOtherWindow):   do not panic if no window
	* win/tkWinWm.c (UpdateGeometryInfo):     is found - handle it in
	* unix/tkUnixEmbed.c (TkpGetOtherWindow): the caller. [Bug 1212056]
	* unix/tkUnixWm.c (Tk_CoordsToWindow, UpdateGeometryInfo): 

2006-04-11  Daniel Steffen  <das@users.sourceforge.net>

	* changes: added latest aqua bug fixes.

	* macosx/tkMacOSXDialog.c (Tk_MessageBoxObjCmd): added standard Escape
	key binding for msgbox cancel buttons [Patch 1193614], whitespace.

	* macosx/tkMacOSXCarbonEvents.c: handle kEventCommandUpdateStatus
	* macosx/tkMacOSXEvent.c:        carbon event to dynamically enable
	the 'Preferences' app menu item when proc [::tk::mac::ShowPreferences]
	is defined. [Bug 700316]

	* macosx/tkMacOSXHLEvents.c:    call ::tk::mac::* procs for all
	* macosx/tkMacOSXWindowEvent.c: registered appleevents [FR 1105284],
	implement print applevent handling, style/whitespace cleanup. 

	* macosx/tkMacOSXDraw.c (TkMacOSXInitCGDrawing): prevent multiple init.

	* macosx/tkMacOSXInt.h:         Implemented 'zoomed' window state
	* macosx/tkMacOSXWindowEvent.c: handling for TkAqua, via titlebar
	* macosx/tkMacOSXWm.c:          widget clicks as well as [wm state].
	* doc/wm.n:                     [Bug 1073456]

2006-04-10  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updates for next RC.

2006-04-09  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWm.c (WmResizableCmd): propagate window attribute
	changes to Carbon window manager. [FR 1467004]
	(TkSetWMName, TkMacOSXMakeRealWindowExist): allow empty name for
	toplevels, remove bogus initial window name. [Bug 1450800]

2006-04-07  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXMouseEvent.c (TkMacOSXProcessMouseEvent): fix return
	values, implement window dragging & growing in background (with Command
	key down) and by fronting clicks [Bug 934524], use correct button &
	modifier state API when application is in background (also in
	TkMacOSXButtonKeyState).

	* macosx/tkMacOSXWm.c (TkMacOSXGrowToplevel): ensure QD port is set
	correctly before using API relying on it.
	
2006-04-06  Vince Darley <vincentdarley@users.sourceforge.net>

	* macosx/tkMacOSXMouseEvent.c: now that [wm attributes -titlepath]
	works correctly, add OS support for dragging proxy icons and 
	using the titlepath menu.

2006-04-06  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWm.c (WmAttributesCmd, WmIconbitmapCmd): fix errors
	in setting/removing window proxy icons via [wm attributes -titlepath]
	and [wm iconbitmap], use HIWindow API on Tiger or later. [Bug 1455241]
	
	* unix/tcl.m4: remove TCL_IO_TRACK_OS_FOR_DRIVER_WITH_BAD_BLOCKING
	define on Darwin. [Tcl Bug 1457515]
	* unix/configure: autoconf-2.13

2006-04-05  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinMenu.c (FreeID, TkpNewMenu, MenuExitHandler) 
	(MenuThreadExitHandler, TkpMenuInit, TkpMenuThreadInit): rework
	Windows menu init/finalization to better respect per-process and
	per-thread boundaries.

	* win/tkWinWm.c (WmProc): pass WM_QUERYENDSESSION message to Tk as
	WM_SAVE_YOURSELF wm protocol callback.

	* generic/tkTextDisp.c (TkTextPixelIndex): Don't segfault on full
	-elide text. [Bug 1442102]

	* win/tkWinX.c (TkWinXInit): init default keyboard charset
	correctly. [Bug 1374119] (pajas)

	* generic/tkText.c (DumpLine): stop dumping if we detect that the
	text widget state has changed while dumping. [Bug 1414171]
	(InsertChars, DeleteChars): fix undo with space-based path.
	* tests/text.test (text-25.14): [Bug 1452419]

	* tests/grid.test: fix segfault on empty index list
	* generic/tkGrid.c (GridRowColumnConfigureCommand):  [Bug 1422430]

2006-03-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkWindow.c (DeleteWindowsExitProc): added comments
	* generic/tkOption.c (TkOptionDeadWindow): handle
	OptionThreadExitProc being called before DeleteWindowsExitProc.

2006-03-29  Don Porter  <dgp@users.sourceforge.net>

	* unix/tkUnixDefault.h: Changed "Black" to "#000000" and "White" to
	"#ffffff" to work around the (broken?) X servers that do not accept
	those color names.  [Bug 917433]

2006-03-28  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkWindow.c (CreateTopLevelWindow): use thread exit
	handler for DeleteWindowsExitProc.

2006-03-28  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/makefile.vc:   Avoid pipe problems on win98.

2006-03-28  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/configure, win/tcl.m4: define MACHINE for gcc builds as well.
	Needed by Tk for manifest generation.

2006-03-28  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkFont.h: added prototype for TkFontGetFirstTextLayout()
	needed by tkMacOSXButton.c and tkMacOSXMenubutton.c.

	* macosx/tkMacOSX.h:             Cleaned up & rationalized order of
	* macosx/tkMacOSXBitmap.c:       #includes of tk and carbon headers;
	* macosx/tkMacOSXButton.c:       sync whitespace, comments & minor
	* macosx/tkMacOSXCarbonEvents.c: changes with HEAD.
	* macosx/tkMacOSXClipboard.c:
	* macosx/tkMacOSXColor.c:
	* macosx/tkMacOSXConfig.c:
	* macosx/tkMacOSXCursor.c:
	* macosx/tkMacOSXDialog.c:
	* macosx/tkMacOSXDraw.c:
	* macosx/tkMacOSXEmbed.c:
	* macosx/tkMacOSXEntry.c:
	* macosx/tkMacOSXEvent.c:
	* macosx/tkMacOSXEvent.h:
	* macosx/tkMacOSXFont.c:
	* macosx/tkMacOSXFont.h (new file):
	* macosx/tkMacOSXHLEvents.c:
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXKeyboard.c:
	* macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXMenus.c:
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXNotify.c:
	* macosx/tkMacOSXRegion.c:
	* macosx/tkMacOSXScale.c:
	* macosx/tkMacOSXScrlbr.c:
	* macosx/tkMacOSXSend.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXTest.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c:
	* macosx/tkMacOSXWm.h:
	* macosx/tkMacOSXXStubs.c:

2006-03-27  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkImgGIF.c (FileReadGIF): Stop crashes when the first GIF
	frame does not define the overall size of the image. [Bug 1458234]

2006-03-22  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updates for next RC.

2006-03-21  Daniel Steffen  <das@users.sourceforge.net>

	* unix/configure.in: fix detection of symbols build when enabling
	TkAqua debug code; filter nm output of libtclstub better to avoid
	error on intel macs [Bug 1415789].
	* unix/configure: autoconf-2.13

2006-03-20  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkUndo.c (TkUndoSetDepth): Fix a crash in the undo stack
	code. [Bug 1380427, Patch 1391939] Thanks to <lz_ufo@tin.it> for
	reporting and Ludwig Callewaert for the fix.

2006-03-17  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/clrpick.tcl:   bug #1451587: avoid using abbreviated
	* library/palette.tcl:   sub-commands in core scripts as this can
	* library/scale.tcl:     cause problems with mega-widget libraries
	* library/scrlbar.tcl:   like snit.
	* library/tkfbox.tcl:
	* library/xmfbox.tcl:

2006-03-16  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* library/msgs/pt.msg: Messages for Portuguese (strictly just for
	Brazilian Portuguese, but they'll do until we get other Portuguese
	speakers localize) from Ricardo Jorge <ricardoj@users.sf.net> and
	Silas Justiano <silasj@users.sf.net>. Many thanks! [Bug 1405069]

	* generic/tkImgPhoto.c (ImgPhotoCmd, Tk_PhotoPutBlock)
	(Tk_PhotoPutZoomedBlock): Added hack to detect copying of a photo with
	a simple alpha channel and skip calling ToggleComplexAlphaIfNeeded.
	This should speed up many photo-to-photo copies, keeping the cost of
	the alpha channel down.

2006-03-15  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkImgPhoto.c (Tk_PhotoPutBlock, Tk_PhotoPutZoomedBlock): Try
	to squelch performance issue with code that writes to large images by
	single pixels. Masses of thanks to George Staplin for helping to trace
	this down to the COMPLEX_ALPHA flag handling code. [Bug 1409140]

2006-03-13  Don Porter  <dgp@users.sourceforge.net>

	* tests/scrollbar.test:	Corrected several broken calls to [testmetrics]
	that were crashing the test suite.

	* tests/constraints.tcl:	Added notAqua constraint to canvPs-3.1
	* tests/canvPs.test:		to stop test suite crash on Mac OSX.
					[Bug 1088807]

	* generic/tkCmds.c:		Purged remaining references to
	* macosx/tkMacOSXPort.h:	errno, and errno.h.  Standardized
	* macosx/tkMacOSXWm.c:		the logic for using header files from
	* macosx/tkMacOSXWm.h:		the compat directory.  Thanks Joe
	* unix/tkUnixPort.h:		English for the patch. [Patch 1445404]

2006-03-11  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* library/bgerror.tcl (::tk::dialog::error::bgerror): Truncated error
	details were getting lost, leading to unreadable error messages.

2006-03-07  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/canvas.n: Added note that stipples are not well-supported on
	non-X11 platforms. [Bug 220787] It's not a great solution, but it does
	indicate the state of affairs that has existed for years anyway; not
	much modern software uses stipples anyway.

2006-03-07  Don Porter  <dgp@users.sourceforge.net>

	* READNE:		Bump version number to 8.4.13 and update
	* changes:		changes to start prep for an 8.4.13 release.
	* generic/tk.h:
	* unix/configure{.in}:
	* unix/tk.spec:
	* win/configure{.in}:

2006-03-02  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/Makefile.in: convert _NATIVE paths to use / to avoid ".\"
	path-as-escape issue.

	* unix/tcl.m4, win/tcl.m4: []-quote ac_defun functions.

	* macosx/tkMacOSXDraw.c (TkPutImage): fix endian issue on OS X x86
	displaying images.  Bitmap images still have a black/white
	reversal issue, appears to be a general OS X issue (as seen in
	frogger demo).

2006-03-02  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* unix/tcl.m4:    Fix for tk bug #1334613 to sort out shared library
	* unix/configure: issues on NetBSD. Regenerated configure script.

2006-02-27  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* generic/tkBitmap.c (Tk_GetBitmapFromData): Improve thread-safety.
	[Bug 470322]

	* generic/tkImgBmap.c (ImgBmapConfigureInstance): Force creation of
	new Pixmaps before deletion of old ones to prevent stupid caching
	problems. [Bug 480862]

2006-02-09  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tk.decls:             fix signature of TkMacOSXInvalClipRgns
	* generic/tkPlatDecls.h:        to use Tk_Window instead of internal	
	* macosx/tkMacOSXSubwindows.c:  type TkWindow (which led to any include 
	* macosx/tkMacOSXWindowEvent.c: of public header tkMacOSX.h requiring
	* macosx/tkMacOSXWm.c:          prior include of tkInt.h).
	
	* generic/tk.h:          move TkAqua specific REDO_KEYSYM_LOOKUP define
	* macosx/tkMacOSXPort.h: out of tk.h into platform header.

2006-01-25  Don Porter  <dgp@users.sourceforge.net>

	* library/bgerror.tcl:	Updates to use Tcl 8.4 features. [Patch 1237759]
	* library/button.tcl:
	* library/choosedir.tcl:
	* library/clrpick.tcl:
	* library/comdlg.tcl:
	* library/console.tcl:
	* library/dialog.tcl:
	* library/entry.tcl:
	* library/focus.tcl:
	* library/listbox.tcl:
	* library/menu.tcl:
	* library/msgbox.tcl:
	* library/palette.tcl:
	* library/panedwindow.tcl:
	* library/safetk.tcl:
	* library/scale.tcl:
	* library/scrlbar.tcl:
	* library/spinbox.tcl:
	* library/tearoff.tcl:
	* library/text.tcl:
	* library/tk.tcl:
	* library/tkfbox.tcl:
	* library/xmfbox.tcl:

2006-01-23  Daniel Steffen  <das@users.sourceforge.net>

	* unix/configure:    minor fix to Darwin specific code removing
	* unix/configure.in: 64bit flags from CFLAGS for Tk build.

2006-01-20  Joe English  <jenglish@users.sourceforge.net>

	* generic/tkEvent.c, unix/tkUnixEvent.c:  XIM fixes 
	[See #905830, patch tk84-xim-fixes.patch].
	+ Revert 2005-12-05 patch disabling XIM when SCIM in use;
	+ Make sure all X events get passed to XFilterEvent,
	including those without a corresponding Tk window.

2006-01-10  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXDraw.c: re-added inclusion of tclInt.h to allow access
	* macosx/tkMacOSXFont.c: to 8.4-internal Tcl_CreateNamespace().

	* macosx/tkMacOSXDebug.c: add TkMacOSXGetNamedDebugSymbol() function
	* macosx/tkMacOSXDebug.h: that finds unexported symbols in loaded
	libraries by manually walking their symbol table; only to be used for
	debugging purposes, may break unexpectedly in the future. Needed to get
	access to private_extern internal debugging functions in HIToolbox.

	* macosx/tkMacOSXCarbonEvents.c: fix debug event tracing on Tiger.
	* macosx/tkMacOSXMenu.c: add debug menu printing during reconfigure.
	* macosx/tkMacOSXInit.c: conditionalize 64bit-unsafe dyld code.
	* macosx/Makefile: add 'wish8.x' symlink to SYMROOT.

	* unix/configure:    add caching, use AC_CACHE_CHECK instead of
	* unix/configure.in: AC_CACHE_VAL where possible, consistent message
	* unix/tcl.m4:       quoting, sync relevant tclconfig/tcl.m4 changes and
	gratuitous formatting differences, fix SC_CONFIG_MANPAGES with default
	argument, Darwin improvements to SC_LOAD_*CONFIG.

2005-12-13  Daniel Steffen  <das@users.sourceforge.net>

	* library/demos/cscroll.tcl: add MouseWheel bindings for aqua.

	* macosx/tkMacOSXCarbonEvents.c (TkMacOSXInitCarbonEvents):
	* macosx/tkMacOSXMouseEvent.c (TkMacOSXProcessMouseEvent,
	GenerateMouseWheelEvent): add support for kEventMouseScroll events
	(smooth mouse wheel scrolling from mighty mouse or scrolling trackpad)
	by handling kEventMouseWheelMoved on application target as well as on
	dispatcher, in order to pick up synthesized MouseWheel events from
	HIObject handler (c.f. QA1453); add support for horizontal scrolling
	events by generating MouseWheel XEvent with Shift modifier.

2005-12-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tcl.m4, unix/configure: Fix sh quoting error reported in
	bash-3.1+ [Bug 1377619] (schafer)

2005-12-08  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXDraw.c:  remove inclusion of tclInt.h and use of tcl
	* macosx/tkMacOSXFont.c:  internals wherever possible in tk/macosx, the
	* macosx/tkMacOSXInit.c:  only remaining tcl internals in TkAqua are
	* macosx/tkMacOSXNotify.c: TclServiceIdle() in tkMacOSXScrlbr.c and
	* macosx/tkMacOSXScrlbr.c: Tcl_Get/SetStartupScript() in tkMacOSXInit.c
				   [RFE 1336531].
	* macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXXStubs.c: sync comments/whitespace with HEAD.

2005-12-05  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4.12 TAGGED FOR RELEASE ***

	* generic/tkOldConfig.c (Tk_ConfigureWidget): fix the handling of
	TK_CONFIG_OPTION_SPECIFIED to be flagged appropriately in original
	Tk_ConfigSpec.  This is *not* thread safe, but will be retained
	for 8.4.x and left out of 8.5.x. [Bug 749908]

2005-12-05  Reinhard Max  <max@tclers.tk>

	* unix/tkUnixEvent.c (OpenIM): Added a workaround to allow at
	least ASCII and the Compose key when typing into text and entry
	widgets on a system that uses SCIM. This has to be taken out again
	once the SCIM problems have been fixed.

2005-12-04  Daniel Steffen  <das@users.sourceforge.net>

	* mac/README: add note that mac classic port is no longer supported.

2005-12-01  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Update changes for 8.4.12 release

	* mac/tkMacWm.c:	Restored consistent error checking and
	* macosx/tkMacOSXWm.c:	messages among different platform's
	* tests/wm.test:	[wm grid] commands.  [Bug 1323972].
	* win/tkWinWm.c:

2005-12-01  Kevin Kenny  <kennykb@acm.org>

	* win/makefile.vc: restored buildability.
	
2005-12-01  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/menu.tcl (::tk::PostOverPoint): correct menu post near
	bottom of screen on Windows. [Bug 1353416]

2005-12-01  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (Darwin): fixed error when MACOSX_DEPLOYMENT_TARGET unset
	* unix/configure: regen.

	* macosx/tkMacOSXCarbonEvents.c (TkMacOSXInitCarbonEvents): added newly
	registered kEventAppAvailableWindowBoundsChanged to debugging code.

2005-11-30  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinWm.c (WmAttributesCmd): set (no)topmost window aspect
	before rewrapping.  [Bug 1086049]

	* generic/tkImgGIF.c: cast calls to block_out

	* win/Makefile.in: place TCL_BIN_DIR first in PATH for targets to
	get Tcl built dll first.

	* tests/scrollbar.test (6.22): fix rounding-error sensitive test

	* tests/textWind.test: use "Courier -12" on all platforms.
	Reduces Windows XP test errors in that file from 9 to 2 (13.2 and
	13.9 still off-by-one pixel).

	* win/tkWinWm.c (UpdateWrapper): Don't install frame menu on dead
	window.  Backport of 1233635

	* generic/tkEvent.c: fix handling of ClientMessage handlers.
	[Bug 1289565 983920]

	* macosx/tkMacOSXEvent.h: define
	kEventAppAvailableWindowBoundsChanged for OS X < 10.3.

2005-11-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/console.tcl (::tk::ConsoleInit): improve work-around to
	avoid '% ' from tclMain.c [Bug 1252259]

	* macosx/tkMacOSXXStubs.c (TkpOpenDisplay, TkMacOSXDisplayChanged):
	* macosx/tkMacOSXCarbonEvents.c (TkMacOSXInitCarbonEvents):
	* macosx/tkMacOSXWindowEvent.c (TkMacOSXProcessApplicationEvent):
	* macosx/tkMacOSXInt.h: Trap kEventAppAvailableWindowBoundsChanged
	event to watch for change in display size and adjust internal
	state appropriately.

	* win/tcl.m4:      Add build support for Windows-x64 builds.
	* win/configure:   --enable-64bit now accepts =amd64|ia64 for
	* win/Makefile.in: Windows 64-bit build variants (default: amd64)
	* win/makefile.vc: [Bug 1369597]
	* win/configure.in:
	* win/wish.exe.manifest.in (new):     manifest must map in MACHINE
	* win/rc/wish.exe.manifest (removed): and VERSION to be correct.

2005-11-27  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (Darwin): add 64bit support, check for Tiger copyfile(),
	add CFLAGS to SHLIB_LD to support passing -isysroot in env(CFLAGS) to
	configure (flag can't be present twice, so can't be in both CFLAGS and
	LDFLAGS during configure), don't use -prebind when deploying on 10.4,
	define TCL_IO_TRACK_OS_FOR_DRIVER_WITH_BAD_BLOCKING (rdar://3171542).
	(SC_ENABLE_LANGINFO, SC_TIME_HANDLER): add/fix caching, fix obsolete
	autoconf macros. Sync with tk/unix/tcl.m4, sync whitespace with HEAD.

	* unix/configure.in: fix obsolete autoconf macros, sync gratuitous
	formatting/ordering differences with tcl/unix/configure.in.

	* unix/Makefile.in: add CFLAGS to wish/tktest link to make
	executable linking the same as during configure (needed to avoid
	loosing any linker relevant flags in CFLAGS, in particular flags
	that can't be in LDFLAGS).  Avoid concurrent linking of wish and
	compiling of tkTestInit.o during parallel make, fix dependencies
	and flags for building tkMacOSXInit.o
	(checkstubs, checkexports): dependency and Darwin fixes

	* macosx/tkMacOSXEvent.c (TkMacOSXProcessEvent):
	* macosx/tkMacOSXEvent.h:
	* macosx/tkMacOSXMouseEvent.c (TkMacOSXProcessMouseEvent):
	* macosx/tkMacOSXCarbonEvents.c: install standard application event
	handler, add & call functions to start and stop carbon even timer that
	runs the tcl event loop periodically during a nested carbon event loop
	in the toolbox (e.g. during menutracking) to ensure tcl timers etc
	continue to fire, register app event handler for menu tracking and HI
	command carbon events, move menu event handling to new handlers for
	those carbon events, no longer register for/handle appleevent carbon
	event (now dealt with by standard application event handler), event
	debugging code dynamically acquires carbon event debugging functions to
	allow use on Tiger where they are no longer exported from HIToolbox.

	* macosx/tkMacOSXFont.c (TkMacOSXUseAntialiasedText):
	* macosx/tkMacOSXKeyEvent.c (GetKeyboardLayout):
	* macosx/tkMacOSXCarbonEvents.c (TkMacOSXInitCarbonEvents):
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXInt.h: abstract common code to dynamically acquire
	address of a named symbol (from a loaded dynamic library) into new
	function TkMacOSXGetNamedSymbol() and macro TkMacOSXInitNamedSymbol.

	* macosx/tkMacOSXMenu.c (TkpNewMenu):
	* macosx/tkMacOSXMenubutton.c (MenuButtonInitControl):
	* macosx/tkMacOSXMenus.c (TkMacOSXHandleMenuSelect): switch to  modern
	utf8 aware menu manager API, remove obsolete code, add error handling.

	* macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXMenus.c:
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXMouseEvent.c: define OSX 10.3 or later only constants
	if necessary to allow compilation on OSX 10.2

	* macosx/tkMacOSXWm.c (UpdateSizeHints): remove code that is never
	executed.

	* generic/tk.h: add/correct location of version numbers in macosx
	files.

	* generic/tkInt.h: clarify fat compile comment.

	* macosx/Wish.pbproj/default.pbxuser (new file):
	* macosx/Wish.pbproj/jingham.pbxuser:
	* macosx/Wish.pbproj/project.pbxproj: sync with HEAD.

	* macosx/buildTkConfig.tcl (removed): remove obsolete build files.

	* macosx/README: clarification/cleanup, sync with HEAD, document
	universal (fat) builds via CFLAGS (i.e. ppc and i386 at the same time).

	* macosx/Makefile: add support for reusing configure cache, build
	target fixes.

	* generic/tkMenu.c:
	* macosx/tkMacOSXButton.c:
	* macosx/tkMacOSXDebug.c:
	* macosx/tkMacOSXDebug.h:
	* macosx/tkMacOSXDialog.c:
	* macosx/tkMacOSXDraw.c:
	* macosx/tkMacOSXEntry.c:
	* macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXXStubs.c:
	* macosx/tkMacOSXSubwindows.c:
	* xlib/xgc.c: declare functions and globals used only in own file as
	static, #ifdef out a few Xlib and aqua functions that are never called
	(sync with HEAD).

	* macosx/tkMacOSXPort.h:
	* generic/tkInt.decls: correct signature of TkMacOSXHandleMenuSelect,
	add XSync to aqua Xlib stubs.

	* generic/tkTest.c: #ifdef unix only declarations.
	(TestmetricsCmd): unify win and mac implementation.

	* generic/tkTextDisp.c:
	* generic/tkTextBTree.c:
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXXStubs.c: fix gcc 4 warnings.

	* macosx/tkMacOSXNotify.c:
	* macosx/tkMacOSXTest.c: sync with HEAD.

	* generic/tkIntPlatDecls.h:
	* generic/tkIntXlibDecls.h:
	* generic/tkStubInit.c:
	* unix/configure: regen.

2005-11-22  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkFont.c (ParseFontNameObj, ConfigAttributesObj): Allow
	these functions to work with a NULL interp by making them check when
	generating error messages. [Bug 1151523]

	* unix/tkUnixSelect.c (SelCvtToX, SelCvtFromX): Backport of fixes for
	* generic/tkSelect.c (TkSelDefaultSelection):	"spaces in atom names"
	* tests/select.test (select-9.5):		problems. [Bug 1353414]

	* library/tkfbox.tcl (::tk::dialog::file::): Correct the quoting of
	the script used in variable traces so that widget names with spaces in
	will work. [Bug 1335485]

2005-11-16  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Update changes for 8.4.12 release

	* README:		Bump version number to 8.4.12
	* generic/tk.h:
	* macosx/Wish.pbproj/project.pbxproj:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf
	* win/configure:

2005-11-16  Vince Darley <vincentdarley@users.sourceforge.net>

	* doc/text.n: clarify left to right interpretation of index
	modifiers, including the fact that validation occurs after
	each step [Bug 1357575]

2005-11-06  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* unix/tcl.m4: Add missing LIBS for OpenBSD shared libary

2005-10-18  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkMain.c:	Rewrote code that sets the ::argv value
	to be sure conversion from the system encoding is complete before
	any processing sensitive to list-special characters is done.
	[Bug 1328926].

2005-10-17  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/tkMacOSXScrlbr.c (UpdateControlValues): check geomMgrPtr
	is valid before checking type

2005-10-10  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkInt.h: add MODULE_SCOPE and WORDS_BIGENDIAN checks
	that will work with OS X universal binary compiles. (steffen)

	* generic/tkConfig.c (Tk_DeleteOptionTable, Tk_CreateOptionTable):
	properly alloc/delete one more option. [Bug 1319720] (melbardis)

2005-10-10  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* tests/winfo.test: Wait until child window is visible
	* tests/wm.test:    Modified test to match actual error output.

2005-10-04  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/dialog.tcl (::tk_dialog): add tkwait visibility before
	grab. [Bug 1216775]

	* win/tkWinDialog.c (ChooseDirectoryValidateProc): reset stored
	path to "" if it doesn't exist and -mustexist is true. [Bug 1309218]

2005-09-15  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkOldConfig.c (GetCachedSpecs): Split out the code to
	manipulate the cached writable specs so that it can be reused from
	all the public Tk_Configure* functions.
	(Tk_ConfigureInfo, Tk_ConfigureWidget, Tk_ConfigureValue): Use the
	factored out code everywhere, so we always manipulate the cache
	correctly. [Bug 1288128]

2005-09-11  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXMouseEvent.c (TkMacOSXProcessMouseEvent): check if
	process is in front on MouseDown, otherwise request process activation
	from BringWindowForward() via new isFrontProcess param.

	* macosx/tkMacOSXCarbonEvents.c (TkMacOSXInitCarbonEvents):
	register our event handler on the dispatcher target for all carbon
	events of interest to TkAqua; this replaces event processing
	directly from the event queue and thus allows to capture events
	that are syntesized by Carbon and sent directly to the dispatcher
	and not to the event queue.

	* macosx/tkMacOSXEvent.c: remove TkMacOSXCountAndProcessMacEvents(),
	rename ReceiveAndProcessEvent() to TkMacOSXReceiveAndProcessEvent().
	(TkMacOSXReceiveAndProcessEvent): remove tk event processing before
	sending events to the dispatcher, all events of interest are now
	processed in our dispatcher target event handler.

	* macosx/tkMacOSXNotify.c (CarbonEventsCheckProc): dispatch events
	directly via TkMacOSXReceiveAndProcessEvent(), but dispatch no
	more than four carbon events at one time to avoid starving other
	event sources.

	* macosx/tkMacOSXEvent.c: formatting cleanup, move XSync() to XStubs,
	* macosx/tkMacOSXEvent.h: removed obsolete kEventClassWish handling.
	* macosx/tkMacOSXXStubs.c

	* macosx/tkMacOSXButton.c: conditionalize all debug message printing to
	* macosx/tkMacOSXCursor.c: stderr via TK_MAC_DEBUG define.
	* macosx/tkMacOSXDebug.c:
	* macosx/tkMacOSXDebug.h:
	* macosx/tkMacOSXDialog.c:
	* macosx/tkMacOSXEvent.c:
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXScale.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c: 

	* unix/configure.in: define TK_MAC_DEBUG on aqua when symbols enabled.
	* unix/configure: autoconf-2.13

	* library/listbox.tcl: corrected comments.
	* library/text.tcl: 

	* xlib/xcolors.c: fixed warning

2005-08-23  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/tkMacOSXDialog.c: make dialogs ignore -initialfile "" and
	-initialdir "" instead of error.

2005-08-23  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWin32Dll.c (DllMain): Replace old asm SEH
	approach with Kenny's new SEH implementation.
	[Tcl bug 1235544]

2005-08-22  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXButton.c:
	* macosx/tkMacOSXDialog.c: fix warnings.

2005-08-16  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkOldConfig.c (Tk_ConfigureWidget, Tk_ConfigureInfo): 
	(Tk_ConfigureValue, DeleteSpecCacheTable): Keep per-interpreter (and
	hence per-thread) copies of all the Tk_ConfigSpec tables so that
	Tk_Uids do not leak across threads. [Bug 749908]

2005-08-11  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkCanvLine.c, generic/tkCanvPoly.c, generic/tkCanvText.c: 
	* generic/tkCanvas.c, generic/tkConfig.c, generic/tkFocus.c: 
	* generic/tkFrame.c, generic/tkGrid.c, generic/tkImgPhoto.c: 
	* generic/tkPack.c, generic/tkPanedWindow.c: Don't pass size_t
	arguments to Tcl_GetStringFromObj, even with casting; it's not
	portable to 64-bit systems. [Bug 1252702]

2005-08-09  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXCarbonEvents.c (new): moved carbon events code into
	* macosx/tkMacOSXHLEvents.c:           new file like on HEAD,
	* macosx/tkMacOSXInit.c (TkpInit):     initialize carbon event handlers
	* macosx/tkMacOSXInt.h:                in TkpInit(), add new source
	* unix/Makefile.in:                    file to Makefile.in.

	* macosx/tkMacOSXCarbonEvents.c (AppEventHandlerProc): handle carbon
	events sent directly to application event target via the general
	TkMacOSXProcessEvent() in the same way as events posted to the event
	loop. Moved existing app event handlers to tkMacOSXWindowEvent.c.
	(TkMacOSXInitCarbonEvents): register our application event handler for
	kEventWindowExpanded events to deal with uncollapsing from the dock.

	* macosx/tkMacOSXEvent.h: made TkMacOSXProcessEvent() non-static, added
	* macosx/tkMacOSXEvent.c: new interp field to TkMacOSXEvent struct for
	                          use by app event handler.

	* macosx/tkMacOSXMouseEvent.c (TkMacOSXProcessMouseEvent): retrieve
	current window, partCode, modifiers and local cursor position from
	carbon mouse event if possible. Use new static GenerateButtonEvent()
	taking a MouseEventData struct instead of TkGenerateButtonEvent() to
	avoid recomputing already known values. Move process activation on
	MouseDown into BringWindowForward() to allow clicking on window titlebar
	widgets without activating process. Move code dealing with clicks in
	window titelbar into separate function HandleWindowTitlebarMouseDown()
	to avoid code duplication. Avoid repeated calls to TkMacOSXGetXWindow()
	by storing result in MouseEventData struct.
	(TkMacOSXButtonKeyState, XQueryPointer): try to get button and modifier
	state from currently processed carbon event (to avoid unnecessary IPC
	with the window server), otherwise use modern carbon API to get this
	info instead of Button() and GetKeys(); only retrieve info caller asks
	for (via non-NULL ptr passed to XQueryPointer).
	(ButtonModifiers2State): new static function converting carbon button
	and modifier state into tk state, allows detection of more than 3 mouse
	buttons (tk supports up to 5) and of NumLock and Fn modifier keys
	(NumLock is mapped to Mod3 and Fn to Mod4).

	* macosx/tkMacOSXWindowEvent.c (TkMacOSXProcessApplicationEvent): handle
	kEventWindowExpanded event to deal with window uncollapsing from the
	dock by generating tk Map event, handle kEventAppHidden and
	kEventAppShown events (moved here from tkMacOSXCarbonEvents.c).

	* macosx/tkMacOSXSubwindows.c (XUnmapWindow): only hide window when
	it is not iconified to avoid window flashing on collapse.

	* macosx/tkMacOSXWm.c: replaced Tk_DoWhenIdle() by Tcl_DoWhenIdle().
	(TkMacOSXZoomToplevel): remove call to TrackBox(), now done in
	HandleWindowTitlebarMouseDown() in tkMacOSXMouseEvent.c.
	(TkpWmSetState): avoid window flashing on collapse by unmapping after
	calling CollapseWindow(); only uncollapse window if it is collapsed.

	* generic/tkInt.decls: changed TkMacOSXZoomToplevel() signature.
	* generic/tkIntPlatDecls.h:

	* macosx/tkMacOSXKeyEvent.c (TkMacOSXProcessKeyboardEvent): only call
	GetMenuItemCommandID() on KeyDown or KeyRepeat events.

	* macosx/tkMacOSXMenu.c (ReconfigureMacintoshMenu): remove call to
	obsolete AppendResMenu() API.

	* macosx/tkMacOSXKeyEvent.c: replaced all direct uses of expensive
	* macosx/tkMacOSXMenu.c:     GetMouse() and TkMacOSXButtonKeyState()
	* macosx/tkMacOSXMenus.c:    APIs by calls to XQueryPointer()
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXScale.c:
	* macosx/tkMacOSXScrlbr.c:
	* macosx/tkMacOSXWm.c:

	* macosx/tkMacOSXDialog.c:   replaced use of FrontNonFloatingWindow()
	* macosx/tkMacOSXKeyEvent.c: by ActiveNonFloatingWindow() as
	* macosx/tkMacOSXMenu.c:     recommended by Carbon docs.
	* macosx/tkMacOSXMenus.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWm.c:

	* macosx/tkMacOSXDialog.c: fixed warnings
	* macosx/tkMacOSXTest.c:

	* macosx/tkMacOSXCarbonEvents.c: added CVS Id line to file header.
	* macosx/tkMacOSXDebug.c:
	* macosx/tkMacOSXDebug.h:
	* macosx/tkMacOSXEntry.c:
	* macosx/tkMacOSXEvent.h:
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.h:

	* macosx/tkMacOSXEmbed.c: replaced all uses of panic() with Tcl_Panic()
	* macosx/tkMacOSXFont.c:  (sync with HEAD).
	* macosx/tkMacOSXMenus.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWm.c:
	* macosx/tkMacOSXXStubs.c:

	* macosx/tkMacOSXInt.h:      sync with HEAD changes of 2005-03-14.
	* macosx/tkMacOSXSubwindows.c:

	* macosx/tclets.r (removed): sync with HEAD.
	* macosx/tkMacOSXScale.c:
	* macosx/tkMacOSXPort.h:

2005-07-30  Daniel Steffen  <das@users.sourceforge.net>

	* unix/Makefile.in (html): reverted/amended changes of 2005-07-24
	that broke TkAqua 'make install'; added BUILD_HTML_FLAGS
	optional var like in tcl/unix/Makefile.in.

2005-07-28  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/tkMacOSXDraw.c (XDrawLines, XDrawSegments): correct
	drawing of CoordModePrevious style (each point based on last).
	Exposed by tktable -drawmode fast.

	* library/bgerror.tcl (::tk::dialog::error::bgerror): use
	zoomDocProc instead of dBoxProc for bgerror dialog

	* macosx/tkMacOSXWm.c (TkpWmSetState): add IsWindowCollapsed check
	before calling CollapseWindow.
	(WmResizableCmd): adjust kWindow*Attributes according to resize
	parameters.

	* macosx/tkMacOSXMouseEvent.c (TkMacOSXProcessMouseEvent): handle
	inToolbarButton action (generates <<ToolbarButton>> virtual event)
	and correct inCollapseBox to properly track the event (waiting for
	buttonrelease) and generate the Unmap event (Map event on
	redisplay still missing).

2005-07-27  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkFrame.c (DisplayFrame):
	* generic/tkInt.decls:  add TkpDrawFrame to allow for
	* generic/tkIntDecls.h: platform-specific drawing into the frame/
	* generic/tkStubInit.c: toplevel area.  Currently only differs on
	* generic/tkFrame.c:    OS X (Aqua), which will draw a themed bg
	* win/tkWinDraw.c:      if tk::mac::useThemedToplevel == 1.
	* unix/tkUnixDraw.c:    Normal frames left alone until we can
	* mac/tkMacDraw.c:      better factor out frame drawing to be
	* macosx/tkMacOSXDraw.c:widget-specific.

	* generic/tkInt.h: Swap TkUnsupported1Cmd for TkUnsupported1ObjCmd.
	* generic/tkWindow.c: Ditto. (neil madden)
	* macosx/tkMacOSXInt.h: Added TkMacOSXWindowClass decl
	* macosx/tkMacOSXWm.c (TkMacOSXWinStyle) New function.
	(TkUnsupported1ObjCmd): New function, replaces the un-objectified
	version of the command, recognizes more classes and attributes.
	(TkMacOSXWindowClass): private function to return OS X class of a
	Tk window.
	* macosx/tkMacOSXSubwindows.c (XMapWindow, XUnmapWindow):
	recognize special show/hide functions for sheets

2005-07-24  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/Makefile.in: Subst TCLSH_PROG and
	BUILD_TCLSH into Makefile. Rework html
	target so that it depends on the tclsh
	installed on the system PATH.
	* unix/configure: Regen.
	* unix/configure.in: Invoke SC_PROG_TCLSH
	and SC_BUILD_TCLSH and subst into Makefile.
	* unix/tcl.m4: Update from Tcl.
	* win/Makefile.in: Subst TCLSH_PROG and
	BUILD_TCLSH into Makefile. Rework winhelp
	target so that it depends on the tclsh
	installed on the system PATH.
	* win/configure: Regen.
	* win/configure.in: Invoke SC_BUILD_TCLSH
	and subst into Makefile.
	* win/tcl.m4: Update from Tcl.
	[Tcl patch 1244153]

2005-07-21  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure, unix/tcl.m4: sync'ed to Tcl's tcl.m4

	* macosx/tkMacOSXEntry.c (TkpDrawEntryBorderAndFocus): set
	oldWidth to avoid warning

	* macosx/tkMacOSXMouseEvent.c (TkMacOSXProcessMouseEvent): 
	corrected if expression error (use of = instead of ==)

2005-07-06  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/getOpenFile.n: correct -multiple docs (takes boolean)

2005-06-25  Daniel Steffen  <das@users.sourceforge.net>

	*** 8.4.11 TAGGED FOR RELEASE ***

	* library/demos/menu.tcl: removed errant '}'.

2005-06-23  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkConsole.c: backport fix for bug 756840 & sync whitespace
	changes from HEAD.

	* generic/tkConsole.c (TkConsolePrint): prevent potential NULL deref.

	* macosx/tkMacOSXDefault.h: change ENTRY_BORDER defaults to from 5 to 2
	to make default entry widgets in TkAqua look like in other aqua apps
	(and have same border dimensions as other platforms). [Bug 1176610]

	* unix/Makefile.in (install-private-headers): rewrite tkPort.h when
	installing private headers to remove ../unix relative #include path to
	tkUnixPort.h (which is incorrect at the installed location).

2005-06-21  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/GetBitmap.3: Fix silly error in SYNOPSIS. [Bug 1224983]

2005-06-20  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkImgGIF.c (mInit,Mgetc,Fread): Stop anyone from reading
	off the end of a buffer.

2005-06-18  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Makefile: for X11 build, add -X11 suffix to unversioned wish
	symbolic link.

	* unix/tcl.m4 (Darwin): add -headerpad_max_install_names to LDFLAGS to
	ensure we can always relocate binaries with install_name_tool.

	* unix/configure: autoconf-2.13

2005-06-18  Don Porter	<dgp@users.sourceforge.net>

	* changes:		Update changes for 8.4.11 release

	* README:		Bump version number to 8.4.11
	* generic/tk.h:
	* macosx/Wish.pbproj/project.pbxproc:
	* unix/configure.in:
	* win/configure.in:

	* unix/configure.in:	Updated LOCALES to cover all msgs catalogs.

	* unix/configure:	autoconf
	* win/configure:

2005-06-04  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkCanvas.c (SearchUids): Move all global data into
	protected storage to stop cross-thread issues. [Bug 1114977] 

2005-06-03  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkConsole.c (Tk_CreateConsoleWindow, TkConsolePrint):
	Transmit the ConsoleInfo through AssocData, so renaming [console]
	won't make things break. [Bug 1016385]

2005-06-03  Daniel Steffen  <das@users.sourceforge.net>

	*** 8.4.10 TAGGED FOR RELEASE ***

	* macosx/Makefile: fixed 'embedded' target.

2005-06-02  Jim Ingham  <jingham@apple.com>

        Another patch from M. Kirkham.
	
	* macosx/tkMacOSXScrlbr.c (ThumbActionProc, ScrollBarBindProc):
	Record the first mouse down point, and compute differences from
	that, rather than getting the mouse down each time through the
	loop.  The old method would get fooled if you moved the mouse less
	than a text line height in the text widget.
	[Bug 1083728]
	
2005-06-02  Jeff Hobbs  <jeffh@ActiveState.com>

	* changes: update for 8.4.10 release (porter)

2005-05-31  Mo DeJong  <mdejong@users.sourceforge.net>

	* macosx/tkMacOSXWm.c (TkWmStackorderToplevelWrapperMap, TkWmStackorderToplevel):
	* unix/tkUnixWm.c (TkWmStackorderToplevelWrapperMap, TkWmStackorderToplevel):
	* win/tkWinWm.c (TkWmStackorderToplevelWrapperMap, TkWmStackorderToplevel):
	Fix panic in wm stackorder when a toplevel is created on another
	diplay. The code now ignores toplevels that have a display
	that does not match the display of the parent window.
	[Bug 1152809]

2005-05-30  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkPanedWindow.c, tests/panedwindow.test: batch of fixes
	to panedwindow from Daniel South.  Improved auto-size to fit
	internal windows, fixed sash placement at edge of pane, fixed
	calculation of stretch amount for internal windows.
	[Bug 1124198 1161543 1054117 1010941 795869 690169 1192323]

	* generic/tkMenu.c (MenuCmd): create event handler earlier to
	ensure proper destruction of menu through DestroyNotify.
	[Bug 1159367]

	* library/console.tcl (::tk::ConsoleInit): print out first prompt
	and swallow the extra "% " that comes once from Tcl on Windows.

2005-05-29  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: added missing FRAMEWORK defines
	introduced with configure/make based build.

	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXNotify.c: fixed warnings.

	* unix/configure.in: skip X11 configure checks when building tk_aqua.
	* unix/configure: autoconf-2.13

2005-05-27  Jeff Hobbs  <jeffh@ActiveState.com>

	* README:       Bumped patchlevel to 8.4.10
	* generic/tk.h:
	* macosx/Wish.pbproj/project.pbxproj:
	* unix/configure, unix/configure.in, unix/tk.spec:
	* win/configure, win/configure.in:

2005-05-27  Todd Helfter <tmh@users.sourceforge.net>

	* library/menu.tcl: correct the sticky behavior of menus posted by
	tk_popup so that they "stick" after the initial <ButtonRelease>
	following the post, that is not over an active menu entry.

2005-05-26  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXInit.c (TkpInit): fixed resource file extraction
	from __tk_rsrc section to work with non-prebound .dylib and .bundle.

	* macosx/Makefile: corrected EMBEDDED_BUILD check, use separate tcl
	and tk version vars to properly support tk/x11 framework version
	overriding, rewrite tkConfig.sh when overriding tk version, corrected
	Wish.app symlink in tk build dir.
	
	* unix/configure.in: corrected framework finalization to softlink
	stub library to Versions/8.x subdir instead of Versions/Current.
	* unix/configure: autoconf-2.13

2005-05-25  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure, unix/configure.in: ensure false Tcl.framework is
	only created with --enable-framework

	* unix/Makefile.in (install-libraries): protect possible empty
	list in for with list= trick for older shells.

2005-05-24  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkTest.c: disable commands not available on TkAqua.

	* macosx/Makefile:
	* macosx/README:
	* macosx/Tk-Info.plist.in (new file):
	* macosx/Wish-Info.plist.in (new file):
	* unix/Makefile.in:
	* unix/configure.in:
	* unix/tcl.m4:
	* unix/tkUnixInit.c:  moved all Darwin framework and TkAqua build
	support from macosx/Wish.pbproj and macosx/Makefile into the standard
	unix configure/make buildsystem, the project and macosx/Makefile are
	no longer required to build Tk.framework and/or TkAqua. TkAqua is now
	enabled by the --enable-aqua configure option, and static and
	non-framework builds of TkAqua are now available via the standard
	configure switches. Tk/X11 can also be built as a framework. The
	macosx/Makefile now wraps the unix buildsystem and no longer uses the
	projects, embedded builds are still only available via this Makefile,
	but for other builds it is not longer required (but its current
	functionality is still available for backwards compatibility). The
	projects currently do not call through to the Makefile to build
	(unlike Tcl.pbproj) so project builds may differ from makefile builds.
	Due to issues with spaces in pathnames, 'Wish Shell.app' has been
	renamed to 'Wish.app', the macosx/Makefile installs backwards
	compatibility symlinks for the old name.
	* macosx/tkMacOSXInit.c (TkpInit): added support for Tk resource file
	in non-framework and static builds: the resource file is copied into a
	__tk_rsrc MachO segment of the library or executable at link time and
	extracted into a temporary location at initialization.
	* unix/configure: autoconf-2.13

	* macosx/Wish.pbproj/project.pbxproj:
	* macosx/tkAboutDlg.r: updated copyright years to 2005.

2005-05-15  Jim Ingham  <jingham@apple.com>

	Fixes from Michael Kirkham:

	* macosx/tkMacOSXMenu.c (TkpConfigureMenuEntry): Thinko in clearing 
	the ENTRY_ACCEL_MASK before re-parsing it. [Tk Bug 1012852]

	* macosx/tkMacOSXScrlbr.c (UpdateControlValues): Don't set the 
	control value BEFORE setting the min and max or the control manager
	will reset it for you. [Tk Bug 1202181]

	* macosx/tkMacOSXXStubs.c (TkMacOSXXGetPixel, TkMacOSXXPutPixel):
	Restore the port to what it was before putting we were called.
	[Tk Bug 1202223]
	
2005-05-14  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXNotify.c: introduction of new tcl notifier based on
	CFRunLoop allows replacement of the custom TkAqua notifier by a
	standard tcl event source. Removes requirement of threaded tcl core
	for TkAqua, allows to stub-link TkAqua against Tcl by removing use of
	the unstubbed TclInitNotifier & TclFinalizeNotifier. [Tcl Patch 1202052]

	* macosx/Wish.pbproj/project.pbxproj: stub-link TkAqua: build with
	USE_TCL_STUBS and link against libtclstub instead of Tcl.framework,
	unexport libtclstub symbols from Tk to avoid duplicate symbol warnings
	when linking with both Tcl and Tk, fixes for gcc4.0 warnings.

	* macosx/tkMacOSXBitmap.c:
	* macosx/tkMacOSXButton.c:
	* macosx/tkMacOSXDialog.c:
	* macosx/tkMacOSXFont.c:
	* macosx/tkMacOSXHLEvents.c:
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXKeyboard.c:
	* macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXWm.c:
	* macosx/tkMacOSXXStubs.c: fixed gcc 4.0 warnings.

	* unix/tcl.m4: sync with tcl
	* unix/configure: autoconf-2.13

2005-05-10  Vince Darley <vincentdarley@users.sourceforge.net>

	* library/text.tcl: test and fix to TextPrevPara to avoid infinite loop
	* tests/textIndex.test: at start of widget [Bug 1191895]

2005-05-06  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure: regen
	* unix/configure.in: add AC_C_BIGENDIAN check
	* unix/tcl.m4: correct Solaris 10 (5.10) check and add support for
	x86_64 Solaris cc builds.

2005-04-25  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXNotify.c: syncd with tclUnixNotfy.c changes since
	2004-06-22, added compile time check for threaded tcl core, removed
	unthreaded code paths as they are never used anyway, fixed
	TkMacOSXAlertNotifier() implementation.

	* unix/Makefile.in: added TCL_STUB_LIB_FILE, needed for unexporting of
	symbols from libtclstub to avoid duplicate symbol warnings.

	* unix/tcl.m4 (Darwin): added configure checks for recently added linker
	flags -single_module and -search_paths_first to allow building with
	older tools (and on Mac OS X 10.1), use -single_module in SHLIB_LD and
	not just T{CL,K}_SHLIB_LD_EXTRAS, added unexporting from Tk of symbols
	from libtclstub to avoid duplicate symbol warnings, added PLAT_SRCS
	definition for Mac OS X.
	(SC_MISSING_POSIX_HEADERS): added caching of dirent.h check.
	(SC_TCL_64BIT_FLAGS): fixed 'checking for off64_t' message output.

	* unix/configure: autoconf-2.13

2005-04-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tkUnixFont.c (FontMapLoadPage): reorder char[] decls to
	avoid possible segv.  Minimal fix for [Bug 1122671]

	* library/tkfbox.tcl (::tk::dialog::file::): fix typeMenuLab ref.
	Add undoc'd ::tk::dialog::file::showHiddenBtn var (default 0) that
	will add a "Show Hidden" checkbutton to tk_get*File and
	tk_chooseDirectory if set to true.
	* library/choosedir.tcl (::tk::dialog::file::chooseDir::): fix
	cancelBtn ref, add hiddenBtn ref for "Show Hidden" button.

2005-04-09  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/README: updated requirements for OS & developer tool
	versions + other small fixes/cleanup.

	* macosx/tkMacOSXEntry.c (ComputeIncDecParameters): manually define
	constants present only in 10.3 headers so that we can build on 10.2.
	
	* macosx/Wish.pbproj/project.pbxproj: fixed absolute path to 
	tkEntry.h that confused 10.2 PBX.
	
	* unix/tcl.m4 (Darwin): added -single_module linker flag to
	TCL_SHLIB_LD_EXTRAS and TK_SHLIB_LD_EXTRAS.
	* unix/configure: autoconf-2.13

2005-03-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tcl.m4, win/configure: do not require cygpath in macros to
	allow msys alone as an alternative.

2005-03-24  Jim Ingham  <jingham@apple.com>

        These changes allow us to draw the Entry and Spinbox widget
	with a native look and feel on Mac OS X.

	* generic/tkEntry.h: New file, extracting the definitions of
	Entry and Spinbox.
	* generic/tkEntry.c (DisplayEntry): Call out to
	TkpDrawEntryBorderAndFocus and TkpDrawSpinboxButtons.  Also
	provide default implementations for X11 & Win.
	* macosx/tkMacOSXEntry.c: New file, implements the entry & focus
	and spinbox button drawing.
	* tkMacOSXDefaults.h: Change the Mac OS X defaults so they fit
	the native widget shapes.
	
	* xlib/xgc.c (XCreateGC): Set the default linewidth to 1, not
	0.  Some extensions seem to expect this.
	
2005-03-15  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* unix/tcl.m4:    Updated for OpenBSD and regenerated the configure
	* unix/configure: script

2005-03-11  Jim Ingham  <jingham@apple.com>

	* macosx/tkMacOSXButton.c (TkpDisplayButton): Set the port to
	the Button window's port BEFORE you set the clip, otherwise you 
	are setting the clip on the wrong window!
	Also, a little cleanup - move x & y into the branches where they are
	used, and don't compute the TextAnchor if we are using the native 
	button text, since we aren't going to use it.
	(TkMacOSXDrawControl): Call ShowControl & SetControlVisibility in a more
	logical order.

	* tkMacOSXInt.h: Add TkMacOSXGenerateFocusEvent.
	* tkMacOSXSubwindows.c (XDestroyWindow): We don't get Activate events
	for the remaining windows when a Floating window is destroyed.  This 
	can cause the focus to disappear.  So catch this case when the window
	is being destroyed and move the focus here.
	* tkMacOSXWindowEvent.c (TkMacOSXGenerateFocusEvent): Make this public
	(used to be GenerateFocusEvent) since we need it here and in 
	tkMacOSXSubwindows.c.  Then change the name everywhere it is used.
	[Bug 1124237]
	
2005-03-10  Jim Ingham  <jingham@apple.com>

	* macosx/tkMacOSXMouseEvent.c (TkMacOSXProcessMouseEvent): In
	the inDrag section, set the GrafPort to the drag window's GrafPort
	before doing LocalToGlobal. [Bug 1160025]
	
2005-03-08  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinWm.c (WinSetIcon): fix GCLP_ICONSM -> GCLP_HICONSM.

	* win/makefile.vc: clarify necessary defined vars that can come
	from MSVC or the Platform SDK.

2005-02-28  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinX.c (GenerateXEvent): correct %A translation on
	MouseWheel [Bug 1118340]

2005-02-25  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tkUnixFont.c (FontMapLoadPage): swap decl of char arrays to
	avoid aligment issues in Tcl_UtfToExternal. [Bug 1122671]

	* unix/configure, unix/configure.in: add AC_C_BIGENDIAN check
	which defines WORDS_BIGENDIAN on BE machines.

2005-02-24  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSX.h: fixed incorrect inclusion of internal header.
	* macosx/tkMacOSXNotify.c: corrected included headers.

2005-02-22  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXDialog.c (Tk_GetSaveFileObjCmd, NavServicesGetFile):
	fixed encoding problems with -initialfile & -filetypes and
	corrected potential buffer overrun with -initialdir/-initialfile.
	[Bug 1146057]

2005-02-14  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* tests/all.tcl: Add a [package require Tk] so that a missing
	display causes an early failure and keeps the error trace short.
	Issue observed in [FRQ 11122147], even though that's unrelated.

2005-02-11  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/panedwindow.tcl (::tk::panedwindow::Cursor): check
	window existence on delayed call. [Bug 949792]

	* doc/text.n: note 'image' key in 'dump' command. [Bug 1115907]

	* win/tkWinWm.c (TkWinGetIcon): fix toplevel retrieval for
	determining icon ref (potential crash). [Bug 1105738]

	* generic/tkCanvBmap.c (ConfigureBitmap, ComputeBitmapBbox): Fixed
	possible crash with disabled bmap and bbox handling [Bug 1119460]
	(BitmapToPostscript): made aware of various bitmap types
	(DisplayBitmap): remove unused fg/bgColor refs

2005-02-10  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/Makefile.in: remove SHLIB_LD_FLAGS (only for AIX, inlined
	* unix/tcl.m4:      into SHLIB_LD).  Combine AIX-* and AIX-5
	* unix/configure:   branches in SC_CONFIG_CFLAGS.
	Correct gcc builds for AIX-4+ and HP-UX-11.

2005-01-31  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* library/msgs/es_ES.msg: Added more localization for Spanish
	Spanish. [Bug 1111213]

2005-01-28  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure, unix/tcl.m4: add solaris 64-bit gcc build
	support. [Bug 1021871]

2005-01-25  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXInit.c (TkpInit): set tcl_interactive to 1 to show
	console at startup instead of directly calling [console show].
	
	* unix/tcl.m4 (Darwin): fixed bug with static build linking to
	dynamic library in /usr/lib etc instead of linking to static library
	earlier in search path. [Tcl Bug 956908]
	Removed obsolete references to Rhapsody. 
	* unix/configure: autoconf-2.13

2005-01-18  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* library/demos/menu.tcl: Reworked to make dialogs children of the
	demo widget so that they are properly visible. Issue reported by
	Keith Nash <k.j.nash@usa.net>

2005-01-14  Joe English  <jenglish@users.sourceforge.net>

	* unix/tkUnixWm.c: Sync with CVS HEAD (r1.47):
	Fixes: #959973 "wm title bug" (support Unicode titles)
	Fixes: #742882 "Potential division by zero in gridded wm geometry"
	Use Tcl_GetTime instead of TclpGetTime [#874745]
	Use Tcl_Panic() instead of "panic" [#865264]
	Fixes: #632816 "cannot remove transient"
	Fixes: #568861 "Fix for wm minsize and maxsize commands"
	* tests/unixWm.test, tests/wm.test: Updated test suite for 
	#632816 (unixWm-37.3, unixWm-37.4, wm-grid-1.11, wm-grid-1.12)
	and #742882 (unixWm-20.9, unixWm-20.11).

2005-01-11  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkObj.c (TkParsePadAmount):
	* generic/tkPack.c: Moved function to tkObj.c and rewrote so that it
	takes advantage of Tcl_Objs properly and cannot leave objects in an
	inconsistent state. [Bug 1098779]

2005-01-07  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkWindow.c (GetScreen): Make sure the result is reset on
	all error paths to stop strange errors. [Bug 697915]

2005-01-05  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/loadTk.n, doc/toplevel.n: Convert to other form of emacs
	mode control comment to prevent problems with old versions of
	man. [Bug 1085127]

2005-01-03  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinWm.c (TkWinWmCleanup): clean up layered window class.
	This caused crash in reinit of Tk (as seen in plugin).

2004-12-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tcl.m4, win/configure: update MSVC CFLAGS_OPT to -O2, remove
	-Gs (included in -O2) and -GD (outdated).  Use "link -lib" instead
	of "lib" binary and remove -YX for MSVC7 portability.  Add
	-fomit-frame-pointer for gcc OPT compiles. [Bug 1092952, 1091967]

2004-12-20  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/panedwindow.n: Fix silly typo. [Bug 1087842]

2004-12-09  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkImgPhoto.c (Tk_PhotoPutBlock, Tk_PhotoPutZoomedBlock):
	Added guards so that rescanning for the complex-alpha check is not
	done in the common case of creating a simple image a bit at a
	time, or any other time where the image was simple before and the
	input data has no alpha channel. [Bug 1081966]

2004-12-06  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4.9 TAGGED FOR RELEASE ***

	* library/text.tcl (::tk::TextUpDownLine): revert 2004-11-23 as it
	prevented scrolling to bottom.

2004-12-03  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkImgPhoto.c (Tk_PhotoPutBlock, Tk_PhotoPutZoomedBlock):
	Make overlay compositing where the target is empty no longer set
	the target to magical gray, and also make sure that the
	complex-alpha flag is toggled when necessary. [Patch 848161]

2004-12-02  Jeff Hobbs  <jeffh@ActiveState.com>

	* changes: updated for 8.4.9 release

2004-12-01  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tkUnixButton.c (TkpDisplayButton): constrain coords to
	Tk_RedrawImage to display only portion that is valid.
	* generic/tkImgPhoto.c (ImgPhotoDisplay): add X error suppression
	around XGetImage to prevent app abort. [Bug 979239]

2004-11-24  Jeff Hobbs  <jeffh@ActiveState.com>

	* README:       Bumped patchlevel to 8.4.9
	* generic/tk.h:
	* macosx/Wish.pbproj/project.pbxproj:
	* unix/configure, unix/configure.in, unix/tk.spec:
	* win/configure, win/configure.in:

2004-11-23  Vince Darley <vincentdarley@users.sourceforge.net>

	* library/text.tcl: make up/down cursor keys move by display
	lines, not logical lines [Bug 1011234] (REVERTED 2004-12-06)

2004-11-19  Reinhard Max  <max@suse.de>

	*** 8.4.8 TAGGED FOR RELEASE ***

	* unix/installManPage: Classic sed doesn't support | in REs.

	* doc/pack-old.n: Changed the internal name of the man page to
	pack-old to avoid a name clash in the installed man pages.

2004-11-18  Don Porter	<dgp@users.sourceforge.net>

	* changes:	Final updates for Tcl 8.4.8 release.

2004-11-18  Reinhard Max  <max@suse.de>

	* unix/tcl.m4 (SC_CONFIG_MANPAGES): Applied an improved version of
	* unix/configure.in:                patch #996085, that introduces
	* unix/Makefile.in:                 --enable-man-suffix.

	* unix/installManPage:              added
	* unix/mkLinks:                     removed

2004-11-17  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkCanvWind.c (ConfigureWinItem): unmap windows
	immediately when state hidden is requested. [Bug 982248]

	* generic/tkCanvImg.c (ImageToPostscript): don't try ps generation
	of canvas image item without image specified. [Bug 1032300]

	* library/console.tcl (::tk::console::ExpandVariable): correct
	array keyname expansion. [Bug 1004508] (bold)

	* generic/tkPanedWindow.c (Tk_PanedWindowObjCmd): set save_under X
	attr to prevent expose events when moving sash. [Bug 1036963]

2004-11-16  Don Porter	<dgp@users.sourceforge.net>

	* changes:	Updates for Tk 8.4.8 release.

	* library/msgs/it.msg:	Updated Italian message catalog.
	Thanks to Roberto Ugoccioni [Bug 1063675].

2004-11-12  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXXStubs.c: implemented XGetGeometry().

2004-11-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkCmds.c (Tk_TkObjCmd): use correct screen data when
	-displayof arg is passed to [tk scaling]. [Bug 800178]

2004-11-12  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXFont.c (Tk_MeasureChars,Tk_DrawChars,etc): Make
	sure that the lastSubFontPtr remains valid even when the subfont
	array is reallocated. [Bug 618872]

2004-11-11  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkMain.c:
	* macosx/tkMacOSXAppInit.c (removed):
	* macosx/Wish.pbproj/project.pbxproj: 
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXInt.h: changes to make TkAqua dynamically loadable,
	enabling [package require Tk] from tclsh. Startup code from
	tkMacOSXAppInit.c moved into tkMacOSXInit.c, added code that
	notifies the window server that an unbundled executable is a full
	GUI application after loading Tk. [Patch 1035348]

	* doc/wm.n: documented [wm attributes] on Mac OS X. [Bug 606665]
	* macosx/tkMacOSXWm.c: implemented TIP 222 [wm attributes -alpha] on
	Mac OS X. [Patch 892194]
	WmIconbitmapCmd: adopted FSRef changes from [wm atttrs -titlepath].

	* macosx/tkMacOSXButton.c:
	* macosx/tkMacOSXMenus.c:
	* macosx/tkMacOSXRegion.c:
	* macosx/tkMacOSXSubwindows.c: synced spacing/formatting with HEAD.

	* macosx/tkMacOSXMouseEvent.c: endianness fixes.

	* macosx/Wish.pbproj/project.pbxproj: corrected path to html help
	inside framework.

	* macosx/Makefile: prevent parallel make from building several
	targets at the same time.
	Ensure that xcodebuild will use Wish.pbproj project even if a .xcode
	project is also present.

2004-11-10  Jim Ingham  <jingham@apple.com>

	From Michael Kirkham (mikek@muonics.com):
	
	* macosx/tkMacOSXButton.c (TkpDisplayButton): Don't set
	the text if compound is NONE and we have and image.
	[Bug 1055023]
	
2004-10-29  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/wm.test: Add Win32 test cases for attributes
	subcommand.
	* win/tkWinWm.c (WmAttributesCmd): Fixup broken
	option processing logic for attributes subcommand.

2004-10-29  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/makefile.vc (DOTVERSION): Was installing 8.4 relabelled as 8.5

	* library/tk.tcl (::tk::PlaceWindow): Backported the fix from 
	#533519 to handle window placement on multi-monitor Windows.

2004-10-28  Mo DeJong  <mdejong@users.sourceforge.net>

	* doc/wm.n: Add wm attributes . -alpha doc to account
	for recent alpha changes.

2004-10-28  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWin32Dll.c (DllMain, _except_dllmain_detach_handler):
	Back port HAVE_NO_SEH handler code from CVS HEAD to fix
	gcc build breakage caused by 2004-10-26 back port.

2004-10-28  Don Porter	<dgp@users.sourceforge.net>

	* README:				Bumped to patch level 8.4.8
	* generic/tk.h:				to prepare for next patch
	* macosx/Wish.pbproj/project.pbxproj:	release.
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf (2.13)
	* win/configure:

2004-10-28  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* unix/tkUnixScale.c (DisplayHorizontalValue): Backport fix for
	#220927 by Michael Schlenker to keep the labels within the window.

2004-10-28  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/*.n: Backport of minor documentation fixes.

2004-10-27  Don Porter	<dgp@users.sourceforge.net>

	* library/xmfbox.tcl (MotifFDialog_BuildUI): Fix [Bug 987169] in
	the Motif file dialogs as well.	 Backport of DKF bug fix.

2004-10-26  David Gravereaux <davygrvy@pobox.com>

	* generic/tkInt.h:	Backport of shutdown safety mods from the HEAD
	* generic/tkMenu.c:	dating from 2003-12-21
	* generic/tkUtil.c:
	* generic/tkWindow.c:
	* mac/tkMacButton.c:
	* unix/tkUnixEvent.c:
	* win/tkWin32Dll.c:
	* win/tkWinEmbed.c:
	* win/tkWinMenu.c:
	* win/tkWinX.c:

	* generic/tkInt.decls:       Signature for tkWinXCleanup needed to be
	* generic/tkIntPlatDecls.h:  changed so it matches the Tcl_ExitProc
				     typedef to avoid a bad-style cast.
	

	* win/makefile.vc:  Backport to the most recent
	* win/rules.vc:     changes on the HEAD.
	* win/nmakehlp.c:

2004-10-26  Don Porter	<dgp@users.sourceforge.net>

	* tests/safe.test (safe-1.3):  Made test less sensitve to the
	full set of existing aliases in an interp, so the it only tests
	whether the tested ones are present.

	* unix/Makefile.in:	Copied LD_LIBRARY_PATH machinery from
	`make shell` target to other similar targets so that just built
	libraries are tested, rather than previous installations.

2004-10-26  Reinhard Max  <max@suse.de>

	* generic/tkEvent.c (Tk_HandleEvent): Call XSetICFocus whenever
	the window receives focus. This fixes bug #905830 but avoids
	#1000051.
	
2004-10-20  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinWm.c (UpdateWrapper): pass SWP_NOOWNERZORDER to
	SetWindowPos when maintaining win Z order, to prevent parent
	from flashing (adjusting Z order).

2004-10-05  Jeff Hobbs  <jeffh@ActiveState.com>

	Backport of 8.5 wm iconphoto that added support for Tk photo
	* generic/tkInt.h (TkDisplay):    images as titlebar icons. TIP #159
	* win/tkWinWm.c (WmIconphotoCmd): wm iconphoto ?-default? image1 ...
	* macosx/tkMacOSXWm.c (WmIconphotoCmd): Implemented for Win/Unix,
	* unix/tkUnixWm.c (WmIconphotoCmd):     stubbed out for OS X.
	* tests/wm.test, tests/unixWm.test, tests/winWm.test: [Bug 815751]

2004-09-24  Don Porter	<dgp@users.sourceforge.net>

	* generic/tkCursor.c:  Add missing initialization in debug routine.

2004-09-22  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinInt.h (TkWinDisplayChanged): added decl
	* win/tkWinX.c (TkWinDisplayChanged, TkpOpenDisplay): Correctly
	* win/tkWinWm.c (InvalidateSubTreeDepth, WmProc):     handle color
	and screen resolution changes.  Tested for 16/24/32 bpp changes on
	XP.  May need more fixes for 8bpp switch, use of special
	colormaps, or other special palette handling cases.  [Bug 223689]

2004-09-22  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkInt.decls: Add decl for TkWinGetPlatformTheme.
	It is only defined under Win32.
	* generic/tkIntPlatDecls.h: Regen.
	* generic/tkStubInit.c: Regen.
	* win/tkWinInt.h: Define TK_THEME_WIN_CLASSIC and
	TK_THEME_WIN_XP.
	* win/tkWinMenu.c (DrawMenuEntryAccelerator, DrawMenuEntryLabel):
	Draw a disabled 3D text highlight for the accelerator only
	with the Win95/98 look. Same goes for the menu entry text.
	* win/tkWinX.c (TkWinGetPlatformId, TkWinGetPlatformTheme):
	Automatically detect the Windows theme in use and return
	either TK_THEME_WIN_CLASSIC or TK_THEME_WIN_XP when the
	TkWinGetPlatformTheme function is invoked.
	[Patch 866194]

2004-09-22  Vince Darley <vincentdarley@users.sourceforge.net>

	* win/tkWinMenu.c: only provide a submenu handle when the
	MF_POPUP flag is given, fixing a recently-introduced crash
	when submenus are disabled.  Also better error checking for
	this sort of situation in the future.
	
2004-09-22  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinMenu.c (ReconfigureWindowsMenu): Fix drawing of a disabled
	(TkWinHandleMenuEvent, DrawMenuEntryArrow): cascade menu arrow. Tk was
	displaying a disabled cascade menu arrow in black instead of
	gray. This was caused by a bug in the Win32 code for user drawn
	menu items. The fix is to avoid telling Windows that the menu item
	is a cascade type and then draw the gray arrow bitmap on our own.
	[Patch 865842]

2004-09-22  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinMenu.c (DrawWindowsSystemBitmap): Fix a strange Win32
	bug where the logical coordinates returned by a call to DPtoLP are
	wrong the first time a menu is posted.  This bug manifested itself
	by drawing the bitmap in the wrong place in a menu.  The fix was
	to pass the newly created DC instead of the DC from the window.

2004-09-22  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinMenu.c (DrawMenuEntryAccelerator):
	(DrawMenuEntryLabel): When drawing the label text and accelerator
	text for a disabled menu entry be sure to draw a 3D highlight.
	The only exception to this is when a disabled menu entry is
	highlighted, in that case do not draw a 3D hightlight.

2004-09-22  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinMenu.c (DrawMenuEntryAccelerator, DrawMenuEntryArrow):
	Move the unused menu arrow drawing code in
	DrawMenuEntryAccelerator into a new function named
	DrawMenuEntryArrow.  This makes no functional change but it will
	make it easier to fix things in the future.

2004-09-22  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinWm.c: Rework WS_EX_LAYERED and LWA_ALPHA
	defines so that compiling with mingw works again.

2004-09-20  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinWm.c (UpdateWrapper, WmAttributesCmd): handle attribute
	settings prior to window mapping and resort to more forceful
	wrapper update again for -toolwindow (to remove it from taskbar).

2004-09-18  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinWm.c (WmAttributesCmd): correct -alpha 0.0/1.0 setting
	and round the value.
	(UpdateWrapper): don't adjust Z order of TOPMOST window.
	(WmAttributesCmd): don't call UpdateWrapper for -disabled or
	-toolwindow attr changes.

2004-09-18  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/README: typos
	* macosx/tkMacOSXDraw.c (TkMacOSXSetUpCGContext): performance
	improvements: removed slow & unnecessary calls.

2004-09-17  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/winWm.test: Add 'wm attributes -alpha' to control toplevel
	* win/tkWinInt.h:   alpha transparency on Win2K/XP+.
	* win/tkWinWm.c:    TIP #222 [Patch 892194]

	* win/tkWinWm.c (UpdateWrapper): Ensure that we maintain Z order
	* tests/winWm.test:              and focus of preexisting window
	when replacing the wrapper window.
	* win/tkWinWm.c (WmIconwindowCmd): Replace bogus call to
	XWithdrawWindow with proper code. (mdejong)

2004-09-16  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkMenu.c (MenuWorldChanged): ensure that we recompute
	the menu geometry on WorldChanged to handle font size
	changes. [Bug 607649]

2004-09-16  Peter Spjuth  <peter.spjuth@space.se>

	* tests/place.test:
	* generic/tkPlace.c: Fixed a memory leak when a placed widget was
	forgotten. [Bug 1028888]

2004-09-13  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinWm.c (ReadIconFromFile): fix mem alloc to get the right
	size for both icons ('?:' order of precedence mistake).

2004-09-10  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* library/tkfbox.tcl (::tk::dialog::file::): Make sure that the
	state is reset properly when starting to run the dialog. [Bug 845189]

	* library/demos/filebox.tcl: Stop the use of tk_strictMotif from
	poisoning the rest of the widget demo. [Bug 1013942]

2004-09-10  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinWm.c (ActivateWindow): SetFocus to grab window when
	clicking outside the grab window hierarchy. [Bug 220908]
	(UpdateWrapper): update to Kovalenko to account for whether the
	override window has a transient parent, and apply WS_POPUP in the
	correct case.  The makes splash screens pop up as well as making
	dropdowns not grab focus away from the parent.

2004-09-09  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinWm.c: backport of several items from 8.5 head:
	(ReadIconFromFile): when using SHGetFileInfo to retrieve icon, get
	regular icon as well for correct Alt-Tab icon. (hobbs)
	Fix for #742882 "Potential division by zero in gridded wm
	geometry" (jenglish)
	(UpdateWrapper): Let overrideredirect'ed window's wrapper be the
	child of desktop window, thus making it to behave more similarly
	to X11 Override Redirect. Esp. useful for combobox-like
	megawidgets. (kovalenko)
	(InstallColormaps): Check for TK_ALREADY_DEAD to avoid handling of
	dead windows. (kovalenko)
	Change 'panic' to 'Tcl_Panic' (davygrvy)

2004-09-06  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/tkfbox.tcl (::tk::dialog::file::Create): use label
	instead of button for "File of type", as it properly handles
	-state disabled now.

2004-08-26  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/text.tcl (::tk::TextTranspose): Ensure that Transpose is
	an atomic op to undo.  Replace 'string compare' with 'ne'.

2004-08-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinDialog.c (EatSpuriousMessageBugFix): Fix a problem with
	double clicks in file dialogs falling through to the window
	underneath in win32. [Patch #611615]

	* win/tkWinDialog.c (Tk_MessageBoxObjCmd): Inherit the icon from
	* win/tkWinInt.h:                          the -parent window for
	* win/tkWinWm.c (TkWinGetIcon):            the MessageBox.

2004-08-18  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkPanedWindow.c (optionSpecs): Add missing GEOMETRY flag
	to -handlepad option. [Bug 1010938]

2004-08-10  Joe English  <jenglish@users.sourceforge.net>

	* unix/tkUnixWm.c: Fix for #1006686 "wm resizable command 
	not working on Solaris/CDE" (patch from Colin McDonald).

2004-08-09  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/canvText.test:
	* win/tkWinFont.c (Tk_MeasureChars): Fix for text
	wrapping problem that appeared using canvas text
	under Win32. A long wrapping string that had
	leading spaces was being incorrectly wrapped.
	This change makes the Win32 implementation behave
	the same as the Unix implementation. [Patch 1006286]

2004-08-04  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkImgPhoto.c (ImgPhotoBlendComplexAlpha): Clean the code
	up a bit and add a few more comments.
	(Tk_PhotoPutBlock, Tk_PhotoPutZoomedBlock): Clarified the code,
	corrected the compositing rule now that I have looked up what the
	right thing to do is, and factorized out the compositing rule code
	into a few simpler macros.

2004-07-30  Daniel Steffen  <das@users.sourceforge.net>

	* unix/configure:
	* unix/tcl.m4 (SC_CONFIG_CFLAGS): Darwin: instead of setting PLAT_OBJS 
	to explict object files in tcl.m4, refer to MAC_OSX_OBJS makefile var.

2004-07-29  Don Porter	<dgp@users.sourceforge.net>

	*** 8.4.7 TAGGED FOR RELEASE ***

	* changes:
	* generic/tkEvent.c (Tk_HandleEvent): revert the 2004-07-20 commit.
	That commit created a new Bug 1000051 - a broken Compose Key.
	This revert restores Bug 905830 until a cleaner fix can be provided.

2004-07-27  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkImgGIF.c (FileReadGIF): fix crash reported by Reinhard Max:
	in case of premature end of image data, return error instead of
	passing nil buffer to Tk_PhotoPutBlock().

	* generic/tkRectOval.c (ComputeRectOvalBbox): Mac OS X specific
	fix to rounding in bounding box 'bloat' calculation to avoid drawing
	outside of bounding box when CG drawing enabled. Fix probably
	correct on other platforms as well?
	
	* macosx/tkMacOSXDraw.c (TkMacOSXInitCGDrawing): fixed LinkVar type
	for tkMacOSXCGAntiAliasLimit.

2004-07-26  Jeff Hobbs  <jeffh@ActiveState.com>

	* changes:	Updated for Tcl 8.4.7 release.

2004-07-24  Jim Ingham  <jingham@apple.com>

	* macosx/tkMacOSXDefault.h: Change the default -tearoff value
	to 0.  It doesn't work at present, so it is silly to make
	it the default.
	
	Mac OS X: Complete the implementation of the CG version of
	the X drawing emulation layer.
	
	This was mostly done by James Tittle (tigital<at>mac<dot>com), 
	with a little help from me.

	* macosx/tkMacOSXint.h: Add declaration of TkMacOSXInitCGDrawing.
	* macosx/tkMacOSXInit.c: Call it.
	* macosx/tkMacOSXDraw.c (TkMacOSXInitCGDrawing): New function
	set up the variables controlling the use of cg drawing.
	(XFillRectangles): Make the CG branch work.
	(XDrawLines): Ditto
	(XDrawSegments): Ditto
	(XFillPolygon): Ditto
	(XDrawRectangle): Ditto
	(XDrawRectangles): Ditto
	(XDrawArc): Ditto
	(XDrawArcs): Ditto
	(XFillArc): Ditto
	(XFillArcs): Ditto
	(TkMacOSXSetupCGContext): Make this actually work.
	(TkMacOSXReleaseCGContext): Ditto.

	Mac OS X: Add support for reading the wm attributes -titlepath 
	command, and convert to using FSRef's.  
	This was done by Neil Madden (nem<at>cs<dot>nott<dot>ac<dot>uk).

	* macosx/tkMacOSXWm.c (WmAttrGetModifiedStatus): New function.
	(WmAttrGetTitlePath) New function.
	(WmAttributesCmd): Convert command parsing to use the options index.
	Use the two above functions to report results.  Convert the titlepath
	code to use FSRef's.
	
2004-07-23  Benjamin Riefenstahl  <Benjamin.Riefenstahl@epost.de>

	[Merge from HEAD]

	Mac OS X: Fix several problems with Icelandic (and Faroese) keyboards
	reported by Jérôme Gagnon-Voyer <gagnonje5000<at>mac<dot>com> on
	tcl-mac on 2004-03-22.
	
	* macosx/tkMacOSXKeyEvent.c (KLSInit): Add.
	(GetKeyboardLayout): Add calls to Keyboard Layout Services, if
	present.  Rework classic handling.  Use GetKCHREncoding().  Add
	parameter encodingPtr.
	(GetKCHREncoding): Add.

2004-07-22  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/tkfbox.tcl (::tk::dialog::file::Update): use -directory
	[pwd] (instead of .) to get around some VFS edge case bugs.
	Use [bind $w], not [$w configure] to modify bindings.

2004-07-20  Jim Ingham  <jingham@apple.com>

	* generic/tkEvent.c (TkQueueEventForAllChildren): Don't queue
	events for unmapped windows.
	
2004-07-20  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkEvent.c (Tk_HandleEvent): ensure IC focus is set after
	creation. [Bug #905830]

2004-07-20  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4: fixed Darwin autoconf breakage caused by
	recent CFLAGS reordering.
	* unix/configure: regen

	* macosx/Makefile: added support to tk framework build to
	optionally install tk manpages in addition to html help,
	similarly to tcl/macosx/Makefile.
	
	* macosx/Wish.pbproj/project.pbxproj: fixes for building with
	non-default SYMROOT/OBJROOT/SRCROOT, added support for using a
	Tcl.framework in DYLIB_INSTALL_PATH != /Library/Frameworks,
	added optional support for building html help without tcl sources 
	present by giving explicit location of tcltk-man2html script.
	
	* macosx/tkMacOSXMenu.c: fixed #include case sensitivity bug.

2004-07-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/Makefile.in, unix/tcl.m4:     move (C|LD)FLAGS after their
	* unix/configure.in, unix/configure: _DEFAULT to allow for env
	setting to override m4 switches.
	Consolidate header checks to limit redundancy in configure.
	(CFLAGS_WARNING): Remove -Wconversion, add -fno-strict-aliasing
	for gcc builds (need to suppress 3.x type puning warnings).
	(SC_ENABLE_THREADS): Set m4 to force threaded build when built
	against a threaded Tcl core.
	Reorder configure.in for better 64-bit build configuration,
	replacing EXTRA_CFLAGS with CFLAGS.  [Bug #874058]

2004-07-14  Jim Ingham  <jingham@apple.com>

	* macosx/tkMacOSXCursor.c (TkpSetCursor): The code to not
	reset the cursor more often than necessary was getting fooled
	when the current cursor was nulled out when the current cursor
	gets freed.  So in the case where the input cursor was NULL, we
	have to just always set it. [Bug #894550]
	
2004-07-14  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkUndo.c (TkUndoSetDepth): correct -maxundo
	segfault. [Bug #969358] (jiangwu)

	* generic/tk.h (TK_PATCH_LEVEL): 
	* README, macosx/Wish.pbproj/project.pbxproj:      bumped to
	* unix/configure, unix/configure.in, unix/tk.spec: patchlevel 8.4.7
	* win/configure, win/configure.in:

2004-07-11  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* library/tkfbox.tcl (::tk::dialog::file::Create): Watch out for
	users destroying the dialog indirectly. [Bug 987169]

2004-06-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkCmds.c (Tk_WinfoObjCmd): refetch interp result obj for
	'winfo id' as it can change when making the window exist.

2004-06-25  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkImgPhoto.c (ImgPhotoDisplay): Early exit from image
	redraw if the region to redraw is empty, so stopping XGetImage
	from bailing out. [Bug 979239]

2004-06-08  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkCanvText.c (DisplayCanvText): Fix text
	rendering problem with canvas text items that
	have a selected region. The previous implementation
	would render the whole line and then redraw the
	selected text if it was a different color. This caused
	problems when the selected text foreground differs
	from the normal text foreground, the anti-aliasing
	alpha pixels for the two text strings would blend
	together resulting in strange looking text. The
	fix is to draw the normal text and the selected text
	separately. This problem has only been observed
	under Windows, with anti-aliased text. [Patch 968725]

2004-05-14  Chengye Mao <chengye.geo@yahoo.com>

	* win/tkWinWm.c (UpdateWrapper): Modified to delete the old wrapper
	correctly [Bug #767176]

2004-05-14  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* library/msgbox.tcl (MessageBox): Shrank the default font size
	for the message to 14-point; nobody liked 18-point!

2004-05-12  Chengye Mao <chengye.geo@yahoo.com>

	* generic/tkBind.c (HandleEventGenerate): Modified to fix wish
	crash due to incorrectly generate <Destroy> event. This bug was
	reported in comp.lang.tcl but not logged.

2004-05-10  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/makefile.vc: Apply fix from tcl bug #950049 for make docs.

2004-05-05  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinFont.c (Tk_MeasureChars,Tk_DrawChars,etc): Make sure
	that the lastSubFontPtr remains valid even when the subfont array
	is reallocated. [Bug #618872] (dkf, hobbs)

2004-05-03  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinMenu.c, unix/tkUnixMenu.c (DrawMenuEntryLabel): place
	images of compound menu entries in indicator space if not a radio
	of checkbutton. [Bug #756952] (eserte)

	* win/tkWinX.c:                fix drawing of unicode chars in menu
	* win/tkWinInt.h (TkWinProcs): titles. [Bug #904371] (riefenstahl)
	* win/tkWinMenu.c (ReconfigureWindowsMenu):

	* generic/tkClipboard.c:   Move TkClipCleanup from tkClipboard.c
	* mac/tkMacXStubs.c:       to being implemented in a platform
	* macosx/tkMacOSXXStubs.c: specific manner.  The cleanup order was
	* unix/tkUnixEvent.c:      bad at least on Windows, where we
	* win/tkWinX.c:            reset/cleared display info that was
	still needed for the clipboard to render.
	[Bug #939389, #822002, #732662]

	* library/panedwindow.tcl (MarkSash): call DragSash to stop sash
	jump when B1 is pressed and released without moving. [Bug #932155]
	Make the panedwindow -opaqueresize option work as per the docs.
	[Bug #778893]

	* tests/panedwindow.test: panedwindow-25.1
	* generic/tkPanedWindow.c (Unlink): clean up -before/-after refs
	to a slave when removing it. [Bug #928413] (griffin)

	* generic/tkImgPhoto.c (ImgPhotoConfigureMaster): force -data into
	ByteArray and -format into String to correctly handle them if they've
	been shimmered or created as some other object type. [Bug #1027849]
	(ImgPhotoCmd): correctly init matched to 0.

2004-04-20  Joe English  <jenglish@users.sourceforge.net>

	* unix/tkUnixWm.c: Backported fix for bug #915350  
	"Tk sets min, max size in WM_HINTS when it shouldn't" 
	and #922336 "Tk apps have no maximize window button under 
	KDE-3.2.1"

2004-04-16  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/bgerror.tcl (bgerror): rework to only set -topmost bit
	on Windows if necessary.  Also use existing ::tk functions for
	placing dialog and managing focus/grab.

2004-03-31  Jim Ingham  <jingham@apple.com>

	* tkMacOSXMenu.c (EventuallyInvokeMenu): Report errors from invoking
	menu commands as background errors. [Bug 220871]

2004-03-26  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkImgPPM.c (ReadPPMStringHeader): Code to read PPM/PGM data
	(StringReadPPM, StringMatchPPM): from strings/bytearrays. [FRQ 540375]
	* generic/tkImgPPM.c (StringWritePPM): New function to support
	converting of images to PPM strings.  Other direction not yet
	done.  Rest of file converted to use new image API.
	* generic/tkImgPhoto.c (ImgPhotoCmd): Restored support for the
	stringWriteProc of old photo formats.  [Bug 923555]

2004-03-20  Jim Ingham  <jingham@apple.com>

	* macosx/tkMacOSXSubwindows.c (GenerateConfigureNotify): New
	function.
	(XMoveWindow): Generate configure notify events for child
	widgets on move.
	(XMoveResizeWindow): Ditto.

2004-03-17  Jim Ingham  <jingham@apple.com>

	* macosx/tkMacOSXHLEvents.c (ApplicationCarbonEventsHandler): New 
	function.
	(tkMacOSXInitAppleEvents): Init the Application Event handler as
	well.
	* macosx/tkMacOSXKeyEvent.c (TkMacOSXProcessKeyboardEvent): Grab
	the Command-H & Command-Shift-H keys and use them for Hide and
	Hide Others before passing keystrokes on to the generic keyboard
	event processing.  There isn't any other good way to get the
	Hide command to work, and the Apple HIG explicitly reserves them.
	* macosx/tkMacOSXMenus.c (TkMacOSXInitMenus): Stop putting a Quit
	menu item in the File menu.  It doesn't belong there.

2004-03-01  Don Porter	<dgp@users.sourceforge.net>

	*** 8.4.6 TAGGED FOR RELEASE ***

	* unix/tcl.m4 (SC_CONFIG_CFLAGS):	Allow 64-bit enabling on
	IRIX64-6.5* systems.  [Bug 218561]
	* unix/configure:	autoconf-2.13

2004-02-23  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXDraw.c:
	* macosx/tkMacOSXXStubs.c:
	* xlib/ximage.c: fixed MacOSX XGetImage/XPutImage and related 
	functions to deal properly with XImages copied from screen.
	* generic/tkCanvPs.c (TkImageGetColor): MacOSX fix.
	* generic/tkImgPhoto.c (ImgPhotoDisplay): enabled alpha blending
	for images with partial transparency on MacOSX.
	[Bug 809157]

2004-02-18  Peter Spjuth  <peter.spjuth@space.se>

	* tests/grid.test:
	* generic/tkGrid.c: Fixed a bug in grid geometry calculations for
	a shrinking grid. [Bug 899246]

2004-02-17  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkBind.c (HandleEventGenerate): only modify root[xy]
	with [xy] when they haven't been otherwise set.

2004-02-17  Don Porter	<dgp@users.sourceforge.net>

	* tests/imgPhoto.test (imgPhoto-16.1):	Corrected incorrect
	variable name [Bug 899010].

2004-02-17  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXMouseEvent.c: fixed modifiers for MouseWheel events.
	
	* library/listbox.tcl:
	* library/text.tcl:
	* library/scrlbar.tcl: on Mac OS, add bindings for MouseWheel with
	modifiers, according to platform convention: 
	Option increases scrolling speed 10 fold; Space scrolls horizontally.
	
	* macosx/Wish.pbproj/project.pbxproj:
	* macosx/tkAboutDlg.r: changed year in copyright strings to 2004.

2004-02-16  Jim Ingham  <jingham@apple.com>

	Fix for MouseWheel Events (from Daniel Steffen):

	* generic/tkEvent.c (Tk_HandleEvent): On Mac OS X, don't route
	MouseWheel events to the Focus window.  They are sent to the
	window under the pointer on X (and the GenerateMouseWheelEvent
	already got this right.)
	* library/listbox.tcl: On Mac OS, don't use the magic 120
	divisor that is used on Windows.  We may come up with a cleaner
	way to do this for the TOT, but this is simple and will do for the
	8.4 branch.
	* library/text.tcl: Ditto.
	* doc/bind.n: Update the docs to reflect the changes.
	
2004-02-15  Jim Ingham  <jingham@apple.com>

	Backport Mac OS X specific fixes from TOT:

	* macosx/tkMacOSXKeyboard.c: General cleanup.  Add support for
	[event generate].  [Bug #860454] - [Benjamin Riefenstahl]
	* macosx/tkMacOSXKeyboard.c: Add PowerBook keycode 0x34 as <Return>.
	[Benjamin Riefenstahl]

	* macosx/tkMacOSXScrlbr.c: Reworking Vince's fix to [Bug 842952].
	This version is clearer, and works helps keep the mouse better
	pinned to the scrollbar.  I also removed the glitch where the
	scrollbar would jump get its middle over the mouse when you first
	moved it.
	
	* macosx/tkMacOSXClipboard.c (TkSuspendClipboard, TkSelGetSelection):
	add unicode clipboard support. [Patch #840107] (senn)	
	
	* macosx/tkMacOSXDialog.c (NavServicesGetFile): Minor cleanups.
	* (OpenFileFilterProc): Handle FSRef's as well as FSSpec's in the input
	file.  Also convert the FSSpec filename to an C-string before passing
	to MatchOneFile.  [bug 517600]
	* (MatchOneFile): Require the input filename to be a C-string, not a
	pascal string.
	
	* macosx/tkMacOSXDialog.c (MatchOneType): If the Macintosh filetype
	is 0, then automatically pass the fileType check.

	* macosx/tkMacOSXButton.c (TkpDisplayButton): Use the tk text
	drawing for checkbuttons & radiobuttons as well as for labels.
	* macosx/tkMacOSXEvent.c (XSync): New function, need to implement
	this so drawing will get flushed in "update idletasks".
	* tkMacOSXPort.h: convert #define of XSync to function def'n.

	* generic/tkWindow.c:
	* macosx/tkMacOSXDialog.c: added native tk_messageBox command,
	(Tk_MessageBoxObjCmd) for MacOS X platform. [Vince Darley]

	* macosx/tkMacOSXMenu.c: corrected encoding conversion for
	torn-off menu entries (but many other display problems still
	exist with these) [Vince Darley]

	* macosx/tkMacOSXMouseEvent.c: improved handling of events in the
	presence of grabs, particularly activation events. [Vince Darley]
	
	* macosx/tkMacOSXColor.c (GetControlPartColor): Use
	the ThemeBrushes to get the control text color for
	buttons.
	
	* tkMacOSXAppInit.c: Formatting cleanups.
	* tkMacOSXButton.c: Ditto
	* tkMacOSXClipboard.c: Ditto
	* tkMacOSXDebug.c: Ditto
	* tkMacOSXDialog.c: Ditto
	* tkMacOSXDraw.c: Ditto
	* tkMacOSXEvent.c: Ditto
	* tkMacOSXFont.c: Ditto
	* tkMacOSXHLEvents.c: Ditto
	* tkMacOSXInit.c: Ditto
	* tkMacOSXInt.h
	* tkMacOSXKeyEvent.c: Ditto
	* tkMacOSXMenu.c: Ditto
	* tkMacOSXMenubutton.c: Ditto
	* tkMacOSXMouseEvent.c: Ditto
	* tkMacOSXNotify.c: Ditto
	* tkMacOSXScale.c: Ditto
	* tkMacOSXScrlbr.c: Ditto
	* tkMacOSXSubwindows.c: Ditto
	* tkMacOSXWindowEvent.c: Ditto
	* tkMacOSXWm.c: Ditto
	
2004-02-13  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinFont.c (Tk_MeasureChars): backport fixes to bold/italic
	font handling. [Patch 852669] [Bug 478568]
	* tests/textDisp.test: added test for the font measurement 
	problem.

2004-02-13  Jim Ingham  <jingham@apple.com>

	* macosx/tkMacOSXDialog.c (Tk_GetOpenFileObjCmd): Use CFStringRef for
	title & message options, not pascal strings.
	(Tk_GetSaveFileObjCmd): Ditto
	(Tk_ChooseDirectoryObjCmd): Ditto
	(NavServicesGetFile): Now that we get CFStrings, we don't need
	to convert them here.

	* macosx/tkMacOSXMenu.c (TkMacOSXDispatchMenuEvent): Cleanup, we don't
	need to handle the Apple Menu picks any more, but the code didn't
	reflect that.

	* macosx/tkMacOSXWm.c (TkSetWMName): Use CFStrings for the Window Title
	name, not Pascal strings.  
	
2004-02-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* README:       update to patchlevel 8.4.6
	* generic/tk.h:
	* macosx/Wish.pbproj/project.pbxproj:
	* unix/configure, unix/configure.in, unix/tk.spec:
	* win/configure, win/configure.in:

	* tests/window.test: simple code cleanup

	* win/tkWinDialog.c (ChooseDirectoryValidateProc): create a pidl
	for -initialdir if we have a UNC path because BFFM_SETSELECTION
	doesn't support UNC paths in strings.

2004-02-10  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* library/msgs/eo.msg:	Language support for Esperanto and Polish from
	* library/msgs/pl.msg:	Artur Trzewik <mail@xdobry.de> with thanks.

2004-02-09  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkImgPhoto.c (Tk_PhotoPutBlock, Tk_PhotoPutZoomedBlock): 
	* tests/imgPhoto.test (imgPhoto-16.1): Better handling of the case
	when copying from one area of a photo to another triggers a
	resizing of the image.  [Bug 877950]

2004-02-03  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/menu.tcl (::tk::MbPost): make menubuttons that post
	above or below reverse direction when not enough space is available.

2004-01-28  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinCursor.c: Backported fix for bug #776646 which makes
	* tests/cursor.test: hand2 and fleur native on windows.

2003-01-27  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: removed erroneous reference
	to mkpsenc.tcl in bundle resources phase (mkpsenc.tcl is already
	part of the copy files phase to Resources/Scripts).

	* macosx/Makefile: added support for 'xcodebuild' on Mac OS X 10.3.

2003-12-31  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: added missing private headers
	to installed Tk.framework, so that tkInt.h can be included  
	sucessfully from Tk.framework/PrivateHeaders.
	* generic/tkPort.h: corrected include of tkMacOSXPort.h

2003-12-17  Jim Ingham <jingham@apple.com>

	* macosx/tkMacOSXScrlbr.c: Reworking Vince's fix to [Bug 842952].
	This version is clearer, and works helps keep the mouse better
	pinned to the scrollbar.  I also removed the glitch where the
	scrollbar would jump get its middle over the mouse when you first
	moved it.
	
	Import from TOT.

2003-12-11  David Gravereaux <davygrvy@pobox.com>

	* win/winMain.c: Backed-out yesterdays change.  Reverted to 1.15 for
	two reasons.  1) problem is best addressed in Tcl's DllMain() and
	2) needs a MinGW custom assembly implimentation as it doesn't
	understand SEH syntax.

2003-12-10  David Gravereaux <davygrvy@pobox.com>

	* win/winMain.c (WishPanic) : placed ExitProcess() in a __try block
	(SEH) to catch any exceptions that might happen.  As Tcl will call
	Tcl_Finalize from its DllMain due to the unload from ExitProcess()
	unloading Tcl, and if Tcl_Panic had gotten called in an __except
	block handling an exception, this avoid the possibility of not
	being able to exit from the stack being a mess.  Falls to
	TerminateProcess() in the __except case.

	Removed the #ifdef _MSC_VER around DebugBreak as that function
	exists in kernel32.dll and is not compiler dependent.  I'd prefer
	to use 'if (IsDebuggerPresent()) DebugBreak();' but
	IsDebuggerPresent() isn't available in all kernel32.dll modules
	for all versions of windows.

2003-12-10  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/CrtImgType.3: Fixed line-transposition error found by Eric
	Raymond. [Bug 857159]

2003-12-03  Don Porter	<dgp@users.sourceforge.net>

	* generic/tk.h:		Bumped patch level to 8.4.5.1 to distinguish
	* unix/configure.in:	CVS snapshots from the 8.4.5 release.
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf (2.13)
	* win/configure:

2003-12-02  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkMenu.c (MenuVarProc): prevent this from triggering
	while interp is being destroyed.

2003-11-21  Benjamin Riefenstahl  <Benjamin.Riefenstahl@epost.de>

	*** 8.4.5 TAGGED FOR RELEASE ***

	* macosx/tkMacOSXKeyboard.c: Add PowerBook keycode 0x34 as
    	<Return>. (Merge from trunk)

2003-11-18  Jeff Hobbs  <jeffh@ActiveState.com>

	* changes: updated for 8.4.5 release

2003-11-17  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkMenubutton.h: fixed compound menubutton handling like
	* generic/tkMenubutton.c: *button corrections of 2003-04-25.
	* mac/tkMacMenubutton.c (TkpDisplayMenuButton): 
	* unix/tkUnixMenubu.c (TkpDisplayMenuButton): 

2003-11-16  Don Porter	<dgp@users.sourceforge.net>

	* win/makefile.vc:	Restored consistency of pkgIndex.tcl file
	with that generated by Makefile.

2003-11-15  David Gravereaux <davygrvy@pobox.com>

	* win/makefile.vc: Fixes pkgIndex.tcl generation so a symbols build
	is loaded when Tcl is symbols.

2003-11-11  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure:
	* unix/tcl.m4: improve AIX --enable-64bit handling

	* generic/tkButton.c (ConfigureButton): abort option processing if
	the button was deleted. [Bug #824479]

	* generic/tkMenuDraw.c (TkPostSubmenu): add {} around menu name in
	case it has spaces when calling Tcl_VarEval.  This is a hack until
	this is rewritten for proper Tcl_Obj handling. [Bug #723856]

	* library/tkfbox.tcl (::tk::dialog::file::Update): optimize the
	dir/files list separation by using the -tails, -directory and
	-type option of 'glob'.  Also passes the glob the -filetypes
	filters instead of calling string match over each file.
	[Patch #833819]
	(::tk::dialog::file::ActivateEnt): allow typing filename into
	entry when tk_getOpenFile -multiple 1 is specified. [Bug #788069]

	* generic/tkListbox.c (ListboxDeleteSubCmd, ListboxListVarProc):
	free itemconfig data when removing it from table. [Bug #836483]

	* macosx/tkMacOSXClipboard.c (TkSuspendClipboard, TkSelGetSelection):
	add unicode clipboard support. [Patch #840107] (senn)

2003-11-10  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinDraw.c (XFillRectangles): correctly handle the
	XGCValues.function parameter when filling rectangles.
	[Bug #820278] [Patch #820282]

	* generic/tkImgPhoto.c (ImgPhotoBlendComplexAlpha): add alpha
	blending for images with partial transparency.  Only operates for
	15bpp+ display, and not on Mac at all. [Bug 809157]

	* win/configure:
	* win/configure.in: define TK_LIB_FLAG, TK_LIB_SPEC,
	TK_BUILD_LIB_SPEC, TK_STUB_LIB_SPEC, TK_STUB_LIB_PATH, and
	TK_BUILD_STUB_LIB_PATH for tkConfig.sh [Bug #826614]

	* unix/Makefile.in (SHLIB_LD_FLAGS): include in Makefile as it is
	used in MAKE_LIB sometimes (ie: AIX-64) [Bug #829686] (jimix)

2003-11-01  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* library/msgs/nl.msg: Updated messages from Arjen Markus and
	Pascal Scheffers.  Thanks!  [Patch 820519]

2003-10-29  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* library/tkfbox.tcl (IconList_Create,IconList_Add): Added option
	munging to allow some control of foreground colours on Unix in the
	same way that you can influence the background.  [Bug 795717]

2003-10-28  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tkUnixFont.c (GetFontAttributes): place extra check for NULL
	family against bad X servers.

	* win/tkWinImage.c (XGetImageZPixmap): add separate 16bpp
	XGetImage code to correctly handle 16bpp requests.  This appears
	to never have worked correctly.

	* tests/focusTcl.test (setup1): expand frame size to allow for
	correct visibility of windows that use larger default fonts.

2003-10-28  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/tk.tcl (::tk::PlaceWindow): Added check for empty string
	first when determining placement strategy. [Bug 819284]

2003-10-22  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/dialog.tcl (tk_dialog): Constrain the dialog to be
	fairly sensibly sized and placed.  [Bug 827535]

2003-10-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkInt.h:      move TkGetOptionSpec to stubs intDecls
	* generic/tkIntDecls.h:
	* generic/tkInt.decls:
	* generic/tkStubInit.c:

	* tests/listbox.test (13.3): correct result size
	(4.7): correct test for possible window drift [Bug #701931] (dgp)

	* unix/mkLinks:
	* doc/GetHWND.3: add Tk_AttachHWND docs [Bug #220803]

2003-10-10  Jeff Hobbs  <jeffh@ActiveState.com>

	* mac/tkMacButton.c (TkpDisplayButton):
	* macosx/tkMacOSXButton.c (TkpDisplayButton):
	* unix/tkUnixButton.c (TkpDisplayButton): correct imageYOffset for
	buttons with just images.

2003-10-09  Jeff Hobbs	<jeffh@ActiveState.com>

	* win/tkWinButton.c (TkpDisplayButton): correct imageYOffset for
	buttons with just images.

2003-10-06  Don Porter	<dgp@users.sourceforge.net>

	* doc/ConfigWidg.3:	Removed reference to Tk_Offset from the
	NAME section to resolve mkLinks conflict with SetOptions.3 [Bug 404197]

	* unix/configure.in:	Reconfigured to use $TCL_PREFIX as the
	default value of --prefix, and also added warning when a TK_PREFIX
	value different from TCL_PREFIX is selected, since [package require Tk]
	fails in that configuration. [Bugs 428627,765642]

	* unix/tcl.m4 (SC_PATH_TCLCONFIG):	Corrected search path so
	that alpha and beta releases of Tcl are not favored. [Bug 608698]

	* unix/configure.in:	Added check that version of Tcl header found
	by configure matches that of the Tk we wish to build.  As long as
	the Tk sources insist on lockstep releases, Tk's configuration should
	verify that's what we have.  [Bug 749088]

	* unix/configure:	autoconf (2.13)
	* unix/mkLinks:		make mklinks

2003-10-03  Don Porter  <dgp@users.sourceforge.net>

	* README:				Bumped to patch level 8.4.5
	* generic/tk.h:				to prepare for next patch
	* macosx/Wish.pbproj/project.pbxproj:	release.
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf (2.13)
	* win/configure:

2003-10-03  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/scale.tcl: Clear bug with chording mouse buttons.

2003-10-01  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj:
	* macosx/Makefile: fixed redo prebinding bug when DESTDIR="".
	Added support for all applicable customizable makefile variables
	from tcl/macosx/Makefile.

	* macosx/README:
	* macosx/Wish.pbproj/project.pbxproj: ensure that the versioned
	wishX.X script works correctly when Tk.framework with multiple
	versions is present by referring to a copy of 'Wish Shell.app'
	located in Tk.framework/Versions/X.X/Resources.

2003-09-29  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* unix/tcl.m4 (SC_ENABLE_FRAMEWORK): Added note to make it clearer
	that this is an OSX feature, not a general Unix feature. [Bug 619440]

2003-09-26  Benjamin Riefenstahl  <Benjamin.Riefenstahl@epost.de>

	* macosx/tkMacOSXWm.c (TkWmStackorderToplevelWrapperMap): Add
	GetWindowFromPort() [Bug #812415]; make function static.

2003-09-25  Daniel Steffen  <das@users.sourceforge.net>

	* library/demos/widget: don't create iconwindow on aqua, but add
	about menu like on classic.
	* macosx/Makefile: pass MAKEOVERRIDES to pxbuild.
	* macosx/tkMacOSXButton.c: added -compound support for bevel buttons.

2003-09-17  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkImage.c:    Stopped [image create] from generating an
	* tests/image.test:     image command name that would overwrite an
	existing command name.  Thanks to Michael Schlenker.  [Bug 808039].

2003-08-19  Joe English  <jenglish@users.sourceforge.net>
	* generic/tkPanedWindow.c(PanedWindowWorldChanged):
	Set window background from the -background resource.
	Fixes [BUG #791500 "PanedWindow refresh glitches on X"]

2003-08-13  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/scale.tcl: Fix for bug #787065 for Button-2 press.
	* tests/scale.test:  Added test for this bug.
	
2003-08-12  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXMenu.c: fixed C99'ism that breaks gcc 2.95.

2003-07-21  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4.4 TAGGED FOR RELEASE ***

	* changes: updated for 8.4.4 release

2003-07-20  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/buildTkConfig.tcl: fix to TK_BUILD_* ref generation
	broken by changes to tcl buildsystem.

2003-07-19  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/scale.tcl: Fix for bug 706765 to correctly handle the 
	-sliderrelief option while moving the thumb.

2003-07-18  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tkUnixFont.c (Tk_DrawChars): do not make XGetGeometry call
	that prevents overwidth lines as it requires a roundtrip call to
	the X server for every string drawn.  Hard-code max width to 32768
	until a beter solution to get max width is made.

	* library/panedwindow.tcl: use widget-specific Priv slots for
	pwAfterId and panecursor items to correctly handle cursor changes
	with adjacant panedwindows.

	* generic/tkEvent.c (Tk_HandleEvent): correct XCreateIC call for
	TK_XIM_SPOT usage. [Bug 742660] (takahashi)

	* win/tkWinCursor.c (TkGetCursorByName): Fix bug 420510 to provide
	consistency between unix and windows -cursor option. (thoyts)

	* win/tkWinDialog.c: doubled the TK_MULTI_MAX_PATH value to ~10K.
	This is a short-term solution until the -multiple option is
	extended.  [Bug 641261]

2003-07-18  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/panedwindow.test (panedwindow-30.2): 
	* generic/tkPanedWindow.c (Tk_PanedWindowObjCmd): Ensure that we
	can share GCs between a panedwindow and its sash proxy, even if
	the panedwindow is in a toplevel with a different visual. [Bug 702230]

2003-07-17  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Makefile: Changes for new tcl buildsystem.

	* macosx/Wish.pbproj/jingham.pbxuser:
	* macosx/Wish.pbproj/project.pbxproj:
	Changes for new tcl buildsystem.
	Changed build to include tk specific html help in Tk.framework
	instead of Tcl.framework.
	Set default SYMROOT in target options to simplify setting up PB
	(manually setting common build folder for tcl & tk no longer needed).

	* macosx/README: Updated info for changes to buildsystem,
	html help location and PB setup.

2003-07-17  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/photo.n: [$photo put] has been able to take rectangles of
	pixel colours, specified as lists of lists, for years.  Now this
	is a documented feature.  [Bug 728952]

	* generic/tkPanedWindow.c (PanedWindowReqProc): Fix from Eric
	Boudaillier so panedwindows get their geometry right even when
	their children don't know their size initially. [Bug 738143]
	* doc/panedwindow.n: Removed sentences about the use of [update
	idletasks] with this command, as that is no longer necessary with
	the fix from Bug 738143. [Bug 747814]

	* generic/tkImgPhoto.c (ImgPhotoCmd): Rewrote subcommand processing
	to never jump to the end of the switch.  I find that confusing as
	I can't see whether there's processing still to be done from a
	quick glance at the code, unlike with a direct return. [Bug 771988]
	(ImgPhotoCmd, ImgPhotoSetSize, ImgPhotoInstanceSetSize): Try harder
	to avoid zero-length mallocs()... [Bug 404421]

2003-07-16  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkPack.c (ConfigureSlaves): silence compiler warning
	[Bug 771982]

2003-07-16  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinImage.c (XGetImage): correct init of biSizeImage in
	bitmap header. [Bug 703697] (cap)

2003-07-17  Peter Spjuth  <peter.spjuth@space.se>

	* tests/frame.test:
	* generic/tkFrame.c (CreateFrame): Make sure all options can be set
	to their default value. [Bug #697652]

2003-07-16  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkPanedWindow.c (ArrangePanes): Ensure that the last pane
	* tests/panedwindow.test: shrinks instead of being clipped when
	resized below the reqsize. [Bug 748277] (spjuth)

	* generic/tkWindow.c (Initialize): do not free uninit'ed dstring.
	[Bug 755906] (mistachkin)

2003-07-15  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/tkUnixEvent.c (TkpCloseDisplay): Don't
	test for XCloseIM bug when the XFree86 version
	is newer than 4.0 since the layout of the
	XIM structure has changed. The check is not
	needed for newer XFree86 releases since
	the bug we are checking for was fixed in
	the 4.2.99.2 release. [Bug 755530]

2003-07-15  Don Porter  <dgp@users.sourceforge.net>

	* README:		Bumped patchlevel to 8.4.4 in preparation
	* generic/tk.h:		for the Tk 8.4.4 release.
	* macosx/Wish.pbproj/project.pbxproj:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf (2.13)
	* win/configure:

2003-07-15  Vince Darley <vincentdarley@users.sourceforge.net>

	* generic/tkMenu.c
	* generic/tkMenu.h
	* generic/tkMenuDraw.c: 
	* tests/menu.test: fixed complex bug in menu clone cleanup
	[Bug#465324] and removed 'knownBug' from a test.
        (This was applied to cvs head on 2003-05-03).
	
2003-07-09  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/send.test: Strengthened constraints to stop accidental
	smashing of Xserver access; some systems (*ahem* mine *ahem*)
	require xhost-style security for all use...  :^/

2003-07-07  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkImage.c (TkDeleteAllImages,etc.): Stopped the deleting
	of hash entries from a table that has just been deleted by this
	function when some images are Tcl_Preserve()d...  [Bug 749353]

2003-05-20  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4.3 TAGGED FOR RELEASE ***

	* changes: updated for 8.4.3

	* unix/Makefile.in: do not run autoconf during 'make dist' as the
	configure is now a CVS-maintained file and should be up-to-date.

2003-05-19  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: changed tkConfig.sh location
	in versioned framework subdirectories to be identical to location
	in framework toplevel; fixed stub library symbolic links to be
	tk version specific.

2003-05-15  Jeff Hobbs  <jeffh@ActiveState.com>

	* README:            Bumped version to 8.4.3
	* generic/tk.h:
	* macosx/Wish.pbproj/project.pbxproj:
	* unix/configure:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure:
	* win/configure.in:

	* unix/tkUnixFont.c: use gb2312-raw as the alias for gb2312*
	charset fonts.  gb2312.enc was made to be euc-cn for Tcl because
	that is what is most often meant, but X really wants the original
	(-raw) gb2312 encoding. [Bug 557030]

2003-05-14  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/msgs/fr.msg: updated msg catalog. [Bug #737790] (zolli)

2003-05-13  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXInit.c (TkpInit): use new versioned bundle 
	resource API to get tk runtime library for TK_VERSION. [Bug 736774]

2003-05-13  Daniel Steffen  <das@users.sourceforge.net>

	backport of Mac OS X specific changes on trunk since 8.4.2:
	
	* macosx/tkMacOSXClipboard.c (TkSelGetSelection): Convert
	'\r' to '\n' on the way into Tcl. (ingham)

	* macosx/tkMacOSXMenu.c (EventuallyInvokeMenu): New function,
	used to invoke menu commands at idle time.
	(TkMacOSXDispatchMenuEvent): Don't immediately dispatch menu
	commands, wait till the idle loop to do so.  This is more like
	what is done on Windows, and avoids the crash from destroying
	a menu in it's command. (ingham)

	* macosx/tkMacOSXHLEvents.c (ReallyKillMe): Don't force the shell
	to exit.  According to the OS X HI guidelines, it should be
	possible to cancel an attempt to quit, and if we force the kill,
	here, it would not be possible to implement this. (ingham)

	* macosx/tkMacOSXApplication.r (removed):
	* macosx/tkMacOSXLibrary.r (removed):
	* macosx/tkMacOSXResource.r (removed):
	* macosx/Wish.pbproj/project.pbxproj:
	* macosx/tkAboutDlg.r: updated copyrights, cleaned up about box,
	removed obsolete unused resource files. (steffen)

2003-05-10  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkCanvPoly.c (PolygonToPostscript):
	* tests/canvPs.test: correct crash when generating postscript for
	a single-line polygon (point) with no color. [Bug #734498] (wilm)

2003-04-30  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/tkMacOSXButton.c (TkpDisplayButton): correct typo for
	stippleGC [Bug #730124].

2003-04-25  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkButton.h:                         Rewrote the handling
	* generic/tkButton.c (TkButtonWorldChanged):  of compound *buttons
	* mac/tkMacButton.c (TkpDisplayButton):       to correctly display
	* macosx/tkMacOSXButton.c (TkpDisplayButton): mixture of disabledfg,
	* unix/tkUnixButton.c (TkpDisplayButton):     selectcolor, indicator,
	* win/tkWinButton.c (TkpDisplayButton):       etc.  *buttons will
	now only stipple the image, unless no disabledfg is given, in which 
	case it will stipple the whole button.

	* library/bgerror.tcl: make bgerror dialog topmost on Windows to
	prevent it being covered by other windows.

	* unix/tkUnixButton.c (TkpDisplayButton): Use the normalTextGc when
	* win/tkWinButton.c (TkpDisplayButton):   displaying disabled text
	that have images, as they get a gray50 stipple as well and the
	disabledGc is not set up correctly for font drawing. [Bug #477740]

2003-04-18  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkCanvBmap.c: s/CreateBitmap/TkcCreateBitmap as Windows
	has a CreateBitmap function already.

	* generic/tkCursor.c: s/GetCursor/TkcGetCursor as Windows has a
	GetCursor func already, which causes compiler warnings.

2003-04-02  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/configure: Regen.
	* win/configure.in: Set stub lib flag based
	on new LIBFLAGSUFFIX variable.
	* win/tcl.m4: Update from Tcl to get new
	LIBFLAGSUFFIX variable.

2003-04-02  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/configure: Regen.
	* win/configure.in: Don't set TCL_DLL_FILE,
	TCL_LIB_FILE, TCL_STUB_LIB_FILE, TCL_STUB_LIB_FLAG,
	and TCL_BUILD_STUB_LIB_SPEC. These variables are
	already set in tclConfig.sh.
	[Bug 691908]

2003-03-22  Kevin Kenny  <kennykb@acm.org>

	* win/makefile.vc:
	* win/rules.vc: Corrected several problems that prevented
	OPTS=symbols from building properly. [Patch 707792] Thanks
	to Joe Mistachkin for the fixes.
	
2003-03-18  Don Porter  <dgp@users.sourceforge.net>

	* tests/unixWm.test (unixWm-41.2): Corrected typo in 2003-03-13
	commit.  Thanks Larry Virden.  [Bug 705567]

2003-03-18  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj:
	* macosx/Makefile:
	* macosx/README: added support for giving 'make' the location
	of Tcl.framework and tclsh to build and link against.

	* macosx/tkMacOSXXStubs.c: fixed crash in [winfo server].

2003-03-14  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/msgbox.tcl (Tk::MessageBox): Stop buttons from being
	very wide when a messageBox has a lot of content. [Bug #701812]

2003-03-13  Don Porter  <dgp@users.sourceforge.net>

	* tests/unixWm.test:  Constrained all tests older than revision 1.21
	to run only on Unix.  Alternative approach did not match maintainer
	habits.
	* tests/spinbox.test (spinbox-17.4): Avoid long failure message.

2003-03-13  Kevin Kenny  <kennykb@users.sourceforge.net>

	* win/makefile.vc: Backed the version to 8.4 on the 8.4 branch.
	(I just loathe sticky tags).
	
2002-03-11  Kevin Kenny  <kennykb@users.sourceforge.net>

	* win/makefile.vc: Backported the code that makes the makefile
	build pkgIndex.tcl as part of the install step.
	
2003-03-03  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4.2 TAGGED FOR RELEASE ***

2003-02-28  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/bind.test (bind-16.44): 
	* generic/tkBind.c (ExpandPercents): Only allow events to see
	those expansions that are actually valid for them, and force the
	substitution of the rest as "??".  This stops some crashes on
	Windows and gets rid of bogus values everywhere.  [Bug #612110]

2003-02-26  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/README: correct 8.4.3 refs to 8.4.2.

	* unix/README: replace version refs with version-agnostic wording.

2003-02-25  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinInt.h:
	* win/tkWinDraw.c:
	* win/tkWinFont.c (Tk_DrawChars): add support for simple XOR text
	drawing on Windows. [Patch #685388] (martin)

	* generic/tkMenu.c (TkMenuCleanup): make sure to reset static
	menusInitialized on finalize. [Bug #548729]

2003-02-25  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXHLEvents.c: fixed conversion of apple event
	parameters to posix style path names.
	[Bug #621672] (steffen, Benjamin Riefenstahl) 

	* macosx/tkMacOSXDialog.c: 
	* macosx/tkMacOSXWm.c:
	* macosx/Wish.pbproj/project.pbxproj:
	* macosx/tkMacOSXUtil.c (removed):
	* macosx/tkMacOSXUtil.h (removed): removed all references to
	tkMacOSXUtil.{c,h}, made obsolete by the patch above. [Bug #621672]
	
2003-02-24  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tkUnixFont.c (CreateClosestFont, CanUseFallback): use the
	first best font match in user font path. [Bug #647497] (dal zotto)

	* generic/tkListbox.c (ListboxSelectionSubCmd): 
	* tests/listbox.test: Allow 'selection includes' to respond when
	disabled (but only 'includes'). [Bug #632514]

	* unix/tkUnixButton.c (TkpDisplayButton): Correct visual display
	of disabled check/radiobutton to be more distinctive on unix.
	* tests/unixButton.test: [Bug #669595] (hintermayer)

	* doc/panedwindow.n: clarified the need to use 'update idle' when
	adding unmapped windows.  Needs further examination. [Bug #605105]

	* generic/tkEntry.c (SpinboxWidgetObjCmd, EntryWidgetObjCmd):
	* tests/entry.test:   return 1 if selection is present even if
	* tests/spinbox.test: entry/spinbox is disabled, as selection get
	will still return the selection (although selection still ignore
	modify requests when entry/spinbox is disabled). [Bug #637828]

2003-02-24  Benjamin Riefenstahl  <Benjamin.Riefenstahl@epost.de>

	* tkMacOSXDialog.c (NavServicesGetFile): Fix bug with
	kNavCtlSetSelection - control data should be a pointer
	not a handle.
	
2003-02-21  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/clrpick.tcl (color::BuildDialog): 
	* library/msgbox.tcl (MessageBox): Yet more places that did
	complex and fragile width calculations instead of using grid,
	though with these it is the -uniform option that saves the day.

	* library/tkfbox.tcl (file::Create): This procedure was really
	very crufty in how it went about creating the GUI.  It is far
	easier and more robust to use the grid geometry manager than it is
	to tune the results of pack with tweaks to -width.  [Bug #673722]

	* library/comdlg.tcl (FDGetFileTypes): Set an upper limit on how
	long a file type item description string can get due to appending
	of types. [Bug #617392]

	* tests/panedwindow.test (panedwindow-30.1): 
	* generic/tkPanedWindow.c (DisplayPanedWindow, DisplayProxyWindow): 
	Use the window's depth, not the screen's default depth. [Bug #671122]

2003-02-20  Daniel Steffen  <das@users.sourceforge.net>

	* library/console.tcl: (aqua & macintosh) added missing <Cmd-q>
	binding for corresponding Quit menu item shortcut.

	* macosx/README: updated instructions for embedded build, 
	added various improvements by Russell Owen.

	* unix/tcl.m4: update from Tcl.
	* unix/configure: regen.

2003-02-20  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinScrlbr.c (UpdateScrollbar): use SIF_DISABLENOSCROLL to
	"disable" scrollbar when on Windows when there is nothing to
	scroll.  This is Windows style, and fixes [Bug #624116].

	* tests/panedwindow.test: 
	* generic/tkPanedWindow.c (ValidSashIndex): corrected to note that
	2 panes must exist before any one sash does. [tcllib Bug #689258]

2003-02-20  Peter Spjuth  <peter.spjuth@space.se>

	* tests/panedwindow.test:
	* generic/tkPanedWindow.c: Fixed calculation of the last slave's
	size when increasing the size of the panedwindow. [Bug #689099]

2003-02-20  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkImgGIF.c (GetDataBlock): Removed pointless static
	variable ZeroDataBlock [Bug #664788]

	* unix/tkUnixFont.c (CanUseFallback): Added argument, passed
	through from callers to FindSubFontForChar(), so that pointers
	into the old subfont table to be updated when that table is
	reallocated, avoiding a (sometimes fatal) FMR.
	[Bugs #618872 and #689357]

2003-02-19  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXKeyEvent.c: fix for uninitialized var warning.

2003-02-19  Jim Ingham <jingham@apple.com>

	* macosx/tkMacOSXMouseEvents.c (GeneratePollingEvents): In the case
	where there was a capture window, we were sending the events to
	the capture window.  But the capture window (return value or
	TkMacOSXGetCapture) is always a toplevel.  So this is wrong in 
	the case that the Event's toplevel IS the capture window - in
	which case the event should go to the subwindow most closely
	containing the event.
	
2003-02-19  Benjamin Riefenstahl <Benjamin.Riefenstahl@epost.de>
	       & Jim Ingham <jingham@apple.com>

	This patch changes the default Tk behavior so that events
	are by default routed to the standard event handlers after
	Tk has looked at them.
	
	* macosx/tkMacOSXEvent.h: Rename "handledByTk" into
	"stopProcessing".
	
	* macosx/tkMacOSXEvent.c: Update erroneous comments and
	remove unused includes.
	(TkMacOSXProcessAppleEvent): Don't declare events
	handled that we didn't even look at.
	(TkMacOSXProcessEvent): Add a comment on policy for
	"stopProcessing".
	(TkMacOSXProcessEvent): Remove "handling" of events that	
	are not our business.
	(TkMacOSXProcessEvent): Rename "handledByTk" into
	"stopProcessing".
	(ReceiveAndProcessEvent): Ditto.
	(ReceiveAndProcessEvent): Tune error production of
	message.
	
	* macosx/tkMacOSXKeyEvent.c (TkMacOSXProcessKeyboardEvent):
	Rename "handledByTk" into "stopProcessing".
	
	* macosx/tkMacOSXWindowEvent.c: Ditto.

	* macosx/tkMacOSXMouseEvent.c: Remove setting of
	"handledByTk".
	(TkMacOSXProcessMouseEvent): Handle clicks in the "traffic
	lights" in the window title when the window (or app) is
	in the background.


	This patch changes the key event handling to use the MacOS
	translation mechanisms.  It also improves dead key handling.
	
	* macosx/tkMacOSXKeyEvent.c (InitKeyData): Add.
	(InitKeyEvent): Add.
	(DecodeViaUnicodeResource): Rename
	KeycodeToUnicodeViaUnicodeResource.
	(DecodeViaKCHRResource): Rename KeycodeToUnicodeViaKCHRResource.
	(GetKeyboardLayout): Use a boolean flag instead of a special
	layout id.

	(KeycodeToUnicodeViaUnicodeResource): Change interface and
	implementation to return a Unicode string instead of directly
	filling an XEvent.
	(KeycodeToUnicodeViaKCHRResource): Ditto.
	(KeycodeToUnicodeViaUnicodeResource): Add handling for callers
	that don't want deadkey processing (i.e. XKeycodeToKeysym).
	(KeycodeToUnicodeViaKCHRResource): Ditto.
	(KeycodeToUnicodeViaUnicodeResource): Clear deadKeyState if a
	character was produced.
	(KeycodeToUnicodeViaKCHRResource): Use CFString and current
	keyboard encoding instead of Tcl Tcl_ExternalToUtf() and fixed
	TkMacOSXCarbonEncoding.
	(TkMacOSXKeycodeToUnicode): Add.
	
	(TkMacOSXProcessKeyboardEvent): Add some heuristics to improve
	keyup events.
	(deadKeyState): Split into deadKeyStateUp and deadKeyStateDown.
	(GenerateKeyEvent): Change interface and implementation to accept
	a Unicode string instead of individual characters.
	(GenerateKeyEvent): Don't generate string representations for
	special characters. 

	* macosx/tkMacOSXEvent.h (TkMacOSXKeycodeToUnicode): Add
	prototype. 

	* macosx/tkMacOSXKeyboard.c (KCHRPtr): Remove.
	(XKeycodeToKeysym): Use TkMacOSXKeycodeToUnicode instead of
	KeyTranslate.
	(XKeycodeToKeysym): Support latin-1 keysyms.

	This patch reverts the hack to put icons in menus that Vince put
	in yesterday (but preserves the bug fix in that submission.)

	* macosx/tkMacOSXMenu.c (SetMenuTitle): revert treating 
	"<bullet> number" as a request to put icon number <number> in
	the menu.
	
2003-02-18  Mo DeJong  <mdejong@users.sourceforge.net>

	* doc/entry.n:
	* doc/text.n: Update double and triple click
	docs to match implementation changes made on
	2002-02-14.
	
2003-02-19  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj:
	* macosx/Makefile: reworked embedded build to no longer require
	relinking but to use install_name_tool instead to change the
	install_names for embedded frameworks. [Bug #644510]

2003-02-19  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/demos/widget:		New part for the widget demo showing
	* library/demos/unicodeout.tcl: Tk's UNICODE output. [Patch #627453]

2003-02-18  Andreas Kupries  <andreask@activestate.com>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl (HP xnet [Bug #651811]).

2003-02-18  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.

2003-02-18  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkText.c (TextWidgetCmd): remove unused lastEnd var.
	[Bug #664790]

	* generic/tkCanvPs.c (TkPostscriptImage): remove unused depth var.
	[Bug #664787]

	* generic/tkEntry.c (EntrySetValue): removed unused code var.
	[Bug #664781]

	* library/tk.tcl (::tk::TabToWindow): auto-highlight spinboxes as
	well as entries when tabbing in. [Patch #683813] (bron)

	* library/xmfbox.tcl (::tk::MotifFDialog_ActivateSEnt): correct
	sub on embedded newlines. [Patch #688572] (bonfield)

	* doc/colors.n: corrected B values [Bug #682714].

	* win/tkWinInit.c (TkpDisplayWarning): truncate MessageBox string
	to 1024 chars to prevent possible oversized window errors.  May be
	necessary in other MB uses (ie Tcl_AppInit). [Tcl Bug #608559]

2003-02-18  Vince Darley <vincentdarley@users.sourceforge.net>

	* macosx/tkMacOSXMenu.c: (SetMenuTitle) fix to utf encoding
	problem when setting menu titles, and provisional support
	for icons. [Tcl Bug #625080]

2003-02-18  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkImgGIF.c (FileReadGIF): Ensure that the trashBuffer is
	always deallocated on function exit to stop a potential memory leak.

2003-02-17  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkEvent.c (Tk_HandleEvent): Fixup button
	press state saving code, it was incorrectly converting
	normal motion events into button press and motion
	events in some cases.
	* generic/tkInt.h: Add mouseButtonWindow member
	to the TkDisplay structure.
	* tests/event.test: Add test case for faulty
	button motion logic.

2003-02-14  Jeff Hobbs  <jeffh@ActiveState.com>

	* README:             Bumped to 8.4.2.
	* generic/tk.h:
	* macosx/Wish.pbproj/project.pbxproj:
	* unix/configure:
	* unix/configure.in:
	* unix/tcl.m4:
	* unix/tk.spec:
	* win/configure:
	* win/configure.in:

	* unix/tcl.m4: correct HP-UX ia64 --enable-64bit build flags

2003-02-13  Kevin Kenny  <kennykb@users.sourceforge.net>

	* doc/wish.n: Added language to describe the handling of
	the end-of-file character \u001a in script files. [Bug 685505]
	
2003-02-10  Jim Ingham <jingham@apple.com>

	* macosx/tkMacOSXCursor.c (TkMacOSXInstallCursor): Set all theme
	cursors using SetThemeCursor or SetAnimatedThemeCursors.
	(TkGetCursorByName): Use the theme cursors for arrow, ibeam, etc.
	Allow animatedCursor{NUM} form for an animated cursor with count.
	(TkpSetCursor): Don't reset the cursor if there is no change.
	* macosx/tkMacOSXMouseEvent.c (GeneratePollingEvents): Don't
	directly call TkMacOSXInstallCursor, it gets called by the call
	to Tk_UpdatePointer immediately above.
	
2003-02-05  Fred Fish  <fnf@intrinsity.com>

	* macosx/tkMacOSXWm.c (Tk_SetGrid): Fix precedence problem with
	* mac/tkMacWm.c (Tk_SetGrid):       '==' and '|'.

2003-02-08  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkCanvArc.c (CreateArc):       Rework canvas create item
	* generic/tkCanvBmap.c (CreateBitmap):   type coords handling to be
	* generic/tkCanvImg.c (CreateImage):     consistent across types
	* generic/tkCanvPoly.c (CreatePolygon):  and not pass empty coords
	* generic/tkCanvLine.c (CreateLine):     to item creation procs.
	* generic/tkCanvText.c (CreateText):
	* generic/tkCanvWind.c (CreateWinItem):
	* generic/tkCanvas.c (CanvasWidgetCmd CANV_CREATE):
	* generic/tkRectOval.c (CreateRectOval):
	* tests/canvRect.test:
	* tests/canvText.test:
	* tests/canvas.test:

2003-01-28  Joe English  <jenglish@users.sourceforge.net>

	* generic/tkInt.h (TkDisplay,TkMainInfo):
	* generic/tkObj.c (windowObjType):
	* generic/tkWindow.c (Tk_DestroyWindow):
	* tests/wm.test (wm-deletion-epoch-1.1):
	Moved 'deletionEpoch' field from TkDisplay to TkMainInfo.
	Reworked windowObj type.  Fixes Tk Bug #671330 "segfault when e.g.
	deiconifying destroyed window"

2003-01-23  D. Richard Hipp  <drh@hwaci.com>

	* library/entry.tcl: Fix the KeyPress binding on the entry widget
	so that it enters text from left to right (not right to left) even
	if the mouse button is being held down.  [Bug #673687]

2003-01-22  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkFrame.c (TkToplevelWindowForCommand): Added way of
	mapping from command names to tkwins-for-toplevels.
	* generic/tkImage.c (Tk_ImageObjCmd): Added check to make sure
	that you're not creating an image named the same as .'s command,
	which refixes 220891, even when the name of the command has been
	changed with 'rename'.  The error message is better too.
	* tests/image.test (image-1.10,image-1.11): Updated to match new
	error message and added test for the rename case.

2003-01-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkImage.c (DeleteImage): delete the image's entry in the
	image table correctly when there are no more instances.  This
	reopens bug 220891. [Bug #669759]

2003-01-18  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/loadTk.n: note that ::safe::loadTk has a prereq on
	::safe::interpCreate or ::safe::interpInit. [Bug #669159]

	* doc/photo.n: $image put only accepts -format and -to, and note
	extended use of -to.

2003-01-17  D. Richard Hipp <drh@hwaci.com>
	* generic/tkCanvUtil.c: The clipping algorithm introduced on 2003-01-08
	was unnecessarily aggressive in reducing the size of the clipping box.
	This did not cause a problem for normal display, but did create
	trouble for some extensions that attempt to render a canvas on a
	GDI printer under Windows.  The patch here relaxes the constraints on
	the clipping box somewhat.  [Bug #663981]

2003-01-14  Joe English  <jenglish@users.sourceforge.net>
	* generic/tkSelect.c (Tk_CreateSelHandler):
	Fix for #666346 "Selection handling crashes under KDE 3.0"
	* tests/unixSelect.test (unixSelect-1.20): Added test case.

2003-01-13  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinDialog.c (Tk_ChooseDirectoryObjCmd,
	ChooseDirectoryValidateProc, Tk_MessageBoxObjCmd):
	Remove unused tsdPtr variable. Use TEXT macro
	instead of _T macro since _T does not work
	under Cygwin. Declare flags as UINT to avoid
	compiler warning when compiling with mingw.

2003-01-12  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/Makefile.in: Add TCL_DEFS to AC_FLAGS
	so that compiler flags defined by Tcl get
	passed to the compiler. Add empty rule
	for cat.c so that Tk compiles under msys.
	* win/configure: Regen.
	* win/tcl.m4: Update from Tcl, this pulls
	in a subst of TCL_DEFS, it also defines
	USE_THREAD_ALLOC when threads are used
	and it updates the SC_ENABLE_SYMBOLS
	and SC_PROG_TCLSH macros to match the
	ones used in Tcl.

2003-01-10  Joe English  <jenglish@users.sourceforge.net>

	* unix/tkUnixEvent.c (OpenIM): Remove unused variable
	(Fixes: #664780 "SGI warning: OpenIM")

2003-01-08  D. Richard Hipp <drh@hwaci.com>

	* generic/tkCanvLine.c:
	* generic/tkCanvas.h:
	* generic/tkCanvUtil.c: Clip long lines so that they will display
	properly even on windowing systems where coordinates are expressed
	as 16-bit numbers.  [Bug #663981]

2003-01-03  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkFrame.c (CreateFrame): throw a Tcl error instead of a
	panic when we cannot get a main window and appname is NULL.  This
	can indicate that a user tried to create a frame/toplevel while Tk
	was dying. [Bug #661792]

2002-12-27  David Gravereaux <davygrvy@pobox.com>

	* generic/tkText.h: ANSI unfriendly typedef for TkTextBTree
	repaired for C++ compilers.

2002-12-27  Joe English  <jenglish@users.sourceforge.net>

	* unix/tkUnixWm.c (WaitForEvent): process Map and Unmap events
	as well as Configure events during WaitFor{Configure|Map}Notify.
	Fixes [Bug 578569] (WaitForMapNotify could process Map and Unmap
	events out of order, making Tk think a window was unmapped when
	it really wasn't).

2002-12-18  Todd M. Helfter  <tmh@purdue.edu>

	* doc/label.n: Fixed documentation of the -compound option to
	the label widget.  The option was simply missing from the
	man page [Bug 577540]

2002-12-17  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/photo.n: Fixed documentation of the put subcommand to no
	longer talk about files and to mention that you can use colour
	names for working with solid colours.  [Bug 640026]

2002-12-13  Don Porter <dgp@users.sf.net>

	* generic/tkMain.c (Tk_Main):  Call on Tcl*StartupScript*() routines
	to store the startup script, if any.  [Bug 616245].

2002-12-10  David Gravereaux  <davygrvy@pobox.com>

	* win/makefile.vc: tclThreadTest.obj not required to link
	tktest.exe [Bug 651396]

2002-12-08  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkEntry.c (ConfigureEntry): keep a flag to indicate when
	a var is traced to prevent double-traces caused by configuring the
	widget in traces with validation on. (dejong)

2002-12-07  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkInt.decls: add TkWinSetHINSTANCE decl
	* generic/tkIntPlatDecls.h: regen
	* generic/tkStubInit.c: regen
	* win/tkWinInit.c (TkpInit):  While init and cleanup aren't correct
	* win/tkWinX.c (TkWinXInit):  in DllMain, we had to specify the
	* win/tkWin32Dll.c (DllMain): true HINSTANCE or the resources of a
	dynamic Tk weren't being loaded correctly.  Created a new function
	TkWinSetHINSTANCE for this purpose.

2002-12-06  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinX.c (TkWinXInit):      Move cleanup into an exit handler
	* win/tkWin32Dll.c (DllMain):     to ensure that it will be called
	* win/tkWinWm.c (TkWinWmCleanup): without having to unload the dll.
	Also reset the static int initialized on cleanup to allow reinit.

2002-12-01  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/event.test (_keypress, _text_ind_to_x_y): Force focus to
	widget in _keypress method to avoid problems with window managers
	that use focus follows mouse. [Bug 526209]

2002-12-01  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/wm.test: Add wm-transient-6.3 to check that a transient
	remains withdrawn when it is first withdrawn and then turned into
	a transient.
	* unix/tkUnixWm.c:
	* win/tkWinWm.c: Replace WM_TRANSIENT_WITHDRAWN with WM_WITHDRAWN
	and set this flag whenever a window is explicitly withdrawn. This
	fixes the test case added above. [Bug 644356]

2002-11-22  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/textDisp.test:
	* generic/tkTextDisp.c (TkTextSeeCmd): handle see for unmapped
	text displays. [Bug #641778]

2002-11-19  Jim Ingham <jingham@apple.com>

	* macosx/tkMacOSXScrlbr.c (TkpDisplayScrollbar): If the
	scrollbar width is set to 12 or less (but 12 is what you 
	should use) use the small metric scrollbar.

	(UpdateControlValues): Fix thinko in setting off AUTO_ADJUST for
	the place geometry manager.
	
2002-11-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/Makefile.in: add macosx/*.tcl (buildTkConfig.tcl in
	particular) to the dist target.

2002-11-14  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkWindow.c (Tk_DestroyWindow, DeleteWindowsExitProc):
	Add TkHalfdeadWindow type and halfdeadWindowList to keep track of
	windows that were only partially deallocated before a call to
	exit. Finish cleaning up these windows in DeleteWindowsExitProc.
	Keep track of cleanup status in Tk_DestroyWindow so that a window
	with a Destroy binding which calls exit will get fully destroyed.
	* tests/window.test: Add Tk_DestroyWindow tests for an assortment
	of half dead window cases. [Bug 630533]

2002-11-10  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: fixed erroneous
	removal of libtkstub before Wish was built.

2002-11-07  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/unixWm.test: Add short delay to test unixWm-51.7
	to account for raise/lower changes in TIP 107. This allows
	the test case to pass under Window Maker on Linux.

2002-11-07  Peter Spjuth  <peter.spjuth@space.se>

	* tests/place.test:
	* generic/tkPlace.c: place info did not return all settings,
	and didn't make sure the result was a proper list.
	Put '-in' first in result to be more consistent with how
	grid/pack info behaves. [Bug #635025][Bug #532022]

2002-11-07  Daniel Steffen  <das@users.sourceforge.net>

	* unix/Makefile.in: added macosx/README to dist target.
	* macosx/Wish.pbproj/project.pbxproj: fix to 'wish' script
	to allow it to work when not installed into '/'.

2002-11-06  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.
	* win/configure: Regen.
	* win/configure.in: Check that AR, RANLIB, and RC
	are found on the path when building with gcc.

2002-11-04  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: added Wish linker flag
	-headerpad_max_install_names to allow use of 'install_name_tool'.
	fixed tkConfig.sh generation and redo_prebinding in the case where
	Tk is not installed alongside Tcl.

2002-11-03  David Gravereaux <davygrvy@pobox.com>

	* win/winMain.c (Tcl_AppInit): Calls Registry_Init() and
	Dde_Init() when STATIC_BUILD and TCL_USE_STATIC_PACKAGES macros
	are set.

	* win/makefile.vc:  linkexten option now sets the
	TCL_USE_STATIC_PACKAGES	macro which also adds the registry and
	dde static lib files to the link of the shell. [Patch 479697]

	* win/rules.vc: Matches the one from Tcl.

	* win/buildall.vc.bat: More useful commentary.

2002-11-01  Andreas Kupries  <andreask@activestate.com>

	* win/makefile.vc (TCLREGLIBNAME): Updated to registry 1.1.

2002-10-29  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/README: added info on new package searching in
	Frameworks directories.
	
2002-10-22  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4.1 TAGGED FOR RELEASE ***

	* changes: updated for 8.4.1 release

2002-10-21  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/README: revised according to Jim's suggestions
	* macosx/tkMacOSXAppInit.c: use standard PATH_MAX from <limits.h>
	
2002-10-18  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/winMain.c (WinMain, main): remove obsolete SetMessageQueue call

	* win/configure: Regen. 
	* win/tcl.m4 (SC_CONFIG_CFLAGS): Check for bug in Cygwin version
	of windres and work around that case by passing a POSIX path
	instead of a Windows native path. One can't always pass a POSIX
	path because the mingw native toolchain accepts only Windows
	native paths. (dejong)

	* win/tkWinPort.h: define OPEN_MAX only if not defined.
	[Patch #625472] (howell)

2002-10-18  Daniel Steffen  <das@users.sourceforge.net>

	* mac/tkMacAppInit.c: removed tcltest dependency.
	[Bug #592639] (porter)

2002-10-17  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/imgPhoto.test:
	* generic/tkImgPhoto.c (ImgPhotoConfigureMaster): fix arg handling
	for missing -format or -data options. [Bug #624974]

	* tests/text.test:                    properly return the number of
	* unix/tkUnixFont.c (ControlUtfProc): bytes consumed. [Bug #624732]

2002-10-17  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/README: info specific to building and running
	TclTk on Mac OS X, answers to tcl-mac list FAQs.
	* macosx/Makefile: permission fix after embedded install.
	* macosx/Wish.pbproj/project.pbxproj: after install, fix
	permissions of uninstalled products.

2002-10-17  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: added TEXT document
	type to plist so that files can be dragged onto Wish Shell.

	* macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXFont.c: added private proc
	TkMacOSXUseAntialiasedText() to enable/disable quickdraw
	text antialiasing where available, default is enabled.
	Added a linked boolean ::tk::mac::antialiasedtext with
	write trace to allow control of antialiasing from tcl.

2002-10-16  Vince Darley  <vincentdarley@users.sourceforge.net>

	* macosx/tkMacOSXMenu.c: fix to accelerators shown in menus
	with non-alphanumeric keys.
	* macosx/tkMacOSXKeyEvent.c: 
	* macosx/tkMacOSXKeyboard.c: applied first patch from [Patch
	#622582] to fix some of [Bug #616988].  Further work is needed
	in this area, but this will let foreign keyboards at least work
	reasonably with Tk.

2002-10-15  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure:
	* unix/tcl.m4: add AIX-5 ppc build support. Remove unused
	SC_ENABLE_MEMDEBUG.

	* win/configure:
	* win/tcl.m4: Add --enable-shared=mem support.

2002-10-10  Peter Spjuth  <peter.spjuth@space.se>

	* tests/grid.test:
	* generic/tkGrid.c: The grid size was not updated properly
	when removing a widget from a grid. [Bug #621241] (forssen)

2002-10-10  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/canvPs.test: tests for canvas embedded window ps generation
	* generic/tkCanvWind.c (CanvasPsWindow): removed dead code loop.
	* generic/tkCanvas.h: moved TkColormapData struct to tkCanvPs.c
	* generic/tkCanvPs.c (TkImageGetColor): corrected bogus use of
	TkColormapData on Windows (Windows now requires RGB pixel data
	from image).
	* win/tkWinImage.c (XGetImage, XGetImageZPixmap): added support
	for generating ps for embedded widgets on canvases on Windows,
	tested for 8, 16, 24 and 32-bit depths (XGetImageZPixmap not used).

	* library/tk.tcl: simplified the adding of extra <ISO_Left_Tab>
	and <hpBackTab> events to <<PrevWindow>>.

2002-10-09  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/README: doc'ed --enable-symbols options.
	* unix/Makefile.in: comment docs
	* unix/configure: regen
	* unix/tcl.m4: replaced SC_ENABLE_MEMDEBUG with a more intelligent
	SC_ENABLE_SYMBOLS that takes yes|no|mem|all as options now.

2002-10-09  Don Porter <dgp@users.sf.net>

	* generic/tk.h:  Added reminder comment to edit
	macosx/Wish.pbproj/project.pbxproj when version number changes.

2002-10-09  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Makefile: don't remove tclsh after building embedded.
	
	* macosx/Wish.pbproj/project.pbxproj: bumped version to 8.4.1;
	added missing library/mkpsenc.tcl to framework.

2002-10-09  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkInt.decls(tkIntXlib): added XQueryTree declaration for
	mac & aqua, since it's now called from ParentXId via Tk_HandleEvent.
	* generic/tkIntXlibDecls.h:
	* generic/tkStubInit.c: regen.
	* mac/tkMacXStubs.c: added XQueryTree stub

	* mac/tkMacEmbed.c (TkpUseWindow): check that container window
	has -container option set (sync with other platforms).

	* mac/tkMacBitmap.c:
	* mac/tkMacFont.c: 
	* mac/tkMacSend.c: 
	* mac/tkMacTest.c: 
	* mac/tkMacWm.c: CONSTification.

	* mac/tkMacProjects.sea.hqx: added tkStyle.c and tkUndo.c to
	tk library projects.

2002-10-09  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkImgPhoto.c (ImgPhotoSetSize): Only error-out if we
	fail to allocate a non-empty buffer; getting a NULL when we
	allocate an empty buffer is no problem since nothing will look at
	the value anyway. [Bug 619544]
	Also tidied up file to take into account the fact that we're using
	32 bits per pixel in the master to accommodate the alpha channel
	as well as RGB.

2002-10-08  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/winButton.test: add option clear to top to prevent option
	leakage from other tests causing problems. [Bug #582382]

	* generic/tkPanedWindow.c (Tk_PanedWindowObjCmd): leave the
	DestroyPanedWindow proc to free the pwPtr, add a Preserve
	reference to the pwPtr->tkwin.
	(DestroyPanedWindow): Release the pwPtr->tkwin.

	* generic/tkFocus.c (TkFocusFilterEvent): Ignore event if we are
	focusing into a dead window. [Bug #588831] (griffin)

2002-10-02  Jim Ingham  <jingham@apple.com>

	* macosx/tkMacOSXScrlbr.c (TkpDisplayScrollbar): Put the Tk scrollbar
	pointer into the control reference data for the Mac scrollbar, so we
	can get it out again in the ScrollbarActionProc.

2002-10-02  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkText.c (TextBlinkProc): don't blink the cursor unless
	it is visible. [Bug #616791] [Patch #614474] (bonfield)

	* tests/entry.test: added entry-20.7
	* generic/tkEntry.c (EntryTextVarProc): check if the entry is
	being deleted before handling an associated textvariable.
	[Bug #607390 #617446]

2002-10-01  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/unixSelect.test (unixSelect-1.1[89]): Altered these tests
	to work around [Bug #616923]
	* unix/tkUnixSelect.c (SelRcvIncrProc,TkSelPropProc): It turns out
	a much simpler and more robust solution is possible if we leverage
	Tcl's encoding engine by using the same code path as for the
	normal string selection.  It might be a bit slower, but it should
	be a lot more correct.  [Bug #614650]

2002-09-30  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/panedwindow.test: added panedwindow-28.[12]
	* generic/tkPanedWindow.c (PanedWindowCmdDeletedProc): 
	(Tk_PanedWindowObjCmd): when destroying the panedwindow, destroy
	the proxy before the parent to avoid dependency conflicts.
	[Bug #616589]

2002-09-30  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/unixSelect.test: Test for various things that can fail to
	work in 8.4.0...
	* unix/tkUnixSelect.c (TkSelPropProc,SelRcvIncrProc): Incremental
	transfers of UTF8_STRING selections should now work; Tk will now
	tag them with the right size and only transfer complete UTF8
	characters.  Previously, things only worked when the transfer
	could only happen in one go, and even then not always. [Bug 614650]

	* doc/bind.n: Doc-fix to mention that %A substitutes UNICODE
	characters rather than ASCII ones.  Tk's done this ever since 8.1
	in any case; after all, it is the right thing to do.

2002-09-27  Don Porter <dgp@users.sf.net>

	* README:		Bumped to version 8.4.1 to avoid confusion
	* generic/tk.h:		of CVS snapshots with release 8.4.0.
	* unix/README:
	* unix/configure.in:
	* unix/tk.spec
	* win/configure.in:

	* unix/configure:	autoconf
	* win/configure:

2002-09-26  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure: regen.
	* unix/tcl.m4: improve AIX-4/5 64bit compilation support.

	* unix/Makefile.in: add macosx subdir to dist target.
	Do not generate .Z, only .gz and .zip in alldist target.

2002-09-18  Mumit Khan  <khan@nanotech.wisc.edu>

	Added basic Cygwin support.

	* win/tcl.m4 (SC_PATH_TCLCONFIG): Support one-tree build.
	(SC_PATH_TKCONFIG): Likewise.
	(SC_PROG_TCLSH): Likewise.
	(SC_CONFIG_CFLAGS): Assume real Cygwin port and remove -mno-cygwin 
	flags.  Add -mwin32 to extra_cflags and extra_ldflags.
	Remove ``-e _WinMain@16'' from LDFLAGS_WINDOW.
	* win/configure: Regenerate.

	* win/tkWinPort.h (tchar.h): Do not include on Cygwin.
	(_T): Define for Cygwin.
	* win/winMain.c (main): Conditionally define.

2002-09-26  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Makefile: preserve environment value of INSTALL_ROOT.
	When embedding only use deployment build. Force relink before
	embedded build to ensure new linker flags are picked up.

	* macosx/buildTkConfig.tcl (new):
	* macosx/Wish.pbproj/project.pbxproj: synthesize tkConfig.sh
	based on tclConfig.sh in Tcl.framework and tkConfig.sh.in.
	Add symbolic links to debug lib, stub libs and tkConfig.sh
	in framework toplevel. Made tkIntXlibDecls.h a public header
	since Headers/X11/Xlib.h includes it. Install wish8.4 script
	that runs "Wish Shell.app" and corresponding wish link.
	Use tcl headers from built Tcl.framework instead of from tcl
	source directory.

	* macosx/tkMacOSXPort.h: added missing standard unix includes 
	and defines, similarly to tkUnixPort.h.
	* macosx/tkMacOSXNotify.c: removed dependency on internal tcl
	header "tclPort.h"

	* unix/Makefile.in:
	* unix/install-sh: copied support for 'install-strip' target
	over from tcl/unix/{Makefile.in,install-sh}

2002-09-22  Jim Ingham <jingham@apple.com>

	* macosx/tkMacOSXScrlbr.c (UpdateControlValue): HiliteControl
	doesn't give the proper "nothing to scroll" look on Mac OS X.
	You have to set the min value greater than the max value to
	get this.

2002-09-15  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.
	* unix/tkUnixEvent.c (TkpCloseDisplay): Use PEEK_XCLOSEIM
	to examine the input context queue before invoking
	XCloseIM. Generate an assert if there is an input
	context that has not been freed.
	[Patch 570902]

2002-09-13  Andreas Kupries  <andreas_kupries@users.sourceforge.net>

	* generic/tk.h: Moved RC_INVOKED down so that tcl.h is still
	  included when running the resource compiler. <tcl.h> excludes
	  the unnecessary parts on its own. This reenables the Windows
	  build. It failed because the non-inclusion of tcl.h caused the
	  resource compiler to miss some vital macro definitions
	  (TCL_FINAL_RELEASE, STRINGIFY, ...).

2002-09-12  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tk.h:
	* mac/tkMacApplication.r:
	* mac/tkMacLibrary.r:
	* mac/tkMacResource.r:
	* macosx/tkAboutDlg.r:
	* macosx/tkMacOSXApplication.r:
	* macosx/tkMacOSXLibrary.r:
	* macosx/tkMacOSXResource.r: unified use of the two equivalent 
	resource compiler header inclusion defines RC_INVOKED and
	RESOURCE_INCLUDED, now use RC_INVOKED throughout.

	* macosx/tkMacOSXAppInit.c: improved detection of Wish startup
	by the finder (by checking if stdin is /dev/null), in which
	case we want to bring up the Tk console window.

	* macosx/tkMacOSXHLEvents.c: added 'rapp' apple event handler.

2002-09-12  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: reference & install
	tk/generic/prolog.ps instead of tk/library/prolog.ps.

2002-09-10  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: added backwards
	compatibility for OSX 10.1 ProjectBuilder 2.0.

2002-09-10  Daniel Steffen  <das@users.sourceforge.net>

	* unix/Makefile.in: added DYLIB_INSTALL_DIR variable for Darwin
	and set it to default value ${LIB_RUNTIME_DIR}
	* unix/tcl.m4 (Darwin): use DYLIB_INSTALL_DIR instead of
	LIB_RUNTIME_DIR in the -install_name argument to ld.
	* unix/configure: regen.

	* macosx/Wish.pbproj/project.pbxproj:
	* macosx/Makefile: added support for building Tcl as an embedded
	framework, i.e. using an dyld install_name containing
	@executable_path/../Frameworks via the new DYLIB_INSTALL_DIR
	unix/Makefile variable.

2002-09-10  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4.0 TAGGED FOR RELEASE ***

2002-09-09  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/tkMacOSXNotify.c (Tk_MacOSXSetupTkNotifier): corrected
	Mac Jaguar event loop issue.

	* library/tk.tcl: use command instead of control on Aqua bindings.
	Force dialogs to appear below fixed native Mac menubar.
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXKeyboard.c: Keypress/release events for pure
	modifier keys were not being passed to Tk.
	Deadkey presses were inserting null characters into text windows.
	Now they do nothing. (Still not ideal, but better than before!)
	* macosx/tkMacOSXMenu.c: Allow more than 200 menus to exist -
	increased to 2000.
	* macosx/tkMacOSXMouseEvent.c: Bad interactions between floating
	windows and ordinary ones.  Ensure that local<->global coordinate
	transformations are wrt to the correct window.
	* macosx/tkMacOSXWm.c: Better error msg for 'wm attributes'.
	Remove crash in 'wm transient'.
	Add 'noActivates' and 'noUpdates' flags to unsupported command.
	[Patch #606658] (darley)

	* library/xmfbox.tcl (::tk::MotifFDialog_ActivateSEnt): corrected
	msgcat code with XPG specifier. [Patch #606719] (miller)

2002-09-06  Don Porter <dgp@users.sf.net>

	* tests/unixWm.test (unixWm-50.3):  Constrained test that hangs
	on Windows.

2002-09-05  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: added overlooked missing
	TK_PATCH_LEVEL version bump to 8.4.0.

2002-09-04  Andreas Kupries  <andreas_kupries@users.sourceforge.net>

	* win/Makefile.in (install-libraries): Added code section to
	  install the message catalogs. Copied same section from
	  unix/Makefile.in and adapted it to the slightly different
	  environment.

2002-09-03  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/button.tcl: further restrict buttons to not resetting
	the "original" relief if it has changed in the interim.  This
	prevents code that simulated overrelief buttons from not working
	in 8.4.  [Bug #604270]

2002-09-03  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: Bumped version number to
	8.4.0 and updated copyright info.

2002-09-03  Vince Darley  <vincentdarley@users.sourceforge.net>

	* macosx/tkMacOSXWm.c: fix to 'wm attributes' error-handling bug.
	
2002-09-03  Don Porter <dgp@users.sf.net>

	* changes: Updated for 8.4.0 release

2002-09-02  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/cursor.test: reverted 2002-08-31 change for OS X to use
	'heart' cursor because 'arrow' on windows has a pre-skewed use
	count. [Bug #602667]

	* tests/button.test: added button-14.1
	* win/tkWinButton.c (TkpComputeButtonGeometry): correct Win button
	sizing to be equal for one-line buttons with -height of 0 or 1, as
	well as -height 0 buttons with empty text and no image, which
	should be the same as single-line text buttons. [Bug #565485]

	* library/button.tcl (::tk::ButtonLeave): correctly restore state
	of button to normal for unix bindings. [Bug #597920]

	* doc/tk.n: added tk windowingsystem docs.

	* tests/wm.test:
	* unix/tkUnixWm.c: remove possible 2-second delay in 'raise'.
	[Patch #601518] (english) TIP #107

	* unix/tcl.m4: add support for 64-bit builds on HP-11 with gcc.
	* unix/configure.in: make sure to substitute LD_LIBRARY_PATH_VAR.
	* unix/configure: regend

	* README:		Bumped version number to 8.4.0
	* generic/tk.h:
	* unix/configure:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure:
	* win/configure.in:

	* generic/tkCmds.c:
	* generic/tkWindow.c: made 'tk' available in safe interpreters,
	but only the caret and windowingsystem subcommands may be called.
	* tests/safe.test (safe-1.2): noted that tk is now available in
	safe interps, but not the appname/scaling subcommands.

	* tests/tk.test (tk-1.2): noted new tk windowingsystem subcommand

2002-08-31  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4: update from Tcl

	* unix/Makefile.in: import of TK_SHLIB_LD_EXTRAS for Tk library
	specific linker settings. Added use of new LD_LIBRARY_PATH_VAR.

	* unix/configure: regen

2002-08-31  Daniel Steffen  <das@users.sourceforge.net>

	*** macosx-8-4-branch merged into the mainline [tcl patch #602770] ***

	* generic/tk.decls:
	* generic/tkInt.decls: added new "aqua" specific entries to the
	stubs tables. Changed all "unix" entries to "x11" to allow us to
	distinguish and build both "aqua" on MacOSX and "x11" on MacOSX.

	* generic/tk.h: added a #ifnded RESOURCE_INCLUDED so that tk.h can
	be passed to the resource compiler. 
	
	* generic/tkCmds.c (Tk_TkObjCmd): added [tk windowingsystem]
	subcommand: returns "x11" when running on X11, "win32" on Windows,
	"classic" on MacOS9 and "aqua" on MacOSX Aqua (i.e. Carbon)

	* generic/tkFont.c (TkFontGetFirstTextLayout): new private function
	returning the first chunk of a Tk_TextLayout, i.e. until the first
	font change on the first line (or the whole first line if there is
	no such font change).

	* generic/tkMain.c: made Tcl_ThreadDataKey static

	* library/demos/puzzle.tcl: fixed button metrics for aqua

	* tests/cursor.test: check for presence of arrow cursor instead of
	heart cursor

	* xlib/xcolors.c: changed xColors static initialization to more
	standard C
	
	* macosx/Wish.pbproj/jingham.pbxuser (new):
	* macosx/Wish.pbproj/project.pbxproj (new): project for Apple's
	ProjectBuilder IDE.

	* macosx/Makefile (new): simple makefile for building the project
	from the command line via the ProjectBuilder tool 'pbxbuild'.

	* macosx/tkMacOSXAppInit.c (new): macosx specific AppInit looking
	for a AppMain.tcl file in its bundled Resources/Scripts folder. If
	present, argv[1] is set to that file and the Scripts folder is
	added to the auto_path. This allows tk apps to embed scripts within
	their bundle directory structure.

	* macosx/tkMacOSXInit.c (new): macosx adapted version of
	tkUnixInit.c: we initialize & cache the Carbon native encoding
	(e.g. 'macRoman') and try to find the tk script library files
	inside Tk packaged as a framework.

	* macosx/tkMacOSXNotify.c (new): new macosx specific merged
	Carbon/select-based notifier.

	* macosx/tkMacOSXEvent.c (new):
	* macosx/tkMacOSXEvent.h (new):
	* macosx/tkMacOSXKeyEvent.c (new):
	* macosx/tkMacOSXMouseEvent.c (new):
	* macosx/tkMacOSXWindowEvent.c (new): new macosx specific event
	handling functionality.

	* macosx/tkMacOSX.h (new):
	* macosx/tkMacOSXBitmap.c (new): 
	* macosx/tkMacOSXButton.c (new):
	* macosx/tkMacOSXClipboard.c (new):
	* macosx/tkMacOSXColor.c (new):
	* macosx/tkMacOSXConfig.c (new):
	* macosx/tkMacOSXCursor.c (new):
	* macosx/tkMacOSXDefault.h (new):
	* macosx/tkMacOSXDialog.c (new):
	* macosx/tkMacOSXDraw.c (new):
	* macosx/tkMacOSXEmbed.c (new):
	* macosx/tkMacOSXFont.c (new):
	* macosx/tkMacOSXHLEvents.c (new):
	* macosx/tkMacOSXInt.h (new):
	* macosx/tkMacOSXKeyboard.c (new):
	* macosx/tkMacOSXMenu.c (new):
	* macosx/tkMacOSXMenubutton.c (new):
	* macosx/tkMacOSXMenus.c (new):
	* macosx/tkMacOSXPort.h (new):
	* macosx/tkMacOSXRegion.c (new):
	* macosx/tkMacOSXScale.c (new):
	* macosx/tkMacOSXScrlbr.c (new):
	* macosx/tkMacOSXSubwindows.c (new):
	* macosx/tkMacOSXTest.c (new):
	* macosx/tkMacOSXUtil.c (new):
	* macosx/tkMacOSXUtil.h (new):
	* macosx/tkMacOSXWm.c (new):
	* macosx/tkMacOSXWm.h (new):
	* macosx/tkMacOSXXStubs.c (new): macosx ports of classic mac Tk
	implementation in tk/mac.

	* macosx/tkMacOSXSend.c (new): only send to local interp
	implemented currently.

	* macosx/tkMacOSXDebug.h (new):
	* macosx/tkMacOSXDebug.c (new): new macosx specific functions for
	debugging MacOS events, regions, etc.

	* macosx/tkAboutDlg.r (new):
	* macosx/tkMacOSXApplication.r (new):
	* macosx/tkMacOSXCursors.r (new):
	* macosx/tkMacOSXLibrary.r (new):
	* macosx/tkMacOSXMenu.r (new):
	* macosx/tkMacOSXResource.r (new):
	* macosx/tkMacOSXXCursors.r (new):
	* macosx/tclets.r (new): sources for Rez resource compiler.

	* macosx/Wish.icns (new): Wish application icon.

	* generic/tk.h:
	* generic/default.h:
	* generic/tkBind.c:
	* generic/tkCmds.c:
	* generic/tkGrab.c:
	* generic/tkPointer.c:
	* generic/tkPort.h:
	* generic/tkSelect.c:
	* generic/tkStubLib.c:
	* generic/tkTest.c:
	* generic/tkText.c:
	* generic/tkWindow.c:
	* unix/tkUnix3d.c:
	* xlib/xgc.c:
	* xlib/X11/X.h:
	* xlib/X11/Xlib.h:
	* xlib/X11/Xutil.h: added #includes and #ifdefs for macosx

	* library/bgerror.tcl:
	* library/button.tcl:
	* library/console.tcl:
	* library/dialog.tcl:
	* library/entry.tcl:
	* library/listbox.tcl:
	* library/menu.tcl:
	* library/msgbox.tcl:
	* library/scrlbar.tcl:
	* library/spinbox.tcl:
	* library/text.tcl:
	* library/tk.tcl:
	* library/demos/menu.tcl:
	* library/demos/menubu.tcl:
	* library/demos/widget: check [tk windowingsystem] instead of
	and/or in addition to $tcl_platform(platform).

	* generic/tkInt.h:
	* mac/tkMacBitmap.c:
	* mac/tkMacWm.c: added missing CONSTification

	* generic/tkIntDecls.h:
	* generic/tkIntPlatDecls.h:
	* generic/tkIntXlibDecls.h:
	* generic/tkPlatDecls.h:	
	* generic/tkStubInit.c: regen

2002-08-27  D. Richard Hipp <drh@hwaci.com>

	* doc/checkbutton.n:      [Bug 582457] Fix the -offrelief option so
	* doc/radiobutton.n:      that when -offrelief is flat and -relief is
	* mac/tkMacButton.c:      sunken and -overrelief is raised, buttons
	* unix/tkUnixButton.c:    work look toolbar buttons under Windows.
	* win/tkWinButton.c:      See also: TIP #82.

2002-08-26  Don Porter <dgp@users.sf.net>

	* win/Makefile.in:	Removed dependence on the (parts of) the
	* win/winMain.c:	tcltest executable on Windows.  It was not
	used, and the dependency complicated the Makefile.  [Bug 592638].

2002-08-20  Don Porter <dgp@users.sf.net>

	* README:		Bumped version number to 8.4b3 to distinguish
	* generic/tk.h:		HEAD from the 8.4b2 release.
	* unix/configure.in:
	* win/configure.in:
	* unix/tk.spec:
	
	* unix/configure:	autoconf
	* win/configure:

	* generic/tk.h:	Added compile-time check that the tcl.h header file
	#included by Tk 8.4 is one from Tcl 8.4.  This is needed to be sure
	that new #defines like CONST84 are available. [Bug 597432].

2002-08-16  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/Makefile.in (install-binaries): simplified pkgIndex.tcl
	file created on installation.
	* win/Makefile.in (install-binaries): corrected and simplified
	creation of pkgIndex.tcl file on installation.

2002-08-14  Vince Darley  <vincentdarley@users.sourceforge.net>

	* win/tkWinDialog.c:
	* win/makefile.vc: broken compilation and link from changes
	Hobbs-08-07 fixed.
	* win/tkWinTest.c: CONST problem resolved.

2002-08-13  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/button.tcl: change the bindings to use Priv($w,relief)
	instead of just Priv(relief).  This ensures that neighboring
	buttons don't confuse (over)relief settings.

2002-08-13  Reinhard Max  <max@suse.de>

	* unix/tkUnixSend.c (Tk_SetAppName): Fixed a compiler warning.

2002-08-12  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/demos/image2.tcl: Tweaked the behaviour of the directory
	box on resize, as resizing of the overall window tends to be
	common given the sample images.

2002-08-08  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/tkUnixWm.c (WmTransientCmd): Apply fix for
	wm transient assertion error that was applied
	to tkWinWm.c for Tk Bug #592201.

2002-08-08  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/wm.test: Add deleteWindows at start of
	new transient tests so they do not fail if the
	toplevels already exist.
	* unix/tkUnixWm.c: Revert patch for Tk Bug #592201
	which incorrectly removed numTransients member.

2002-08-08  Joe English  <jenglish@users.sourceforge.net>

	* unix/tkUnixWm.c:
	* win/tkWinWm.c:
	* tests/wm.test: Fix for Tk Bug #592201 "wm transient fails with two
	  masters"; fixes panic after a transient window is reassigned to
	  new master and either master is subsequently destroyed.

2002-08-08  Don Porter <dgp@users.sf.net>

	* tests/unixWm.test:  Corrected packaging of unixWm-50.3 so that
	[setupbg] and [cleanupbg] always balance, no matter what tests
	are skipped.

2002-08-08  Reinhard Max  <max@suse.de>

	* unix/Makefile.in: Fixed typos in DISTNAME, and ZIPNAME.

2002-08-08  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4b2 TAGGED FOR RELEASE ***

	* generic/tkButton.c (TkButtonWorldChanged): added GCFont handling
	to the disabledGc of buttons when compound != none.  The drawing
	appears to be incorrect across platforms still.  [Bug #477740]

	* generic/tkImgGIF.c (FileReadGIF): fixed -from handling for gifs
	[Bug #467524] (obermeier)

2002-08-07  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkCanvUtil.c (TkSmoothParseProc): recognize the built-in
	bezier method by name. [Bug #578654]
	* doc/canvas.n: update to note that -smooth really doesn't take
	or return just booleans.

	* win/tkWinMenu.c (TkpSetWindowMenuBar): fixed logic bug in when
	to idle call ReconfigureWindowsMenu.

	* doc/GetBitmap.3: removed doc refs to deprecated
	Tk_GetBitmapFromData. [Bug #590379]

	* generic/tkPanedWindow.c (Tk_PanedWindowObjCmd): 
	* library/panedwindow.tcl: changed class from PanedWindow to
	Panedwindow to not conflict with existing bwidgets, but also to be
	more regular with other names used in the core.

	* tests/panedwindow.test: added -text foobar to some test buttons
	to enable correct testing of panedwindow across platforms.
	[Bug #582370]

	* win/tkWinDialog.c: enabled use of the updated native Windows
	directory browser (tk_chooseDirectory).  This does require
	shell32.dll v4.71 or greater. [Patch #468139]

	* win/configure:
	* win/tcl.m4: added shell32 to libs for updated native Windows
	tk_chooseDirectory dialog.

2002-08-06  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkPanedWindow.c (RESIZE_PENDING): Separated out flag for
	indicating that a resize needs to be issued.
	(PanedWindowReqProc): Do the old behaviour when the panedwindow is
	not mapped; easiest way of making the test suite pass while still
	preserving improved behaviour in the face of children whose size
	is not known immediately.

2002-08-06  Don Porter <dgp@users.sf.net>

	* tests/defs.tcl: removed file.  No longer needed now that Tk is 
	using the tcltest package to do its testing.

2002-08-05  Don Porter <dgp@users.sf.net>

	* win/tkWinFont.c:	Additional changes to fix CONST warnings on
	* win/tkWinWM.c:	Windows due to latest patch.  Tks Vince Darley.

	* doc/3DBorder.3:	Applied companion patch for Tcl Patch 585105,
	* doc/BindTable.3:	updating Tk to use Tcl 8.4's fully CONST-ified
	* doc/ConfigWidg.3:	interface, and fully CONSTifying Tk at the
	* doc/CrtImgType.3:	same time.
	* doc/CrtWindow.3:
	* doc/DeleteImg.3:	This patch includes purging Tk of its last
	* doc/FindPhoto.3:	direct access to interp->result.  [Bug 589853]
	* doc/GetAnchor.3:
	* doc/GetBitmap.3:	The substantial changes include copying
	* doc/GetCapStyl.3:	event sequence strings into Tcl_DStrings
	* doc/GetClrmap.3:	in tkBind.c, and copying [text] indices into
	* doc/GetColor.3:	Tcl_DStrings because parsing them involved
	* doc/GetCursor.3:	overwriting them.  If this causes performance
	* doc/GetFont.3:	trouble, that can be resolved by further
	* doc/GetImage.3:	converting them to Tcl_Obj's.
	* doc/GetJoinStl.3:
	* doc/GetJustify.3:	The #defines USE_NON_CONST and USE_COMPAT_CONST
	* doc/GetOption.3:	have the same effect for Tk as they do for Tcl.
	* doc/GetRelief.3:	(They actually change tcl.h)
	* doc/GetScroll.3:
	* doc/GetVisual.3:
	* doc/InternAtom.3:
	* doc/NameOfImg.3:
	* doc/SetAppName.3:
	* doc/WindowId.3:
	* generic/tk.decls:
	* generic/tk.h:
	* generic/tk3d.c:
	* generic/tkAtom.c:
	* generic/tkBind.c:
	* generic/tkBitmap.c:
	* generic/tkButton.c:
	* generic/tkCanvArc.c:
	* generic/tkCanvBmap.c:
	* generic/tkCanvImg.c:
	* generic/tkCanvLine.c:
	* generic/tkCanvPoly.c:
	* generic/tkCanvPs.c:
	* generic/tkCanvText.c:
	* generic/tkCanvUtil.c:
	* generic/tkCanvWind.c:
	* generic/tkCanvas.c:
	* generic/tkCanvas.h:
	* generic/tkClipboard.c:
	* generic/tkCmds.c:
	* generic/tkColor.c:
	* generic/tkConfig.c:
	* generic/tkConsole.c:
	* generic/tkCursor.c:
	* generic/tkDecls.h:
	* generic/tkEntry.c:
	* generic/tkFont.c:
	* generic/tkFrame.c:
	* generic/tkGet.c:
	* generic/tkGrid.c:
	* generic/tkImage.c:
	* generic/tkImgBmap.c:
	* generic/tkImgPhoto.c:
	* generic/tkInt.decls:
	* generic/tkInt.h:
	* generic/tkIntDecls.h:
	* generic/tkIntPlatDecls.h:	
	* generic/tkListbox.c:
	* generic/tkMenu.c:
	* generic/tkMenubutton.c:
	* generic/tkMessage.c:
	* generic/tkOldConfig.c:
	* generic/tkOption.c:
	* generic/tkRectOval.c:
	* generic/tkScale.c:
	* generic/tkScrollbar.c:
	* generic/tkSelect.c:
	* generic/tkStyle.c:
	* generic/tkTest.c:
	* generic/tkText.c:
	* generic/tkText.h:
	* generic/tkTextBTree.c:
	* generic/tkTextDisp.c:
	* generic/tkTextImage.c:
	* generic/tkTextIndex.c:
	* generic/tkTextMark.c:
	* generic/tkTextTag.c:
	* generic/tkTextWind.c:
	* generic/tkUtil.c:
	* generic/tkVisual.c:
	* generic/tkWindow.c:
	* mac/tkMacConfig.c:
	* mac/tkMacCursor.c:
	* mac/tkMacEmbed.c:
	* mac/tkMacSend.c:
	* unix/tkUnixConfig.c:
	* unix/tkUnixCursor.c:
	* unix/tkUnixEmbed.c:
	* unix/tkUnixFont.c:
	* unix/tkUnixSelect.c:
	* unix/tkUnixSend.c:
	* unix/tkUnixWm.c:
	* win/tkWinConfig.c:
	* win/tkWinCursor.c:
	* win/tkWinEmbed.c:
	* win/tkWinMenu.c:
	* win/tkWinSend.c:

2002-08-02  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkPanedWindow.c (DestroyPanedWindow): Idle calls need to
	be deleted on destruction of the window, or things can *really* go
	pear-shaped.

2002-07-31  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkPanedWindow.c (PanedWindowReqProc): Postpone pane
	arrangement until idle, as is done in other window managers, to
	fix problems with size calculations when the children don't
	already know their sizes anyway.

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.

2002-07-29  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/configure.in: Remove code that was setting
	CC_SEARCH_FLAGS and LD_SEARCH_FLAGS to try to
	account for cc vs ld linking. Tcl now handles this.
	* unix/tcl.m4: Update from Tcl.

2002-07-27  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/Makefile.in: Add MAJOR_VERSION, MINOR_VERSION,
	PATCH_LEVEL, INSTALL_LIBRARY, STUB_LIB_FILE, and LIB_FILE
	to support changes in tcl.m4 related to library builds.
	Use MAKE_LIB macro to avoid dealing with RANLIB issues.
	Rename TK_CC_SEARCH_FLAGS to CC_SEARCH_FLAGS and
	rename TK_LD_SEARCH_FLAGS to LD_SEARCH_FLAGS.
	Use new INSTALL_LIB and INSTALL_STUB_LIB substs to
	deal with ranlib issues when install libraries.
	* unix/configure: Regen.
	* unix/configure.in: Remove AC_PROG_RANLIB since
	this is done by tcl.m4 now. Define CC_SEARCH_FLAGS
	instead of TK_CC_SEARCH_FLAGS and so on.
	Use MAKE_LIB and MAKE_STUB_LIB from tcl.m4.
	Remove AC_SUBST calls that are no done in tcl.m4.
	* unix/tcl.m4: Update from Tcl.
	* unix/tkConfig.sh.in: Subst CC_SEARCH_FLAGS and
	LD_SEARCH_FLAGS.

2002-07-25  Peter Spjuth  <peter.spjuth@space.se>

	* generic/tkInt.h:
	* generic/tkWindow.c:
	* mac/tkMacWm.c:
	* unix/tkUnixWm.c:
	* win/tkWinWm.c:
	* tests/wm.test:
	* tests/winWm.test:
	* tests/unixWm.test: Objectifed wm. [Patch #564521]
	Note: At this point the Mac file is completely untested
	and may not even compile.

2002-07-25  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/spinbox.test: added spinbox-22.[1-3]
	* generic/tkEntry.c (ConfigureEntry): made the textvariable value
	take precedence over changed -from/-to values, unless it must be
	constrained.  [Bug #559078]

	* library/spinbox.tcl (MouseSelect): when not in the entry, just
	return instead of invoking - ButtonUp handles invoking already.
	[Bug #499168]

	* library/tk.tcl (RestoreFocusGrab): handle the case where the
	FocusGrab info is not set. [Bug #553283]

2002-07-24  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/canvas.test: added canvas-14.[1-6]
	* generic/tkCanvas.c (CanvasWidgetCmd): corrected handling of
	'scan' subcommand args.  Also removed early return cases to goto
	done instead where the canvasPtr would be Tcl_Release'd.  This may
	solve other problems with unreleased canvasPtr's. [Bug #581560]

	* win/tkWinButton.c (TkpDisplayButton): corrected display of focus
	ring around the actual text when the button is a compound button.
	[Bug #583691]

	* unix/README: Corrected notes about running user interactive Tk
	tests. [Bug #462320]

	* generic/tkText.c (TextEditUndo): set isDirtyIncrement to -1 when
	reverting to note proper "dirtiness". [Bug #580362] (callewaert)

	* generic/tkEntry.c (DisplayEntry): correct cursor position before
	calling Tk_SetCaretPos. (yamamoto)

2002-07-23  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.

2002-07-22  Mo DeJong  <mdejong@users.sourceforge.net>

	* library/choosedir.tcl (tk::dialog::file::chooseDir):
	* library/clrpick.tcl (tk::dialog::file::chooseDir):
	* library/msgbox.tcl (tk::MessageBox):
	* library/tkfbox.tcl (tk::dialog::file):
	* library/xmfbox.tcl (tk::MotifFDialog):
	Revert [Tk patch 568278]. The transient window workaround
	is no longer needed since the fix for [Tk bug 570764]
	solved the problem for withdrawn transients.

2002-07-19  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure:
	* unix/configure.in:
	* win/configure:
	* win/configure.in: Add AC_PREREQ(2.13) in an attempt
	to make it more clear that the configure scripts
	must be generated with autoconf version 2.13.
	[Tcl Bug 583573]

2002-07-19  D. Richard Hipp  <drh@hwaci.com>

	* library/mkpsec.tcl: Fix a bug that was causing postscript generation
	to fail under Win2K.

2002-07-18  Reinhard Max  <max@suse.de>

	* unix/tkUnixSend.c: Using Tcl_GetTime instead of TclpGetTime.

2002-07-17  Reinhard Max  <max@suse.de>

	* library/unsupported.tcl: Extended ExposePrivateVariable, and
	ExposePrivateCommand to accept patterns as well.	

2002-07-17  Don Porter <dgp@users.sf.net>

	* generic/tkFont.c: Corrected reversed logic in assert -> panic
	conversion.  [Bug 582799]

2002-07-16  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkFont.c (TkFontPkgFree): Call panic instead
	of assert since assert is not used in the rest of Tk.
	[Tk bug 579651]

2002-07-16  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/Makefile.in:
	* win/Makefile.in: Add a more descriptive warning
	in the event `make genstubs` needs to be rerun.

2002-07-16  Vince Darley  <vincentdarley@users.sourceforge.net>

	* win/tkWinWm.c: 
	* doc/wm.n: fix for part of [Bug 581627], and made iconbitmap
	code on Windows more flexible about reading in icons [Bug
	220800].

2002-07-15  David Gravereaux <davygrvy@pobox.com>

	* win/makefile.bc (new): re-add of the borland makefile.  Submitted
	by Helmut Giese <hgiese@ratiosoft.com>.  This needs testing, still.

2002-07-15  Don Porter <dgp@users.sf.net>

	* Fixes for [Bug 581627, 581795].
	* generic/tkTest.c:		Test commands not supported on non-Unix
	  platforms should not be defined there in the first place.
	* tests/constraints.tcl:	Fixed "secureserver" constraint.
	* tests/unixWm.test:		Some tests needed "unix" constraint.
	* win/tkWinWm.c:		Typo in error message.

2002-07-14  Don Porter <dgp@users.sf.net>

	* tests/event.test:	Fixes to enable testing of only userInteraction
	* tests/visual_bb.test:	tests.

	* README:		Bumped HEAD to version 8.4b2 in order to 
	* generic/tk.h:		distinguish it from the 8.4b1 release.
	* unix/configure*:	Also extended LOCALES to cover all message
	* unix/tk.spec:		catalogs.
	* win/configure*:

	* tests/focustTcl.test:	Conversion bug: Corrected backwards logic.
	* tests/imgPhoto.test:	Conversion bug: overwrote unix/README.

	* tests/all.tcl:		Completed conversion of Tk test suite
	* tests/constraints.tcl:	to use tcltest.
	* tests/[b-v]*.test:
	* unix/Makefile.in:

2002-07-12  Don Porter <dgp@users.sf.net>

	* tests/constraints.tcl:	Converted more files to tcltest and
	* tests/[g-x]*.test:		factored out common code.

2002-07-11  Don Porter <dgp@users.sf.net>

	* tests/canvPsImg.tcl:			Converted several files in the
	* tests/constraints.tcl (new file):	Tk test suite for testing by
	* tests/[r-x]*.test:			tcltest 2.1.
	* unix/Makefile.in:

2002-07-11  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinDialog.c (Tk_ChooseDirectoryObjCmd): initialize
	utfTitle to NULL, add a few more notes about limitations of
	possible new Tk_ChooseDirectoryObjCmd function.

2002-07-11  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/imgPhoto.test (imgPhoto-15.1): Added test of mem-alloc
	failure, but this is non-portable.
	* generic/tkImgPhoto.c (ImgPhotoSetSize): Allowed this function to
	fail when it can't allocate enough memory.  Note that not all the
	places that call it can fail nicely without API changes; some
	still panic but at least some of the potential failures are now
	handled gracefully.

	* tests/visual_bb.test (lpr): Stopped this from relying on
	external files; direct piping is much more flexible for this
	application.

2002-07-09  Don Porter <dgp@users.sf.net>

	* generic/tkTest.c:	Removed unused dependence on TclThread_Init()
	* tests/defs.tcl:	and [testthread].  [Bug 578165, Tcl Bug 531413]

2002-07-08  David Gravereaux <davygrvy@pobox.com>

	* unix/Makefile.in: Added missing win/lamp.bmp to the dist
	target.

2002-07-05  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4b1 TAGGED FOR RELEASE ***

2002-07-04  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/bgerror.tcl (bgerror): Stopped the bgerror dialog from
	getting wider than the screen; in theory really long messages
	could make it become taller than the screen now, but that's much
	less likely to happen.  Also trimmed a little bit of internal
	space so that the icon-message gap is the same as the icon-frame
	and message-frame gaps.

2002-07-01  Don Porter <dgp@users.sf.net>

	* unix/configure:
	* unix/tcl.m4: Updated to latest tcl.m4 from Tcl.

2002-06-28  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/msgbox.tcl (MessageBox): Force all non-button widgets to
	have the same background as the containing toplevel.  [Bug #552515]

2002-06-27  Andreas Kupries  <andreas_kupries@users.sourceforge.net>

	* win/Makefile.in (install-binaries): Fix of troubled Makefile
	quoting introduced by [Patch 521356] causing the installed to
	fail.

2002-06-25  Don Porter <dgp@users.sf.net>

	* unix/tkUnixFont.c: (Tk_DrawChars) silence compiler warning.

2002-06-26  David Gravereaux <davygrvy@pobox.com>

	* generic/tkStyle.c: <eol> of the committing cvs client didn't
	match the <eol> of the file itself.  Windows users where getting
	\r\r\n.  Problem fixed.

2002-06-26  Anton Kovalenko <a_kovalenko@users.sourceforge.net>

	* generic/tkFont.c (TkTextLayoutToPostscript): fixed potential
	buffer overflow which could be intentionally triggered from
	within safe interpreter -- malicious applet could modify 
	tk::psglyphs array.

2002-06-26  Anton Kovalenko <a_kovalenko@users.sourceforge.net>

	* tests/font.test (font-32.1): updated this test
	to expect the new behavior of canvas postscript.

2002-06-25  Don Porter <dgp@users.sf.net>

	* unix/Makefile.in:	Expanded install-binaries target to create
	* win/Makefile.in:	and install a pkgIndex.tcl file to enable
	Tk as a loadable package [Patch 521356]

2002-06-25  Anton Kovalenko <a_kovalenko@users.sourceforge.net>

	* library/mkpsenc.tcl: (added) utilities to generate
	Postscript prolog for current system encoding.
	* generic/tkCanvPs.c (TkCanvPostscriptCmd): now
	uses mkpsenc.tcl to generate Postscript prolog.
	* generic/tkFont.c (TkTextLayoutToPostscript): modified
	according to patch #546910. Now outputs system-encoded
	characters (for unibyte) or Adobe glyph names (for
	multibyte or outside-locale).
	* tests/canvText.test (canvText-17.1): updated this test
	to expect the new behavior of canvas postscript.

2002-06-25  Reinhard Max  <max@suse.de>

	* unix/tcl.m4:       New macro SC_CONFIG_MANPAGES.
	* unix/configure.in: Added support for symlinks and compression
	* unix/Makefile.in:  when installing the manpages. [Patch 518052]
	                     Default is still hardlinks and no compression.

	* unix/mkLinks:      generated
	* unix/configure:

	* unix/README:       Added documentation for the new features.

	* unix/configure:                  Replaced ${exec_prefix}/lib
	* unix/tcl.m4 (SC_PATH_TCLCONFIG): by ${libdir}.

2002-06-24  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/winWm.test: Verify that both an unmapped
	and already mapped toplevel are raised and receive
	the focus when deiconified.
	* tests/wm.test: Add wm deiconify tests. Check that
	a toplevel that has never been mapped is not mapped
	by the deiconify command since it should be done
	at idle by MapFrame.
	* win/tkWinWm.c (Tk_WmCmd): Check the WM_NEVER_MAPPED
	flag while processing the wm deiconify command.
	The WM_UPDATE_PENDING flag should never be set when
	WM_NEVER_MAPPED is set, but double check so that
	the implementation is more explicit and matches
	the comment just above.
	Return without invoking TkWmRestackToplevel or
	TkSetFocusWin on a toplevel that has never been
	mapped. This fixes a bug where a toplevel is mapped
	with the wrong size and is then resized by the
	idle call to MapFrame. [Tk bug 233150]

2002-06-23  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinWm.c (UpdateGeometryInfo): remove the check for a null
	wrapper introduced in r1.41 on 2002-06-15 because it prevented
	geometry setting from taking effect if the window was not on the
	screen.  Another check may go in it's place as IsIconic and
	IsZoomed should not be passed NULL.

2002-06-22  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/wm.test: Remove invalid minsize test. Add update
	calls to wm transient tests so that idle handlers get
	run. This is needed to get the tests to pass under Win32.
	* unix/tkUnixWm.c (WmWaitMapProc): Move the special
	transient withdrawn check into the if body to
	make it easier to set a breakpoint on this test
	inside a debugger. No functional changes.
	* win/tkWinWm.c (WmWaitVisibilityOrMapProc): Ditto.

2002-06-22  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/wm.n:                   TIP #95 Windows implementation and
	* mac/tkMacWm.c (Tk_WmCmd):   docs with mac and unix stubs.
	* unix/tkUnixWm.c (Tk_WmCmd):
	* win/tkWinWm.c (Tk_WmCmd):
	* tests/unixWm.test:
	* tests/winWm.test: more wm attr tests will be needed.

	* generic/tkGrid.c (GridReqProc): check that gridPtr is not NULL
	(may be when embedded). [Bug #548791] (halliday)

	* generic/tkFont.c (TkFontPkgFree): changed panic on freeing fonts
	to an assert, and wrapped panic in #ifdef PURIFY. [Bug #568701]

	* library/menu.tcl: corrected menus from being posted offscreen
	on Windows. [Bug #464451] (darley)

	* library/console.tcl: corrected the defaultPrompt substitution
	[Bug #553207] and made Tab a default expansion key (like Escape).

	* win/tkWinEmbed.c (EmbedWindowDeleted): added a check for a null
	containerPtr.  The core of this bug is likely elsewhere. [Bug #476176]

	* doc/text.n:                             TIP #93 implementation that
	* generic/tkText.c (TextWidgetCmd):       enhances the text get and
	* generic/tkTextIndex.c (TkTextGetIndex): delete methods to accept
	* tests/text.test:                        multiple range pairs.
	This handles the delete case in an atomic, fixed-index fashion.

2002-06-21  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/wm.test: Add tests to make sure a withdrawn
	transient does not get remapped by state changes
	in the master.
	* unix/tkUnixWm.c (Tk_WmCmd, WmWaitMapProc):
	* win/tkWinWm.c (Tk_WmCmd, WmWaitVisibilityOrMapProc):
	Add a WM_TRANSIENT_WITHDRAWN flag that gets set by the
	withdraw, deiconify, or state wm subcommands. Check
	this flag before mapping a transient when processing
	a MapNotify event. [Tk bug 570764]

2002-06-21  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* unix/tk.spec (version), README, win/configure.in, unix/configure.in: 
	* generic/tk.h (TK_RELEASE_*, TK_PATCH_LEVEL): Bumped to beta1.

2002-06-21  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/text.n:          TIP #104 implementation which generalizes the
	* generic/tkText.c:    undo/redo stack to not be tied solely to the
	* generic/tkText.h:    text widget.  The APIs are still private.
	* generic/tkUndo.c:    This also adds a stack limiting ability and
	* generic/tkUndo.h:    a -maxundo option to the text widget (in
	* library/text.tcl:    addition to the options from TIP #26) should
	* mac/tkMacDefault.h:  users want to limit the undo/redo stack
	* tests/text.test:     (should not be necessary in most cases).
	* unix/Makefile.in:    [Patch #554763] (callewart)
	* unix/tkUnixDefault.h:
	* win/Makefile.in:
	* win/makefile.vc:
	* win/tkWinDefault.h:

2002-06-21  Don Porter <dgp@users.sf.net>

	* unix/Makefile.in:	Removed unnecessary dependence of tktest
	* unix/tkAppInit.c:	executable on the tcltest executable on
	Unix.  If there are similar dependencies on other platforms, they
	can probably be removed as well.  [Bug 572134].

2002-06-20  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/listbox.n:
	* generic/tkListbox.c (DisplayListbox): 
	* mac/tkMacDefault.h:   TIP #94 implementation adding -activestyle
	* tests/listbox.test:   option to the listbox.  This adds the ability 
	* unix/tkUnixDefault.h: to have listboxes look native on Windows, and
	* win/tkWinDefault.h:   "nicer" elsewhere using the 'dotbox' style.

2002-06-20  Peter Spjuth  <peter.spjuth@space.se>

	* generic/tkGrid.c: Corrected the test for grid propagate change.
	[Bug #571433]

2002-06-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/panedwindow.test:
	* generic/tkPanedWindow.c: ensure that sash index is lower bounds
	checked. [Bug #548727]

2002-06-19  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkClipboard.c (TkClipCleanup): Add code
	to set dispPtr->clipWindow to NULL, this was
	accidently removed by last commit. Fixes
	a crash while running the tests under win32.

2002-06-19  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkBind.c (TkBindDeadWindow):
	Handle case where Tk_DestroyWindow is invoked
	on clipboard and send windows.
	* generic/tkClipboard.c (TkClipCleanup):
	Invoke Tk_DestroyWindow to cleanup the
	dispPtr->clipWindow. Call Tcl_Preserve
	and Tcl_Release on the window to avoid an
	invalid memory ref on shutdown.
	* generic/tkEvent.c (Tk_HandleEvent):
	Panic if XCreateIC is invoked twice for
	the same window. This should never happen,
	the check were just added to make sure it
	does not since this could lead to crashes
	in XCloseIM.
	* generic/tkFocus.c (TkFocusDeadWindow):
	Handle case where Tk_DestroyWindow is invoked
	on clipboard and send windows.
	* generic/tkOption.c (TkOptionDeadWindow): Ditto.
	* generic/tkWindow.c (TkCloseDisplay): Move
	deletion of dispPtr->winTable after TkpCloseDisplay
	call since Tk_DestroyWindow uses it and could
	be called by TkpCloseDisplay for clipboard/send windows.
	Also invoke ckfree for the dispPtr instead of
	doing it in TkpCloseDisplay.
	(Tk_DestroyWindow): Check for a null winPtr->mainPtr
	before doing certain cleanup tasks so the we can
	invoke Tk_DestroyWindow on clipboard and send windows.
	We need to do this so that XDestroyIC will get invoked
	for the input contexts of each window.
	* mac/tkMacXStubs.c (TkpCloseDisplay): Don't free
	the displayPtr since this is now done in TkCloseDisplay.
	* unix/tkUnixEvent.c (TkpCloseDisplay, OpenIM): Remove
	conditional compilation around calls to XCloseIM
	since I am confident that the crashes related to
	input contexts has been fixed. Don't free
	the displayPtr since this is now done in TkCloseDisplay.
	* unix/tkUnixSend.c (TkSendCleanup): Invoke the
	Tk_DestroyWindow method to cleanup the special
	send window. This will call XDestroyIC and thereby
	avoid a crash in XCloseIM. The send window needs
	to be Tcl_Preserve and Tcl_Release to avoid an
	invalid memory ref on shutdown.
	* win/tkWinX.c (TkpCloseDisplay): Don't free
	the displayPtr since this is now done in TkCloseDisplay.
	[Tk patch 570902]

2002-06-19  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkStyle.c: TIP#48 style engine.
	See http://purl.org/tcl/tip/48.html for details.

	* generic/tkConfig.c (GetOptionFromObj): Split to allow for access
	to option tables via name as well as via object.
	(TkGetOptionSpec): Semi-public interface to GetOption functionality.
	(DoObjConfig, Tk_RestoreSavedOptions, FreeResources)
	(GetObjectForOption): Basic style support for configure.

	* generic/tkWindow.c (TkCreateMainWindow, Tk_DestroyWindow): Added
	calls to set up and tear down the style subsystem.

	* generic/tk.decls, generic/tk.h: Many declarations forming TIP#48
	public interface.

	* generic/tkInt.decls (TkStylePkgInit,TkStylePkgFree): 
	* generic/tkInt.h (TkGetOptionSpec): Supporting declarations.

	* unix/Makefile.in, win/Makefile.in, win/makefile.vc: Added
	tkStyle.c to list of generic source files.

2002-06-18  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/defs.tcl (makeFile): Defined the return value of this
	procedure to be the filename of the created file, as in the real
	tcltest package...

2002-06-17  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkImage.c (Tk_ImageObjCmd, DeleteImage): Call
	Tcl_Preserve and Tcl_Release for the masterPtr->winPtr
	window to avoid accessing memory that had already
	been deallocated in DeleteImage.

2002-06-17  David Gravereaux <davygrvy@pobox.com>

	Trims to support the removal of RESOURCE_INCLUDED from rc
	scripts from Tcl's accepted FR #565088.

	* generic/tk.h: Changed RESOURCE_INCLUDED to be RC_INVOKED
	as the RC tool defines this already by default.

	* win/rc/tk.rc:
	* win/rc/wish.rc: removed the #define RESOURCE_INCLUDED lines.

2002-06-17  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/Makefile.in (dist): correct installation of
	wish.exe.manifest to DISTDIR target directory.

	* generic/tkCmds.c (Tk_TkObjCmd): 
	* generic/tkInt.h (struct TkCaret): 
	* mac/tkMacXStubs.c (Tk_SetCaretPos): 
	* unix/tkUnixKey.c (TkpGetString, Tk_SetCaretPos): 
	* win/tkWinX.c (Tk_SetCaretPos): 
	* tests/tk.test:        Added 'tk caret' implementation of TIP#96
	* doc/SetCaret.3 (new): which adds a TkCaret structure element to
	* doc/tk.n:             TkDisplay for maintaining state.

	* unix/tkUnixSend.c (TkSendCleanup): special cleanup of
	inputContext to avoid bug in XCloseIM. (dejong)

2002-06-17  Don Porter <dgp@users.sf.net>

	* library/msgs/en_gb.msg:  Added catalog for UK English.
	Currently includes only Color -> Colour translation.

2002-06-17  D. Richard Hipp  <drh@hwaci.com>

	* doc/checkbutton.n:
	* doc/radiobutton.n:
	* generic/tkButton.c:
	* generic/tkButton.h:
	* mac/tkMacButton.c:
	* tests/button.test:
	* unix/tkUnixButton.c:
	* win/tkWinButton.c: Implementation of TIP#82 - Added the
	-offrelief option to checkbutton and radiobutton.

2002-06-14  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkWindow.c (Tk_DestroyWindow): Set the pathName
	component of a window to NULL after its memory has been
	deallocated to avoid a possible illegal memory access
	as a result of a call to Tk_PathName() on a Tk_Window
	structure of a window that has already been destroyed.
	[Tk bug 521946]

2002-06-14  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkOption.c (Tk_GetOption): Allocate
	memory with ckalloc not malloc. This keeps
	Tk from erroring out when built with
	TCL_MEM_DEBUG.

2002-06-14  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkBind.c (HandleEventGenerate): 
	* generic/tkInt.h: changed warpInProgress boolean from int to a
	bit in the flags variable (TK_DISPLAY_IN_WARP)

	* generic/tkCmds.c (Tk_TkObjCmd): 
	* unix/tkUnixKey.c (TkpGetString): 
	* generic/tkEvent.c (Tk_HandleEvent): 
	* generic/tkInt.h: changed useInputMethods boolean from int to a
	bit in the flags variable (TK_DISPLAY_USE_IM)

	* generic/tkInt.h:
	* generic/tkCmds.c (Tk_WmObjCmd): 
	* unix/tkUnixWm.c (Tk_WmCmd): 
	* win/tkWinWm.c (Tk_WmCmd): changed wmTracing from being an int to
	just a bit in the flags variable (TK_DISPLAY_WM_TRACING)

	* generic/tkEvent.c (Tk_HandleEvent): 
	* unix/tkUnixEvent.c (OpenIM): 
	* unix/tkUnixKey.c (TkpGetString): 
	* generic/tkInt.h: added TK_DISPLAY_XIM_SPOT flag bit for TkDisplay
	and used this to allow a runtime check to see if over-the-spot XIM
	is possible.  If not it will try and fallback to the old-style
	input context, which handles things like dead keys input.

	* generic/tk.decls:     added TIP #84 implementation that adds a
	* generic/tkDecls.h:    Tk_CollapseMotionEvents API which controls
	* generic/tkEvent.c:    Tk's collapsing of incoming motion events
	* generic/tkInt.h:      on its windows.  The default remains to do
	* generic/tkStubInit.c: collapsing.  Added a flags parameter to the
	* generic/tkWindow.c:   internal display structure to support this
	* doc/QWinEvent.3:      and be used in the future for other bits.
	                        [Tk patch 564642]

	* unix/mkLinks: updated from current docs

2002-06-14  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkEvent.c (TkXErrorHandler): Declare static
	function to avoid compiler error with VC++.
	* generic/tkBind.c (ExpandPercents): Cast argument to
	Tk_GetAtomName in order to avoid compiler warning.

2002-06-14  Joe English  <jenglish@users.sf.net>

	* doc/bind.n:
	* generic/tk.h:
	* generic/tkBind.c:
	* generic/tkCanvWind.c:
	* generic/tkCmds.c:
	* generic/tkEvent.c:
	* generic/tkFocus.c:
	* generic/tkGrab.c:
	* generic/tkGrid.c:
	* generic/tkImage.c:
	* generic/tkPack.c:
	* generic/tkPlace.c:
	* generic/tkPointer.c:
	* generic/tkTextWind.c:
	* generic/tkWindow.c:
	* mac/tkMacSubwindows.c:
	* mac/tkMacWindowMgr.c
	* mac/tkMacWm.c:
	* unix/Makefile.in:
	* unix/tkUnixEmbed.c:
	* unix/tkUnixWm.c:
	* win/tkWinScrlbr.c:
	* win/tkWinWindow.c:
	* win/tkWinWm.c: Implementation of TIP #47 by Neil McKay
	"Modifying Tk to Allow Writing X Window managers".
	Add CirculateRequest, Create, MapRequest, ResizeRequest, 
	and ConfigureRequest event types;
	Split TK_TOPLEVEL flag into TK_TOPLEVEL, TK_HAS_WRAPPER,
	TK_WIN_MANAGED, and TK_TOP_HIERARCHY. [Tk patch 572978]

2002-06-14  Andreas Kupries  <andreas_kupries@users.sourceforge.net>

	* unix/tkAppInit.c: Removed now unneeded and erroneous reference
	  to 'matherr'. See Tcl ChangeLog entry 2002-05-31 Don Porter.

2002-06-14  David Gravereaux <davygrvy@pobox.com>

	* win/rules.vc: The test for compiler optimizations was in error.
	Thanks goes to Roy Terry <royterry@earthlink.net> for his
	assistance with this.

2002-06-14  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	Implement TIP 98  [Tk patch 566765]
	
	* doc/FindPhoto.3, generic/tk.h, generic/tk.decls:
	* generic/tkImgPhoto.c: Changed *_Old to *_NoComposite and
	USE_OLD_PHOTO_PUT_BLOCK to USE_COMPOSITELESS_PHOTO_PUT_BLOCK
	following a suggestion from Don Porter. 

	* tests/imgPhoto.test: Added tests of -compositingrule

	* doc/photo.n: Added documentation for "-compositingrule".
	* generic/tkImgPhoto.c (ImgPhotoCmd, ParseSubcommandOptions): New
	"-compositingrule" option for [$photo copy] subcommand, using
	OPT_COMPOSITE flag and compositingRule field in SubcommandOptions
	structure.

	* doc/FindPhoto.3: Documented the extra argument for the
	compositing rule and the action to take if anyone wants to
	maintain total backward-compatability.

	* generic/tk.h (TK_PHOTO_COMPOSITE_*): Defined values for use as
	compositing rules. 
	(USE_OLD_PHOTO_PUT_BLOCK): Added a way for users to select the old
	interface to Tk_PhotoPutBlock to provide an easier upgrade path.

	* generic/tk.decls: Alter Tk_PhotoPut*Block to Tk_PhotoPut*Block_Old
	and introduce new slots for the old name of function with an extra
	argument at the end for the compositing rule.

	* generic/tkImgPhoto.c (ImgPhotoCmd): Updated "transparency set"
	subcommand to use TkSubtractRegion().

	* win/tkWinRegion.c (TkSubtractRegion): 
	* mac/tkMacRegion.c (TkSubtractRegion): 
	* generic/tkInt.decls (TkSubtractRegion): 
	* unix/tkUnixPort.h (TkSubtractRegion): Added function to perform
	the set-difference operation on regions; it seems all platforms
	can support it, and it makes removing rectangular bits from
	regions much easier.

	* generic/tkImgPPM.c (FileReadPPM): Reading a PPM/PGM always uses
	the SET compositing rule because it is faster and the format does
	not have any transparency information.

	* generic/tkImgGIF.c (FileReadGIF): Reading a GIF always uses the
	SET compositing rule because GIF files model transparency as a
	single special colour.

	* generic/tkImgPhoto.c (Tk_PhotoPutBlock, Tk_PhotoPutZoomedBlock):
	Added a compositing rule to allow better control over what happens
	to transparent pixels when inserting data into a photo image.

2002-06-13  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/winfo.test: Add basic tests for winfo ismapped.

2002-06-13  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/unixWm.test:
	* tests/wm.test: Move wm minsize and wm maxsize
	usage tests into the cross platform wm tests.

2002-06-13  Don Porter <dgp@users.sf.net>

	* tests/cursor.test:  corrected error after cursor-2.2.
	* tests/defs.tcl: Added enhancements to Tk's fake version of
	tcltest required by recent cursor.test changes.

2002-06-13  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/cursor.test (cursor-2.[34]): Tests added to ensure that
	cursor specs really are well-behaved lists.  Also some general
	clean-up...
	* win/tkWinCursor.c (TkGetCursorByName): Undone Jeff's back-off
	and fixed things so that they should work now.  Cursor specs are
	lists first and foremost.

2002-06-12  Mo DeJong  <mdejong@users.sourceforge.net>

	* changes: Clearly label wm transient changes as
	a POTENTIAL INCOMPATIBILITY. 
	* doc/wm.n: Remove "some window managers will" text
	and explicitly state what behavior a transient
	window will display. Also mention that it is an
	error to make a window a transient of itself.

2002-06-12  Mo DeJong  <mdejong@users.sourceforge.net>

	* library/choosedir.tcl (tk::dialog::file::chooseDir):
	* library/clrpick.tcl (tk::dialog::file::chooseDir):
	* library/msgbox.tcl (tk::MessageBox):
	* library/tkfbox.tcl (tk::dialog::file):
	* library/xmfbox.tcl (tk::MotifFDialog): Remove the
	transient property on dialogs after they have been
	dismissed to insulate them from further state changes
	in the master. This keeps a withdrawn dialog from
	being mapped when the master is deiconified. [Tk patch 568278]

2002-06-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinCursor.c (TkGetCursorByName): reverted fix from
	2002-06-06 because it broke the ability to use built-in cursors
	like left_ptr.

2002-06-12  Mo DeJong  <mdejong@users.sourceforge.net>

	* library/choosedir.tcl (tk::dialog::file::chooseDir):
	* library/clrpick.tcl (tk::dialog::color):
	* library/dialog.tcl (tk_dialog):
	* library/msgbox.tcl (tk::MessageBox):
	* library/tkfbox.tcl (tk::dialog::file):
	* library/xmfbox.tcl (tk::MotifFDialog_Create):
	Only make the dialog window a transient if
	the master is visible. This check already
	appeared in some of the dialogs. This patch
	just copies the check into those that were
	lacking. [Tk patch 568253]

2002-06-12  Mo DeJong  <mdejong@users.sourceforge.net>

	* changes: Add note about new transient behavior.
	* tests/unixWm.test: Check that the WM_TRANSIENT_FOR
	property for a transient window is being cleared
	when the master is destroyed.
	* tests/wm.test: Source defs.tcl instead of using
	tcltest to match the rest of Tk's test files.
	Add new tests that ensure that a transient's state
	mirrors the state of the master.
	* unix/tkUnixWm.c (WmInfo, TkWmNewWindow, TkWmMapWindow,
	TkWmDeadWindow, Tk_WmCmd, WmWaitMapProc): Add numTransients
	member to WmInfo structure. Keep state of master and
	transient in sync using a callback that tracks MapNotify
	and UnmapNotify events. When the master is mapped, map
	the transient. When the master is unmapped or iconified,
	withdraw the transient.
	* win/tkWinWm.c (TkWmMapWindow, TkpWmSetState,
	TkWmDeadWindow, Tk_WmCmd, WmWaitVisibilityOrMapProc):
	Keep state of master and transient in sync using a
	callback that tracks MapNotify and UnmapNotify events.
	Move masterPtr check from TkpWmSetState into TkWmMapWindow
	to deal with WM_NEVER_MAPPED transients. Cleanup
	numTransients and the callback in TkWmDeadWindow.
	Cleanup numTransients and the callback only after
	deleting a master in wm transient command to avoid
	deleting the callback when an error is raised.
	Add support for MapNotify and UnmapNotify events
	to the master callback. [Tk patch 561708]

2002-06-11  Joe English  <jenglish@users.sf.net>

	* library/menu.tcl: fix for bug report #530212 "Bad Window Path 
	  Name in tkMenuFind"

2002-06-10  David Gravereaux <davygrvy@pobox.com>

	* win/makefile.vc: Fixed a win98 issue where the /exclude option
	for xcopy is unsupported.
	Reported by Roy Terry <royterry@earthlink.net>.

2002-06-10  Anton Kovalenko <a_kovalenko@users.sourceforge.net>

	* library/tk.tcl: added utility functions to get "-underline" and 
	"-text" for labels and buttons from translatable string containing 
	"magic ampersand" [patch #566605]
	* library/clrpick.tcl:
	* library/msgbox.tcl:
	* library/tkfbox.tcl:
	* library/xmfbox.tcl: some places where msgcat is used to get
	translated label are modified to handle labels with magic ampersand.
	* library/msgs/ru.msg: russian translations added
	* library/msgs/cs.msg:
	* library/msgs/de.msg:
	* library/msgs/el.msg: 
	* library/msgs/es.msg:
	* library/msgs/fr.msg:
	* library/msgs/it.msg:
	* library/msgs/nl.msg: all translation files now have labels with
	'magic ampersand' where appropriate. In el.msg some ampersands are
	missing, as I don't know which underline positions seems natural
	to "el" users.

2002-06-09  Mo DeJong  <mdejong@users.sourceforge.net>

	* library/bgerror.tcl (tk::dialog::error::bgerror):
	Don't set the bgerror dialog as a transient of
	itself since this operation is ill defined.

2002-06-06  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* win/tkWinCursor.c (TkGetCursorByName): Fixed so that the reading
	of cursors from a file with a cursor spec was built using [list]
	works when the file has a space in instead of requiring fiddling
	with backslashes.

2002-06-06  Anton Kovalenko <a_kovalenko@users.sourceforge.net>

	* library/msgbox.tcl (MessageBox): Add -default normal
	when creating non-default buttons for message box.
	They already get -default normal when they're 
	unfocused, and dialog window size used to change suddenly
	in such cases.

2002-06-05  Anton Kovalenko <a_kovalenko@users.sourceforge.net>

	* unix/tkUnixFont.c (Tk_DrawChars): Don't assume that
	one char is always one byte, and that required 
	subfont for the last character in any string is 
	the same as for the previous character 
	[Bug #559435] [Patch #559437]

2002-05-27  Mo DeJong  <mdejong@users.sourceforge.net>

	* changes: Document [wm transient .t .t] error.
	* tests/wm.test: Check that setting a window
	as a transient of itself raises an error. Check
	that passing a non-toplevel window to the wm
	transient command uses the enclosing toplevel.
	* unix/tkUnixWm.c (Tk_WmCmd): Raise an error
	if the user tries to make a toplevel a
	transient of itself.
	* win/tkWinWm.c (Tk_WmCmd): Raise an error
	if the user tries to make a toplevel a
	transient of itself. Test for other error
	before checking for the transient self error.

2002-05-27  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/tkUnixWm.c (WmInfo, TkWmCleanup, TkWmNewWindow,
	TkWmMapWindow, TkWmDeadWindow, Tk_WmCmd): Replace
	WmInfo's master and masterWindowName members with
	a masterPtr member. This implementation is much
	simpler and mirrors the Win32 implementation. This
	change makes it easy to check the flags of the
	master window. No user visible changes.

2002-05-27  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkInt.decls: Add unix decl for TkpWmSetState.
	* generic/tkIntPlatDecls.h: Regen.
	* generic/tkStubInit.c: Regen.
	* tests/wm.test: Test state changes between iconic,
	normal, and withdrawn both before and after initial
	mapping.
	* unix/tkUnixWm.c (Tk_WmCmd, TkpWmSetState): Move
	state change code into TkpWmSetState to more closely
	match the Win32 implementation. No user visible changes.

2002-05-27  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/embed.test: Added cross platform embed tests.
	Check that window passed to -use has the -container
	option set.
	* tests/wm.test: Remove useless catch call. Deiconify
	. just in case, stackorder tests will not pass unless
	it is in the normal state. Add -container flag to
	embedded stackorder test.
	* unix/tkUnixEmbed.c (TkpUseWindow):
	* win/tkWinEmbed.c (TkpUseWindow): Lookup Tk window
	based on the id passed in as the value for -use.
	Generate an error if the Tk window did not have
	the -container option set.

2002-05-26  Peter Spjuth <peter.spjuth@space.se>

	* generic/tkButton.c (ConfigureButton): When creating
	a radiobutton with -value "" it was not drawn properly
	if the -variable was created by the radiobutton.
	[Bug #548765]

2002-05-26  Peter Spjuth <peter.spjuth@space.se>

	* generic/tkCanvText.c (ComputeTextBbox): Negative
	coordinates were rounded badly causing a 1 pixel
	displacement. [Bug #556526]
	
2002-05-24  Mo DeJong  <mdejong@users.sourceforge.net>

	* mac/tkMacWm.c (Tk_WmCmd):
	* tests/unixWm.test: Move wm transient checks over
	to wm.test so they will be run on all systems.
	* tests/wm.test: Add tests to check for error when
	an iconwindow is passed to the wm transient command.
	* unix/tkUnixWm.c (Tk_WmCmd):
	* win/tkWinWm.c (Tk_WmCmd): Raise an error if one
	of the windows passed to the wm transient command
	is an iconwindow for another toplevel.

2002-05-23  Mo DeJong  <mdejong@users.sourceforge.net>

	* mac/tkMacWm.c (TkWmStackorderToplevelWrapperMap):
	* tests/wm.test: Add embedded Window test case for
	the stackorder command.
	* unix/tkUnixWm.c (TkWmStackorderToplevelWrapperMap):
	* win/tkWinWm.c (TkWmStackorderToplevelWrapperMap):
	Ignore embedded windows during wm stackorder command.

2002-05-21  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/configure.in: Invoke SC_ENABLE_SHARED before
	calling SC_CONFIG_CFLAGS so that the SHARED_BUILD
	variable can be checked inside SC_CONFIG_CFLAGS.
	* unix/tcl.m4: Update from Tcl.

2002-05-20  Don Porter  <dgp@users.sourceforge.net>

	* library/tk.tcl:  A little namespace cleanup on Daniel Steffen's
	latest revisions to avoid defining new global commands.

2002-05-20  Daniel Steffen  <das@users.sourceforge.net>

	* mac/tkMacInit.c:
	* mac/tkMacTclCode.r: include msgcat package in resources
	as bgerror depends on it. Restores ability of mac static
	build to run standalone (except for encoding file issues).

	* mac/tkMacInit.c:
	* library/console.tcl:
	* library/tk.tcl: fix tk.tcl not sourcing library files
	that define bindings at startup on mac. (independent of
	tk library files being in resources or on auto_path)

2002-05-08  Don Porter  <dgp@users.sourceforge.net>

	* library/bgerror.tcl:
	* library/tclIndex:  Cleaned up namespace usage of the bgerror
	dialog.  Completes soft dependence on msgcat.  [FR 539309]

2002-05-07  David Gravereaux  <davygrvy@pobox.com>
	* win/makefile.vc: Problem with TCLDIR macro not accepting
	forward slash path seperators resolved.  Added the same logic
	to INSTALLDIR, too. [Bug #553208]

2002-04-26  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure:
	* unix/tcl.m4: change HP-11 SHLIB_LD_LIBS from "" to ${LIBS} so
	that the .sl knows its dependent libs.

2002-04-24  Daniel Steffen  <das@users.sourceforge.net>

	* mac/tkMacTclCode.r:
	* mac/tkMacResource.r: added check of
	TCLTK_NO_LIBRARY_TEXT_RESOURCES #define to allow disabling the
	inclusion of the tk library code in the resource fork of Tk
	executables and shared libraries.
	Moved tk library code inclusion to separate file like in tcl.
	Added 'panedwindow' resource.

2002-04-22  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/button.tcl (ButtonLeave): corrected the 3
	implementations of ButtonLeave to check for Priv(relief) existing
	before trying to use it. [Patch #541849]

	* generic/tkTextDisp.c (DisplayLineBackground): 
	* unix/tkUnix3d.c (Tk_3DHorizontalBevel): 
	* unix/tkUnixFont.c (Tk_DrawChars): applied fixes to not overrun
	the X window 16-bit size limit. [Patch #541999] (bonfield)

2002-04-22  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkTextDisp.c (GetXView, GetYView): Comparison with
	previous values of scrollbar range are now done in a way that is
	sensitive to the bizarreness of floating-point on architectures
	where IEEE-FP is not used on the processor.  Also increased the
	size of the temporary buffer to take account of the fact that
	TCL_DOUBLE_SPACE is meant to only imply enough space to take a
	printed double and trailing '\0', and no more.  [Bug #223739]
	(FP_EQUAL_SCALE): New macro to help compare floating-point numbers
	for equality in a sane way, used in GetXView and GetYView.

2002-04-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkWindow.c (TkCloseDisplay): Added to centralize where a
	display was closed.  This handles freeing memory associated with a
	display and closing it.
	(DeleteWindowsExitProc): actually close displays.  This would also
	ideally be done in Tk_DestroyWindow when the last window on the
	display has been closed, but that still has unresolved order of
	cleanup problems.
	(Tk_DestroyWindow): added TkFocusFree call.

	* generic/tkStubInit.c:
	* generic/tkIntPlatDecls.h:
	* generic/tkIntDecls.h:
	* generic/tkInt.decls: added TkFocusFree, TkClipCleanup and
	TkGCCleanup generic private procs, and TkWmCleanup, TkSendCleanup
	and TkFreeXId unix private procs.

	* generic/tkInt.h:
	* unix/tkUnixXId.c (TkFreeXId): frees XID resources.
	Made idCleanupScheduled a Tcl_TimerToken (was int) in TkDisplay
	structure to allow us to delete the timer scheduled for it.

	* unix/tkUnixWm.c (TkWmStackorderToplevel): ensure children
	structure is freed.
	(ConfigureEvent, ComputeReparentGeometry): Add extra wm tracing info
	(TkWmRestackToplevel): initialize changes to 0 to prevent UMR.
	Use WaitForConfigureNotify on all windows.  This part still
	requires fixing as it is the root of the 2 second raise delay on
	some window managers (those that use extra wrapper windows of
	their own).

	* unix/tkUnixSend.c (TkSendCleanup): free send-related resources

	* unix/tkUnixEvent.c (TkpCloseDisplay): call TkSendCleanup and
	TkWmCleanup.

	* unix/tkUnixSelect.c (SelRcvIncrProc): added missing Tcl_Release
	of interp

	* generic/tkGet.c (FreeUidThreadExitProc): free thread-specific
	resources on thread exit

	* generic/tkFocus.c (TkFocusFree): frees TkMainInfo data
	* generic/tkClipboard.c (TkClipCleanup): frees TkDisplay data
	* generic/tkGC.c (TkGCCleanup): frees TkDisplay data

	* unix/tkUnixFont.c (FontPkgCleanup): cleanup thread specific font
	resources on thread exit.

	* mac/tkMacXStubs.c (TkpOpenDisplay): memset the initial display
	structures to 0.

	* generic/tkOption.c (OptionThreadExitProc): freed tsd option
	stacks on thread exit.
	(Tk_GetOption): free mem used to get Tk_Uid

	* generic/tkMenu.c (ConfigureMenu): freed saved options in all
	error cases.

	* win/tkWinInt.h: declaration for TkWinGetUnicodeEncoding
	* win/tkWinDialog.c (GetFileNameW): use TkWinGetUnicodeEncoding
	* win/tkWinInit.c (TkpDisplayWarning): use TkWinGetUnicodeEncoding
	* win/tkWinFont.c: use TkWinGetUnicodeEncoding instead of static
	unicodeEncoding.

	* win/tkWinX.c (Tk_SetCaretPos): remove WM_IME_STARTCOMPOSITION
	and place the IME position within Tk_SetCaretPos.  Cache results in
	Tk_SetCaretPos to reduce unnecessary repositioning.  Also call
	DestroyCaret if we receive WM_KILLFOCUS.
	(TkpOpenDisplay): ZeroMemory the initial display structures.
	(TkWinGetUnicodeEncoding): Added so that Windows only needs to
	cache this value one, and then free it in TkWinXCleanup.
	(HandleIMEComposition): add support for Win98 and ATOK13
	IME. (yamamoto)

	* generic/tkConsole.c (ConsoleCmd): correct return that should
	have just set result code.

	* generic/tkImgPhoto.c: Added PhotoFormatThreadExitProc to clean
	up on thread exit. (Tk_PhotoPutBlock) slight code updates

	* generic/tkPanedWindow.c (DestroyPanedWindow, ConfigureSlaves):
	fix mem leaks in not freeing slave info

	* win/configure:
	* win/tcl.m4: Enabled COFF as well as CV style debug info with
	--enable-symbols to allow Dr. Watson users to see function info.
	More info on debugging levels can be obtained at:
	http://msdn.microsoft.com/library/en-us/dnvc60/html/gendepdebug.asp

2002-04-10  Mo DeJong  <mdejong@users.sourceforge.net>

	* doc/wm.n:
	* mac/tkMacWm.c:
	* tests/wm.test:
	* unix/tkUnixWm.c:
	* win/tkWinWm.c: Update wm stackorder usage message
	to make it clear that either 1 or 3 arguments are
	required. [Bug 540013]

2002-04-08  Daniel Steffen  <das@users.sourceforge.net>

	* mac/tkMacProjects.sea.hqx: added tkPanedWindow.c to projects
	* mac/tkMacAppInit.c: fixes to MSL stdin/stdout hookup to the
	TkConsole when using shared MSL libraries; fix for crashing
	bug on exit: writing to stdin/sterr when console has already
	been destroyed. (both fixes need support in MSL, see 
	'CW Pro6 changes' in tcl/mac/tcltkMacBuildSupport.sea.hqx)
	* mac/tkMacDialog.c: fixes to Navigation Services Dialog filter.
	* mac/tkMacDraw.c: add panic for overwide TkImages that would
	crash Tk on mac otherwise.

2002-04-05  Jeff Hobbs  <jeffh@ActiveState.com>

	* mac/tkMacXStubs.c: added Tk_SetCaretPos stub (does nothing).
	* win/tkWinX.c: added Tk_SetCaretPos code to position IME windows
	correctly when WM_IME_STARTCOMPOSITION is received.
	* unix/tkUnixKey.c: added Tk_SetCaretPos and code for setting
	XIM caret in TkpGetString.

	* generic/tkStubInit.c:
	* generic/tkDecls.h:
	* generic/tk.decls: added Tk_SetCaretPos declaration.  This command
	allows users to indicate the cursor position and is used by XIM
	(Unix) or IME (Windows) to place the caret box correctly.  It is
	also part of correct Accessibility style on Windows to make the
	magnifier jump to the focus point.

	* win/tkWinButton.c (TkpDisplayButton): 
	* generic/tkTextMark.c (TkTextInsertDisplayProc):
	* generic/tkCanvText.c (DisplayCanvText):
	* generic/tkEntry.c (DisplayEntry): added Tk_SetCaretPos calls

	* generic/tkInt.h: added TK_XIM_SPOT #define (default 1).
	Added XFontSet attribute to TkDisplay when TK_XIM_SPOT is true.
	* generic/tkEvent.c (Tk_HandleEvent): made sure inputContexts are
	not getting created on DestroyNotify events (for dead windows).
	Added over-the-spot support if TK_XIM_SPOT is defined (default).
	The is the nicer XIM behavior, but uses a bit more memory.

	* unix/tkUnixEvent.c:
	* generic/tkWindow.c: moved OpenIM over to tkUnixEvent.c.
	Removed setting inputContext to null in Tk_MakeWindowExist as it
	was redundant.

	* unix/tkUnixWm.c (CreateWrapper): Removed redundat setting of
	inputContext to null.

	* win/Makefile.in: changed gdb and shell targets to properly build
	all binaries before running (otherwise an error often occured).

2002-03-28  David Gravereaux <davygrvy@pobox.com>

	* win/.cvsignore (new):
	* win/lamp.bmp (new):
	* win/makefile.vc:
	* win/nmakehlp.c (new):
	* win/rules.vc:  Brought the makefile up-to-date with Tcl's one.
	This now has support for Win9x issues and the winhelp target now
	exists.  Color scheme can be changed.  I'm just imparting a first
	suggestion using orange :)  I'll have to think about the install
	portion of the helpfile as I'll need to do some tricks to insert
	tk's contents file into Tcl's using some special winhlp32.exe
	switches.  [Bug 533862 527941]

	* win/makefile.vc:  Tk helpfile is now installing itself into Tcl's
	contents file as part of the install target and rebuilding the
	contents table as desired.  [Bug 527941]

	* doc/console.n:  Changed topic from "Tcl Built-In Commands" to
	"Tk Built-In Commands"

	* win/buildall.vc.bat:  Update to match Tcl.

2002-03-26  Andreas Kupries  <andreask_kupries@users.sourceforge.net>

	* unix/tkUnixFont.c: Added inclusion of <arpa/inet.h>. This fixes
	  a GCC/HPUX problem with missing a "htons". See also
	  "tclUnixPort.h" for equivalent code.

2002-03-21  David Gravereaux <davygrvy@pobox.com>

	* win/makefile.vc: Changed optimize flag to -0ti instead of -02.
	[Bug 528441]

2002-03-20  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkButton.c (ButtonTextVarProc,ButtonVarProc): 
	* generic/tkCmds.c (WaitVariableProc):
	* generic/tkEntry.c (EntryTextVarProc):
	* generic/tkListbox.c (ListboxListVarProc):
	* generic/tkMenu.c (MenuVarProc):
	* generic/tkMenubutton.c (MenuButtonTextVarProc): 
	* generic/tkMessage.c (MessageTextVarProc): 
	* generic/tkScale.c (ScaleVarProc): Updates to handle change in
	type of part2 argument of Tcl_VarTraceProc typedef. [TIP 27]
	[Patch 532644].

2002-03-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkOldConfig.c (Tk_ConfigureValue): prevent leaving
	interp->result as NULL.

2002-03-07  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/text.tcl (TextPasteSelection): Renaming of TextPaste to
	prevent confusion with tk_textPaste.  Stopped code from inserting
	selections twice, which seems to have happened with TIP#26, and
	reorganized code to reduce amount of stuff protected by catch
	which is tricky to maintain.
	(tk_textPaste): Reduce amount of code protected by catch.

2002-03-06  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinX.c: Define _WIN32_IE as 0x0300
	before including commctrl.h so that we can
	access the InitCommonControlsEx API when
	building Tk with mingw.

2002-03-06  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* README, generic/tk.h, unix/configure.in, unix/tk.spec:
	* win/configure.in: Bumped patchlevel; this might need to change
	in the future, but it will help us distinguish between the CVS
	version and the most recent released version.

2002-03-05  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4a4 TAGGED FOR RELEASE ***

	* unix/README: updated --* options docs.

	* unix/tk.spec: fixed URL refs to use www.tcl.tk or SF.

2002-03-04  Jeff Hobbs  <jeffh@ActiveState.com>

	* README: 
	* mac/README: 
	* unix/README: 
	* win/README: updated to use www.tcl.tk URL.

2002-03-03  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/entry.tcl: added catch around Triple-1 binding use of
	sel.last

2002-02-28  Don Porter  <dgp@users.sourceforge.net>

	* library/console.tcl (ConsoleBind): Corrected console <<Paste>>
	binding on Unix platforms.

2002-02-26  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.

	* generic/tkWindow.c (Tk_MainWindow, Tk_GetNumMainWindows):
	protect against being called before Tcl stubs are init'ed.
	[Bug #220916] (porter)

2002-02-25  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkText.c (ConfigureText): reenable the blinking cursor
	on state change where necessary. [Bug #503772]

	* tests/listbox.test:
	* generic/tkListbox.c: corrected error handling when setting to an
	invalid listvar value. [Bug #503613]

	* library/scale.tcl: mirror B2 bindings to B3 on Windows to better
	accomodate two button mice. [Patch #493145]

	* library/panedwindow.tcl: improved proxy sash handling. (boudaillier)

2002-02-25  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/filebox.test: Reorganised and fixed so that tests are
	executed fewer times (!) and the automatic extension adding
	behaviour of tk_getSaveFile is tested.

2002-02-23  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.

2002-02-22  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkPanedWindow.c (PanedWindowWidgetObjCmd): fixed returns
	that should have been breaks instead.  Corrected .pw configure
	handling for insufficient args.  [Patch #521436] (boudaillier)

	* mac/tkMacDefault.h:
	* unix/tkUnixDefault.h:
	* win/tkWinDefault.h: changed panedwindow default relief to flat,
	a more natural outer relief.

	* library/panedwindow.tcl (ReleaseSash): changed to not pass x and
	y args at all (they aren't used).
	Added proc comments.  Made configuring sash cursor more efficient.
	Added Cursor timer that restores the default cursor when pointer
	is no longer over the sash.  This is necessary because Leave
	events won't be seen when moving into a paned child.

2002-02-22  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/demos/widget: New section "Paned Windows"
	* library/demos/paned2.tcl, library/demos/paned1.tcl: New files.

	* library/panedwindow.tcl (ReleaseSash): Added missing arguments.
	* library/tk.tcl: Bindings for paned window were not being loaded
	by default.

	* unix/tkUnixMenu.c (GetMenuLabelGeometry,DrawMenuEntryLabel):
	Stop meaningless GCC warnings.

2002-02-21  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/panedwindow.n (new):
	* generic/tkPanedWindow.c (new):
	* generic/tkInt.h:
	* generic/tkWindow.c:
	* library/panedwindow.tcl (new):
	* mac/tkMacDefault.h:
	* tests/panedwindow.test (new):
	* unix/Makefile.in:
	* unix/tkUnixDefault.h:
	* win/Makefile.in:
	* win/makefile.vc:
	* win/tkWinDefault.h: added implementation of TIP #41, panedwindow
	widget. [Patch #512503] (melski)

	* generic/tkOption.c (ReadOptionFile): fixed Tcl_Seek casting to
	remove warnings (we expect no option files with be > 2GB).

	* unix/configure: regenerated
	* unix/tcl.m4: updated to sync with Tcl's tcl.m4
	Added --enable-64bit support for AIX-4 using IBM's xlc (-q64 flag).

2002-02-19  Don Porter  <dgp@users.sourceforge.net>

	* changes: First draft of updated changes for 8.4a4 release.

2002-02-19  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkImgPhoto.c (MatchFileFormat):  Tcl_Seek takes
	Tcl_WideInt offset (three places.)
